/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2010 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Suphi Basdemir <suphi.basdemir@open-xchange.com>
 * 
 */

/**
 * Search for Contacts in different Addressbooks
 * makes a liveGrid for Searchresult, an append the selected to a LiveGrid or
 * in a Input field
 * @param {String} searchstring for pattern in the database
 * @param {String} Id of the main search dialog div
 * @param {String} Id of the div for the Livegrid, in the search dialog
 * @param {String} optional: for appending the Contacts in a LiveGrid of the page
 * @param {String} Id from div, for the selected Contacts in the search dialog
 * @param {String} Id from div, for clearing the search string in the search dialog
 * @param {Array} optional: if suffix of each Inputfield (example: 'to' and 'cc' for newmail_btn_add_to, newmail_btn_add_cc)
 * 
 * the DOM Event as parameter.
 */

function SearchListAddressBook(searchstring, floatingpopupdiv, liveGridDivSearch, liveGridDivResult, divAddContact, searchField, moreFields)
{
	var Self = this;
	this.emptySearchText = _("Please enter your search");
	this.searchField = searchField;
	this.blurTimer;
	addressbookFolderPath();
	this.divAddContact = divAddContact;
	this.liveGridDivResult = liveGridDivResult;
	this.liveGridDivSearch = liveGridDivSearch;
	this.floatingpopupdiv = floatingpopupdiv;
	this.searchstring = searchstring;
	this.resulObject = {};
	this.arrayWhithDistrContact = new Array();
	this.numberOfSelection = 0;
	this.findContactForDistrList = null;
	this.buildContactForDistrList = new Array();
	this.tmpIdsForSave = new Array();
	this.contactsForBigGrid = {};
	this.tmpCountAppendet = 0;
	this.tmpCountSearchAppendet = 0;
	this.contactsForBigGrid.data = new Array();
	this.internalStorage = new Storage(0, []);
	this.internalResultStorage = new Storage(0, []);
	//this.internalResultStorage = new Storage(0, [], "", 0, 0,  null, function(x){ return x[0] + "." + x[1];});
	this.setAdding = "";
	this.distrids = new Array();
	this.myAddedContacts = new AddedSearchContacts();
	this.updateList = false;
	this.tmpDistId = 210000000;
	this.moreFields = new Array();
	
	if(moreFields)
	this.moreFields = moreFields;
	this.method = "";
	this.aFindedAddressboks = new Array();
	this.recipientType = "to";	
	$(this.searchField).value = this.emptySearchText;
	this.enabled = false;
	
    Self.clickOnCombobox = function (e) {
    	if (Self.blurTimer != undefined) {
            clearTimeout(Self.blurTimer);
            delete(Self.blurTimer);
        }
        if ($(searchField).value == Self.emptySearchText) {
            $(searchField).value="";
            $(Self.searchField).style.color="";
        } else if (e.keyCode == 13) {
            Self.searchstring = $(searchField).value;            
            Self.getResult();
            //$(liveGridDivResult).focus();
        }
    };
    Self.enterInput = function(e) {
    	Self.blurTimer = setTimeout(function() {
	        if (trimStr($(searchField).value).length == 0) {
	            $(searchField).value=Self.emptySearchText;
	            $(Self.searchField).style.color="silver";
	        }
        }, 100);
    }; 
    
    addDOMEvent($(this.searchField), "keypress", Self.clickOnCombobox); 
    addDOMEvent($(this.searchField), "click", Self.clickOnCombobox);
    addDOMEvent($(this.searchField), "blur", Self.enterInput); 
	
	register("searchContacts", function(){ if(Self.enabled) Self.getResult(); });
}

SearchListAddressBook.prototype = {

    setAllFolders: function(checkbox, folder_button) {
        if (configGetKey("modules.contacts.singleFolderSearch")) return;
        var setDisabled = classNameSetter("font-color-disabled");
        checkbox.parentNode.parentNode.parentNode.style.display = "";
        checkbox.checked = true;
        setDisabled(folder_button, true);
        checkbox.onclick = function() {
            setDisabled(folder_button, checkbox.checked);
        };
        this.allFoldersCheckbox = checkbox;
    },

	displayError: function(msg) {
        $(this.floatingpopupdiv+"SearchError").style.display="";
        $(this.floatingpopupdiv+"SearchError").getElementsByTagName("DIV")[0].firstChild.data=msg;
    },
	getResult: function() {	        
		var Self = this;
        this.searchstring="";
        var inVal=$(this.searchField).value;
        if (trimStr(inVal).length == 0 ||
            inVal == this.emptySearchText) {
            $(this.searchField).value=this.emptySearchText;
            setTimeout(function() {
                $(Self.searchField).style.color="silver";
            },0);
            if (configContainsKey("modules.contacts.mailAddressAutoSearch") &&
                configGetKey("modules.contacts.mailAddressAutoSearch") == false) {
            	this.searchstring = "";
                if(this.enabled) this.resetGrid();
                return;	
            } else if (configContainsKey("minimumSearchCharacters") &&
                configGetKey("minimumSearchCharacters") != 0) {
                this.displayError(
                   //#. %s is the number of characters.
                   //#, c-format
                   format(_("The search pattern requires at least %s characters."), 
                       configGetKey("minimumSearchCharacters")));
                return;
            } else {
            	this.searchstring="";
            }
        } else if (configContainsKey("minimumSearchCharacters") &&
            trimStr(inVal).length < configGetKey("minimumSearchCharacters")) {
            this.displayError(
                //#. %s is the number of characters.
                //#, c-format
                format(_("The search pattern requires at least %s characters."), 
                    configGetKey("minimumSearchCharacters")));
            return;
        } else {
    	   $(Self.searchField).style.color="";
    	   this.searchstring=inVal;
        }
		var pattern = trimStr(this.searchstring) ? this.searchstring : "*";
        this.searchObject = {
            display_name: pattern, first_name: pattern, last_name: pattern,
            email1: pattern, email2: pattern, email3: pattern, orSearch: true
        };
        if (!this.allFoldersCheckbox || !this.allFoldersCheckbox.checked) { 
            this.searchObject.folder = clickedItem;
        }
		
		if(!json)
		var json = new JSON();
		this.distrids = [];
		json.put(AjaxRoot + "/contacts?action=search&session=" + corewindow.session + "&columns=1,500,555,556,557,524,602,592,501,502",
			Self.searchObject,
			null,
			function(findContactForDistrList) {	
				/*
		         * 0 = id               (1)
		         * 1 = display_name     (500)
				 * 2 = email1           (555)
				 * 3 = email2           (556)
				 * 4 = email3           (557)
				 * 5 = internal_userid  (524)
				 * 6 = mark_as_distri.  (602)
				 * 7 = distribution_l.  (592)
				 * 8 = first name
				 * 9 = last name
				 */
				
				/* click on "Go" for search in the Addressbook */
				Self.findContactForDistrList = findContactForDistrList;
				Self.findContactForDistrList.events = new Events();	
				Self.buildContactForDistrList = [];
				var tmpLaufIndex = Self.findContactForDistrList.data.length;
				for(i=0; i<tmpLaufIndex; i++) {	
					(function() {
						if(Self.findContactForDistrList.data[i][6]) {
							/* the finded "contact" is a distribution list */
							if((Self.method && Self.method == "mail") || (Self.moreFields && Self.moreFields.length > 0)) {
								var tmpDistArray = new Array();
								tmpDistArray[0] = Self.findContactForDistrList.data[i][0];
								tmpDistArray[1] = Self.findContactForDistrList.data[i][1];
								tmpDistArray[2] = "";
								tmpDistArray[3] = "true";
								var tmpString = "";
								if(Self.findContactForDistrList.data[i][7]) {
									for(var t=0; t<Self.findContactForDistrList.data[i][7].length;t++) {
										if(t==0) {
											tmpString = Self.findContactForDistrList.data[i][7][t].mail;
										} else {
											tmpString += ", "+Self.findContactForDistrList.data[i][7][t].mail;
										}
									}
									tmpDistArray[4] = tmpString;
									Self.buildContactForDistrList.push(tmpDistArray);
									Self.myAddedContacts.setAllFinded(
													tmpDistArray[0],
													tmpDistArray[4]
										);	
								}
							}
						} else {
							/* the flag in [index 6] is false, so this contact is not a distribution list  */
							var displayName = "";
							if (Self.findContactForDistrList.data[i][1]) {
								displayName = Self.findContactForDistrList.data[i][1];
							} else if (Self.findContactForDistrList.data[i][8] || Self.findContactForDistrList.data[i][9]) {
								displayName = (Self.findContactForDistrList.data[i][9] || "") + ", " 
									+ (Self.findContactForDistrList.data[i][8] || "");
							}
							
                            var findEmails = 0;
							if(Self.findContactForDistrList.data[i][2]) {
								var tmpDistArray = new Array();
								tmpDistArray[0] = Self.findContactForDistrList.data[i][0];
								tmpDistArray[1] = displayName;
								tmpDistArray[2] = Self.findContactForDistrList.data[i][2];
								Self.buildContactForDistrList.push(tmpDistArray);
								findEmails = 1;		
								Self.distrids.push(tmpDistArray[0]);
								Self.myAddedContacts.setAllFinded(tmpDistArray[0], tmpDistArray[2]);				
							}
							
							if(Self.findContactForDistrList.data[i][3]) {
								var tmpDistArray = new Array();
								tmpDistArray[1] = displayName;
								tmpDistArray[2] = Self.findContactForDistrList.data[i][3];
								
								Self.buildContactForDistrList.push(tmpDistArray);
								if(findEmails == 0) {
									tmpDistArray[0] = Self.findContactForDistrList.data[i][0];
								} else {
									tmpDistArray[0] = Self.tmpDistId;
									Self.findContactForDistrList.data.push(tmpDistArray);
									Self.tmpDistId++;
								}
								findEmails = 1;		
								
								Self.distrids.push(tmpDistArray[0]);
								Self.myAddedContacts.setAllFinded(tmpDistArray[0], tmpDistArray[2]);					
							}
							
							if(Self.findContactForDistrList.data[i][4]) {
								var tmpDistArray = new Array();
								tmpDistArray[1] = displayName;
								tmpDistArray[2] = Self.findContactForDistrList.data[i][4];
								if(findEmails == 0) {
									tmpDistArray[0] = Self.findContactForDistrList.data[i][0];
								} else {
									tmpDistArray[0] = Self.tmpDistId;
									Self.findContactForDistrList.data.push(tmpDistArray);
									Self.tmpDistId++;
								}
								
								Self.distrids.push(tmpDistArray[0]);
								Self.buildContactForDistrList.push(tmpDistArray);
								findEmails = 1;		
								
								Self.myAddedContacts.setAllFinded(tmpDistArray[0], tmpDistArray[2]);					
							}
						}
					})();
				}
				Self.internalStorage.remove(0,Self.tmpCountSearchAppendet);
				Self.internalStorage.append(Self.buildContactForDistrList);	
				Self.aFindedAddressboks.push(Self.buildContactForDistrList);
				/* 
				 * Self.buildContactForDistrList 
				 * is an array with Object with the ids and tmpIds
				 * all finded valid Contact are inside 
				 * */
				distruGrid.enable(Self.internalStorage); 
				Self.tmpCountSearchAppendet = Self.buildContactForDistrList.length;
			}
		);
	},
	
	/*
	 * result view for Modules with Livegrid
	 */   	
	showResult: function(insertDistribution) {		
		this.insertDistribution = insertDistribution;
		
		if (this.insertDistribution == "extern" && myDistrListExternEmails.storage.ids.length != 0) { //external email
		  	for (i = 0; i < myDistrListExternEmails.storage.ids.length; i++) {		  		
		  		var extObj = myDistrListExternEmails.storage.data.data[i];
		  		if (!this.myAddedContacts.exist(extObj.displayName + extObj.email)) {
		  			this.contactsForBigGrid.data[this.contactsForBigGrid.data.length] = [ this.tmpDistId++, extObj.displayName, extObj.email ] ;
		  			this.myAddedContacts.set(extObj.displayName + extObj.email, true);
                    this.updateList = true;
		  		}
		  	}
		
		} else if (this.insertDistribution == "db") {
			if(this.findContactForDistrList) { //internal email
			    /* this is the function after clicking to "Ok" in the bottom, to accept the selected data or contacts */
					for(i=0; i< this.findContactForDistrList.data.length; i++){
						for(j=0; j< this.tmpIdsForSave.length; j++) {
							if(this.tmpIdsForSave[j] == this.findContactForDistrList.data[i][0]) {
								
								if(this.findContactForDistrList.data[i][0] == 0 || typeof this.findContactForDistrList.data[i][0] == "undefined") {
									this.findContactForDistrList.data[i][0] = this.tmpDistId;
									this.tmpDistId++;
								}
								if(!this.myAddedContacts.exist(this.findContactForDistrList.data[i][2]+this.findContactForDistrList.data[i][3])) {
									this.contactsForBigGrid.data[this.contactsForBigGrid.data.length] = 
																			this.findContactForDistrList.data[i];
									
				
									this.myAddedContacts.set(
										this.findContactForDistrList.data[i][2]+this.findContactForDistrList.data[i][3],
										true
									);										
								}						
							}			
						}
					}
					
					this.tmpIdsForSave = [];
				}
			} else {
				if(this.aFindedAddressboks) { //internal email
			    /* this is the function after clicking to "Ok" in the bottom, to accept the selected data or contacts */
					for(i=0; i< this.aFindedAddressboks.length; i++){
						/* through each addressbook from the search result  */
						for(k=0; k< this.aFindedAddressboks[i].length; k++){
							/* the arrays in the addressbook (index 0 = id, index 1 = display name, index 2 = mail address)  */
							for(j=0; j< this.tmpIdsForSave.length; j++) {
								if(this.tmpIdsForSave[j] == this.aFindedAddressboks[i][k][0]) {
									
									if(this.aFindedAddressboks[i][k][0] == 0 || typeof this.aFindedAddressboks[i][k][0] == "undefined") {
										this.aFindedAddressboks[i][k][0] = this.tmpDistId;
										this.tmpDistId++;
									}
									if(!this.myAddedContacts.exist(this.aFindedAddressboks[i][k][1]+this.aFindedAddressboks[i][k][2])) {
										this.contactsForBigGrid.data[this.contactsForBigGrid.data.length] = 
																				this.aFindedAddressboks[i][k];
										
										this.myAddedContacts.set(
													this.aFindedAddressboks[i][k][1]+this.aFindedAddressboks[i][k][2],
													true
										);										
									}						
								}			
							}
						}
					}
					
					this.tmpIdsForSave = [];
				}
			}
			
			
			var Self = this;
			Self.internalResultStorage.remove(0,Self.tmpCountAppendet);
			Self.internalResultStorage.append(Self.contactsForBigGrid.data);
			
			if(Self.internalResultStorage.ids.length > 0)
			distruBigGrid.enable(Self.internalResultStorage);
			
			
			/*if(this.arrayWhithDistrContact.length != 0) {
				distruBigGrid.enable(this.internalResultStorage);
				
			} else {
				//distruBigGrid.disable();
			}*/
			this.tmpCountAppendet = this.contactsForBigGrid.data.length;
	},
	
	showResultInInput: function(insertDistribution) {	
		/*
		 * result view for Mail Module
		 * */
		if(this.moreFields && this.moreFields.length > 0) {
			var valueToInputArray = new Array();
			for (var i = 0; i < this.moreFields.length; i++) {
				valueToInputArray[i] = $(this.divAddContact + "_" + this.moreFields[i]).value;
				if (!valueToInputArray[i] || valueToInputArray[i].length == 0) continue;
				$(this.moreFields[i]).value += this.setSemicolon(valueToInputArray[i], this.moreFields[i]);
				oMailFunctionsNew.showAdditionalHeaderField(this.moreFields[i], true);
			}
		} else {
			var valueToInput = $(this.divAddContact).value;
			if(valueToInput != '') {
				$(this.recipientAs).value += this.setSemicolon(valueToInput, this.recipientAs);
			}
		}		
		this.closeDiv();	
	},
	
	setSemicolon: function(value, divRecipientId) {
		if(value == "") return "";
		var valueToInput = value;
		var valueInitToInput = $(divRecipientId).value;
		var indexOfSemicolon = valueInitToInput.lastIndexOf(',');
		var lengthOfString = valueInitToInput.length - 2;
		if(valueInitToInput != '' && indexOfSemicolon == (lengthOfString + 1 )) {
			//the last char is a semicolon, whitout space
			valueToInput = " " + valueToInput;
		} else if(valueInitToInput != '' && indexOfSemicolon < lengthOfString) {
			//the last char is not a semicolon
			valueToInput = ", " + valueToInput;			
		} else {
			//input field is empty
		}
		return valueToInput;
	}, 
	
	addToList: function(setAdding, fieldSuffix){
		this.setAdding = setAdding;
				
		//mySelectedDistrContacts = 3405.name, 3333.name
		if(distruGrid.storage) {			
			var mySelectedDistrContacts = distruGrid.selection.getSelected();
			if((mySelectedDistrContacts.length > 0 && this.setAdding == "bySelection") || this.setAdding == "all") {	
				var myTmpArray = new Array();
				if(this.setAdding == "bySelection") {
					mySelectedDistrContacts = mySelectedDistrContacts.toString();
					myTmpArray = mySelectedDistrContacts.split(",");	
				} else {
					myTmpArray = distruGrid.storage.ids;
				}				
				
				for(i=0; i<myTmpArray.length;i++) {
					if(myTmpArray[i] in this.arrayWhithDistrContact) {
						//alert("already in list");
					} else {							
						this.updateList = true;
						this.arrayWhithDistrContact[myTmpArray[i]] = this.myAddedContacts.getFromAll(myTmpArray[i]);
					}	
				}
				
				if(fieldSuffix) {
					var tmpArrayWhithNames = $(this.divAddContact + '_' + fieldSuffix).value;
					this.recipientType = fieldSuffix;
				} else {
					var tmpArrayWhithNames = "";
				}
				for(i in this.arrayWhithDistrContact) {
					if(tmpArrayWhithNames == "") {
						tmpArrayWhithNames = this.arrayWhithDistrContact[i];
					}
					else {
						tmpArrayWhithNames += ", " + this.arrayWhithDistrContact[i];
					}
					this.tmpIdsForSave[this.tmpIdsForSave.length] = i;
				}
				if(fieldSuffix) {
					$(this.divAddContact + '_' + fieldSuffix).value = tmpArrayWhithNames;
					this.arrayWhithDistrContact = [];
				} else {
					$(this.divAddContact).value = tmpArrayWhithNames;
				}
				
				
			} else {
				newConfirm(_("Select a contact"),_("Please select a contact to add"),AlertPopup.OK,null,null,null,null);		
			} 
		} /* else {
			triggerEvent("OX_New_Error", 4, "Please search to add Contact");
		}*/
	},
	deleteSelected: function(callbak) {	
		var mySelectedDistrContacts = distruBigGrid.selection.getSelected(distruBigGrid.storage);
		for (i=0; i< mySelectedDistrContacts.length; i++) {
			for(t=0; t< this.contactsForBigGrid.data.length; t++) {
				if(this.contactsForBigGrid.data[t][0] == mySelectedDistrContacts[i]) {
					var hashKey = this.contactsForBigGrid.data[t][1]+this.contactsForBigGrid.data[t][2];
					for(value in this.myAddedContacts.addContacts) {
						if(value == hashKey)
							this.myAddedContacts.addContacts[value] = false;
					}
					this.contactsForBigGrid.data.splice(t,1);	
					this.updateList = true;		
				}
			}
		}	
		if(callbak) callbak();
		//distruBigGrid.deleteSelected();	
	},
	clearList: function(){
		this.arrayWhithDistrContact = [];	
		this.tmpIdsForSave = [];
		if(this.moreFields && this.moreFields.length > 0) {
			for(var i = 0; i < this.moreFields.length; i++) {
				$(this.divAddContact + "_" + this.moreFields[i]).value = "";
			}
		} else {
			$(this.divAddContact).value = "";
		}
	},
	resetView: function() {
		this.clearList();
		this.tmpIdsForSave = [];
		if(distruGrid.storage) {
			distruGrid.storage.remove(0,this.tmpCountSearchAppendet);
		}
		//$(this.searchField).value = "";
	},
	resetGrid: function() {		
        if(distruGrid && distruGrid.storage) {
        	distruGrid.disable();        	
            this.internalStorage = new Storage(0, []);            
            this.makeGrid();
        }
	},	
	makeGrid: function() {
		var list = $(this.liveGridDivSearch);
		var listHeader = $(this.liveGridDivSearch + "Header");
		if (distruGrid) 
		{
			removeChildNodes(listHeader);
			list.innerHTML = "";
			distruGrid = null;
		}
		
		distruGrid = new LiveGrid([
			{
				text: "&#xa0;",
				sortable: true,
				width: "20px",
				style: {padding: 0},
				set: function(div,text) {
					var divIcons = "";
					if (div) {
						if (text) {
							divIcons = "<img src='"+getFullImgSrc("img/menu/distributionlist.gif")+"' alt='Distribution List' />"; 
						} else {
							divIcons = "<img src='"+getFullImgSrc("img/folder/contacts.gif")+"' alt='Contact' />"; 
						}
						
					}
						div.innerHTML = divIcons;
				},
				clear: LiveGrid.makeClear("..."),
				index:3
			},{	
				text: _("Name"),
				sortable: true,
				width: "40%",
				set: LiveGrid.defaultSet,
				clear: LiveGrid.makeClear("..."),
				index:1
			}, {
				text: _("E-Mail"),
				/* sortable: true, */
				set: LiveGrid.defaultSet,
				clear: LiveGrid.makeClear("..."),
				index:2
			}
		], new Selection());
		listHeader.appendChild(distruGrid.getHeader());
		distruGrid.getTable(list);
		
		var Self = this;
		distruGrid.events.register("Activated", 
			function(ids){
				if(Self.moreFields && Self.moreFields.length > 0)
					Self.addToList('bySelection', Self.recipientType);		
				else
					Self.addToList('bySelection');				
			}
		);	
	},
	makeBigGrid: function() {
		var list = $(this.liveGridDivResult);
		var listHeader = $(this.liveGridDivResult + "Header");
		if (distruBigGrid) 
		{
			list.innerHTML = "";
			distruBigGrid = null;
		}
		
		distruBigGrid = new LiveGrid([
			{	
				text: _("Name"),
				sortable: true,
				width: "50%",
				set: LiveGrid.defaultSet,
				clear: LiveGrid.makeClear("..."),
				index:1
			}, {
				text: _("E-Mail"),
				sortable: true,
				set: LiveGrid.defaultSet,
				clear: LiveGrid.makeClear("..."),
				index:2
			}
		], new Selection());
		
		distruBigGrid.emptylivegridtext = "No recipients have been added";/*i18n*/
		
		listHeader.appendChild(distruBigGrid.getHeader());
		distruBigGrid.getTable(list);
		
		
		distruBigGrid.events.register("Selected", 
			function(ids){
				triggerEvent("SubSelected",distruBigGrid.getSelectedIDs().length);				
			}
		);		
			
	},
	
	buildFloatingDiv: function(style) {
		this.enabled = true;
		$(this.floatingpopupdiv).style.display = style;
		this.makeGrid();
		
		//clear values
		this.arrayWhithDistrContact = [];
		if(this.moreFields && this.moreFields.length > 0) {
			for(var i = 0; i < this.moreFields.length; i++) {
				$(this.divAddContact + "_" + this.moreFields[i]).value = "";
			}
		} else {
			$(this.divAddContact).value = "";
		} 		
	},
	
	closeDiv: function() {
		this.disableActiveGrids();
		$(this.floatingpopupdiv).style.display = 'none';
	},
	
	disableActiveGrids : function() {		
		if(distruGrid && distruGrid.storage) {
			distruGrid.storage.remove(0,this.tmpCountSearchAppendet);
			window.setTimeout(function() {
					distruGrid.disable();
			}, 0);
		}
	}
};


function AddedSearchContacts() {
	this.addContacts = new Array();
	this.allFindedContacts = new Array();
}

AddedSearchContacts.prototype = {
	
	set : function(key,value) {
		this.addContacts[key] = value;
	},
	
	setAllFinded : function(key,value) {
		this.allFindedContacts[key] = value;
	},
	
	getFromAll : function(key) {
		var myItem = this.allFindedContacts[key];
		return (myItem) ? myItem : false;
	},
	
	exist: function(key) {
		var tmpItem = this.addContacts[key];
		return (tmpItem) ? true : false;
	}
	
};

var contactAddressbookTreeLoaded = false;
var treeAddressbookVisible = false;
var newAddressbookFolderTree = null;
var clickedItem = "";
var currentDivIdForAddressbook = "";

function addressbookFolderPath() {
    corewindow.oMainFolderTree.checkGAL(function(GAL) {
        clickedItem = GAL ? 6 : corewindow.configGetKey("folder.contacts");
    });
	session = corewindow.session;
	var folderViewSettingsNewContact = new Object();
	var folderViewSettingsNewContactById = new Object();
	//Disable Email... 
	folderViewSettingsNewContactById["default"] = 4;
	folderViewSettingsNewContact["contacts"] = 8;
	folderViewSettingsNewContact["calendar"] = 4;
	folderViewSettingsNewContact["tasks"] = 4;
	folderViewSettingsNewContact["infostore"] = 4;
	if(corewindow || window.parent)
		var oLocalState = corewindow.optFolderState.getState('folderAddressbook_tree_info');
	else
		var oLocalState = new Object();	
	if(!contactAddressbookTreeLoaded){
	/*		
			var LocalFolderCache = new ox_folder_cache();
			LocalFolderCache.folders = corewindow.oMainFolderTree.cache.folders;		
			LocalFolderCache.fast_access = corewindow.oMainFolderTree.cache.fast_access;		
			LocalFolderCache.timestamp = corewindow.oMainFolderTree.cache.timestamp;
*/
			newAddressbookFolderTree = new cFolderTree(	$('folderAddressbook_tree_info'),
									folderAction,
									false,	
									corewindow.oMainFolderTree.cache,								
									oLocalState);
			newAddressbookFolderTree.enabled_modules = {contacts:true};	
			newAddressbookFolderTree.load();
			
			contactAddressbookTreeLoaded = true;
	}
								
	if(corewindow || window.parent)									
		newAddressbookFolderTree.setSaveConfiguration(corewindow.optFolderState);		


	newAddressbookFolderTree.cache.get_folder(clickedItem, cb_AddressbookGetpath);
}
	

function cb_AddressbookGetpath(sPath)
{
	/*
	var tmpSlash = sPath.substr(sPath.length-1);
	
	if(tmpSlash == "/")
		sPath = sPath.substr(0, sPath.length-1);
	
	var tmpIndex = sPath.lastIndexOf("/") + 1;
	var finalFolderName = sPath.substr(tmpIndex);
	*/
	var vb = document.getElementsByName('newcontact_folder')[0].value = sPath.oxfolder.data.title;
}

function folderAction(ofolder) {
	hideAddressbookTree(currentDivIdForAddressbook);
	clickedItem = ofolder.oxfolder.data.id;
	newAddressbookFolderTree.cache.get_folder(clickedItem, cb_AddressbookGetpath);
    triggerEvent('searchContacts');
}

/*
function showAddressbookTree(divId){
	$(divId).style.display = "block";
	if(!contactAddressbookTreeLoaded){
		newAddressbookFolderTree.load();
		contactAddressbookTreeLoaded = true;
	}
}
*/

function hideAddressbookTree(divId){
	$(divId).style.display = "none";	
	treeAddressbookVisible = false;
}

function toggleAddressbookTree(divId){
	currentDivIdForAddressbook = divId;
	if(!treeAddressbookVisible){
		$(divId).style.display = "block";
		treeAddressbookVisible = true;
	}
	else{
		$(divId).style.display = "none";
		treeAddressbookVisible = false;
	}
}
var init = 
{"images":{"d88e110":"themes/default/img/dummy.gif","d88e159":"themes/default/img/contacts/dummypicture_add.gif","d88e168":"themes/default/img/arrows/arrow_darkgrey_left.gif","d88e175":"themes/default/img/arrows/arrow_darkgrey_right.gif","mini_calender_birthday_img":"themes/default/img/calendar/datepicker.gif","mini_calender_add_appointment_img":"themes/default/img/menu/add_appointment_d.gif","d88e226":"themes/default/img/arrows/arrow_darkgrey_left.gif","d88e233":"themes/default/img/arrows/arrow_darkgrey_right.gif","mini_calender_anniversary_img":"themes/default/img/calendar/datepicker.gif","d88e277":"themes/default/img/dummy.gif","treeDialogNewContact-h-i":"themes/default/img/x.png","contact_upload_image-h-i":"themes/default/img/x.png","menu_new_options_menu_img":"themes/default/img/arrows/arrow_gray_down.gif","menu_options_arrow_down":"themes/default/img/arrows/arrow_double_gray_down.gif","menu_options_arrow_up":"themes/default/img/arrows/arrow_double_gray_up.gif","d89e55":"themes/default/img/dummy.gif","menu_big_save":"themes/default/img/dummy.gif","d75e22":"themes/default/img/dummy.gif","d90e14":"themes/default/img/menu/distributionlist_intcontact.gif","d90e19":"themes/default/img/menu/distributionlist_intcont_d.gif","d90e24":"themes/default/img/menu/distributionlist_extcontact.gif","d90e29":"themes/default/img/menu/distributionlist_extcont_d.gif","d90e34":"themes/default/img/menu/distributionlist_remove.gif","d90e39":"themes/default/img/menu/distributionlist_remove_d.gif","d90e59":"themes/default/img/mail/add_attachment.gif","d90e64":"themes/default/img/mail/add_attachment_d.gif","d90e69":"themes/default/img/mail/remove_attachment.gif","d90e74":"themes/default/img/mail/remove_attachment_d.gif","d90e94":"themes/default/img/menu/add_picture.gif","d90e99":"themes/default/img/menu/add_picture_d.gif","d90e104":"themes/default/img/menu/remove_picture.gif","d90e109":"themes/default/img/menu/remove_picture_d.gif","d15e9":"themes/default/img/menu/section_scroll_left.gif","d15e15":"themes/default/img/dummy.gif","d15e23":"themes/default/img/menu/section_scroll_left_dis.gif","d15e29":"themes/default/img/dummy.gif","d18e9":"themes/default/img/menu/section_scroll_right.gif","d18e22":"themes/default/img/menu/section_scroll_right_dis.gif","d79e14":"themes/default/img/menu/cancel_clear.gif","d79e19":"themes/default/img/menu/cancel_clear_d.gif","d79e24":"themes/default/img/menu/cancel_clear.gif","d79e29":"themes/default/img/menu/cancel_clear_d.gif","alert_window-h-i":"themes/default/img/x.png","create_window-h-i":"themes/default/img/x.png","conflict_window-h-i":"themes/default/img/x.png","window_categories-h-i":"themes/default/img/x.png","window_categories_new-h-i":"themes/default/img/x.png","error_popup-h-i":"themes/default/img/x.png","attachPopupTemplate-h-i":"themes/default/img/x.png"},"hide":{},"movable":["treeDialogNewContact-h","contact_upload_image-h","alert_window-h","create_window-h","conflict_window-h","window_categories-h","window_categories_new-h","error_popup-h","attachPopupTemplate-h"],"size":[{"id":"mainarea","align":"stretch","margin":"0px 10px 0px 10px","children":[{"id":"all_of_menu","align":"top","size":"11em","resize":"static","children":[,,,,,,]},{"id":"contentarea","align":"stretch","margin":"0px 0px 0px 0px","children":[{"id":"d88e14","align":"top","size":"2em","padding":"0px 4px 0px 4px","children":[{"id":"d88e15","align":"stretch","children":[]}]},{"id":"d88e20","align":"bottom","size":"1.6em","padding":"0px 4px 8px 4px","children":[]},{"id":"d88e21","align":"stretch","padding":"0px 4px 0px 4px","children":[{"id":"tabPanels","align":"top","size":"2.2em","margin":"0px 0px 1px 0px","children":[]},{"id":"d88e31","align":"stretch","children":[{"id":"tabContact4","align":"stretch","children":[]},{"id":"tabContact5","align":"stretch","children":[{"id":"attachmentsNewContactGridHeader","align":"top","size":"1.6em","children":[]},{"id":"attachmentsNewContactGrid","align":"stretch","children":[]}]},{"id":"tabContact6","align":"stretch","children":[]}]}]}]}]},,,],"help":{"panelContact1":"Enter business data","panelContact2":"Enter personal data","panelContact3":"Enter additional data","newcontact_categories_button-button":"Select a contact category","d88e256":"Enter a comment","image1":"Upload a picture","d89e41":"Select the functions for the dynamic field","menu_options_arrow_down":"Expand the panel","menu_options_arrow_up":"Collapse the panel"},"min":{},"max":{},"split":{},"i18n":{"d88e19":"","d88e23":"","d88e25":"","d88e27":"","panelContact4":"","d88e29":"","d88e40":"","d88e46":"","d88e50":"","d88e52":"","d88e56":"","d88e58":"","d88e64":"","d88e67":"","d88e71":"","d88e74":"","d88e78":"","d88e81":"","d88e85":"","d88e87":"","d88e93":"","d88e96":"","d88e100":"","d88e103":"","d88e107":"","d88e112":"","d88e116":"","d88e119":"","d88e123":"","newcontact_categories_button-button":"title,","but_folder-button":"","treeDialogNewContact-h-i":"alt,title","treeDialogNewContact-h-c":"","d88e137":"","d88e139":"","d88e151":"","d88e154":"","d88e162":"","d88e177-button":"","d88e178":"","d88e183":"","d88e186":"","d88e191":"","d88e194":"","d88e199":"","d88e202":"","d88e209":"","d88e212":"","d88e217":"","d88e220":"","d88e235-button":"","d88e238":"","d88e241":"","d88e246":"","d88e249":"","d88e256":"","d88e267":"","d88e270":"","d88e274":"","d88e279":"","d88e283":"","d88e286":"","d88e290":"","d88e293":"","d88e297":"","d88e300":"","d88e304":"","d88e307":"","d88e311":"","d88e314":"","d88e318":"","d88e321":"","d88e325":"","d88e328":"","d88e334":"","d88e337":"","d88e341":"","d88e344":"","d88e348":"","d88e351":"","d88e355":"","d88e358":"","d88e362":"","d88e365":"","d88e369":"","d88e372":"","d88e376":"","d88e379":"","d88e383":"","d88e386":"","d88e390":"","d88e393":"","d88e397":"","d88e400":"","contact_upload_image-h-i":"alt,title","contact_upload_image-h-c":"","d88e415-button":"","d88e416-button":"","d89e32":"","d89e35":"","menu_options_arrow_down":"title","menu_options_arrow_up":"title","menu_save_save_text":"","d90e7":"","d90e14":"title","d90e16":"","d90e19":"title","d90e21":"","d90e24":"title","d90e26":"","d90e29":"title","d90e31":"","d90e34":"title","d90e36":"","d90e39":"title","d90e41":"","d90e52":"","d90e61":"","d90e66":"","d90e71":"","d90e76":"","d90e87":"","d90e96":"","d90e101":"","d90e106":"","d90e111":"","d79e7":"","d79e16":"","d79e21":"","d79e26":"","d79e31":"","alert_window-h-i":"alt,title","alert_window-h-c":"","d39e8":"","alert_window_cancel-button":"","alert_window_nocomment-button":"","alert_window_no-button":"","alert_window_yes-button":"","alert_window_ok-button":"","alert_window_appointment-button":"","alert_window_series-button":"","alert_window_edit-button":"","alert_window_continue-button":"","create_window-h-i":"alt,title","create_window-h-c":"","create_window_cancel-button":"","create_window_nocomment-button":"","create_window_advanced-button":"","create_window_ok-button":"","conflict_window-h-i":"alt,title","conflict_window-h-c":"","d39e28":"","conflict_recurrence_msg":"","d39e42":"","d39e44":"","d39e46":"","d39e48":"","d39e53-button":"","conflict_window_ignore-button":"","window_categories-h-i":"alt,title","window_categories-h-c":"","d39e63":"","categories_sel_but_new-button":"","categories_sel_but_rename-button":"","categories_sel_but_delete-button":"","d39e69":"","d39e72-button":"","d39e73-button":"","window_categories_new-h-i":"alt,title","window_categories_new-h-c":"","d39e79":"","d39e82":"","categories_new_but_cancel-button":"","categories_new_but_ok-button":"","error_popup-h-i":"alt,title","error_popup-h-c":"","error_popup_ok-button":"","attachPopupTemplate-h-i":"alt,title","attachPopupTemplate-h-c":"","d81e10":"","d81e14":"","d81e16-button":"","d81e20-button":"","d81e24-button":"","d81e25-button":""}};

// get reference to core window
var corewindow = null;
if (window.opener) {
    corewindow = window.opener.corewindow;
} else if (window.parent) {
    corewindow = window.parent.corewindow;
}
oxThemeStyle = corewindow.oxThemeStyle;
function ErrorPopup() {}
ErrorPopup.ok = function () {
	ErrorPopup.closeWindow();
};
ErrorPopup.openWindow = function () {
    ox.api.setModal(true);
//	showNode("modal-dialog");
//	$("modal-dialog").style.display="block";
	showNode("error_popup");
	centerPopupWindow($("error_popup"));
	$("error_popup").style.display="block";
};
ErrorPopup.closeWindow = function () {
	hideNode("error_popup");
	$("error_popup").style.display="none";
	ox.api.setModal(false);
//	hideNode("modal-dialog");
//	$("modal-dialog").style.display="none";
};
register("Loaded",function() {
    var newPath = corewindow.oxThemeStyle.path || "default";
    for (var i in init.images) {
        init.images[i] = init.images[i].replace(/\/default\//g, "/"+newPath+"/");
    }
	addOnClose($("error_popup"),function() { ErrorPopup.closeWindow(); }); 
	appendNode("everything");
});
function addHideTreeNode(node,parent,index) {
}
function appendNode(id,cd) {
	var node=document.getElementById(id);
	if(node && !cd && (node.style.display=="none" || node.style.display=="NONE")) {
		if(node.tagName == "DIV") { node.style.display = "block"; }
		else { node.style.display = ""; }
	}
}
function removeNode(id,cd) {
	var node=document.getElementById(id);
	if(node && !cd && (node.style.display!="none" || node.style.display!="NONE")) {
		node.style.display = "none";
	}	
}
function refillImages(id) {
    if($ALL(id)) {
        var elements=$ALL(id).getElementsByTagName("img");
        for(var i=0;i<elements.length;i++) {
            var src = init.images[elements[i].id];
            if(src && src != elements[i].src) elements[i].src = src;
        }
    }
}
function showNode(id,changedisplay) {
	appendNode(id,changedisplay);
	refillImages(id);
}

function hideNode(id,changedisplay) {
	removeNode(id,changedisplay);
}
var fileloaded=function() {};

function autorefill() {
	var effectsarray1=["menu_global_attachments","menu_mail","menu_mail2","menu_task_new_participant","menu_calendar_new_attachment","menu_dyn_window","menu_contact_new_picture","menu_new_contact_distributionlist","menu_calendar_new_participant","menu_new_mail","menu_mail_new_attachment","menu_new_mail_view"];
	var effectsarray2=["menu_global_tags"];
	var singlearray1=[];
	var singlearray2=["menu_small_mail","menu_small_calendar","menu_small_contacts",
				      "menu_small_distributionlist","menu_small_tasks","menu_small_infostore"];
	var singlearray3=["menu_big_portal","menu_big_mail","menu_big_calendar","menu_big_contacts","menu_big_tasks","menu_big_infostore","menu_big_save","menu_mail_save"];
						  
	if(configGetKey("gui.effects.global")) {
		for(var zaehler=0;zaehler<effectsarray1.length;zaehler++) {
			makeButtonElement1($ALL(effectsarray1[zaehler]));
		}
		for(var zaehler=0;zaehler<effectsarray2.length;zaehler++) {
			makeButtonElement2($ALL(effectsarray2[zaehler]));
		}
		for(var zaehler=0;zaehler<singlearray1.length;zaehler++) {
			setDOMMenuElement1($ALL(singlearray1[zaehler]));
		}
		for(var zaehler=0;zaehler<singlearray2.length;zaehler++) {
			setDOMMenuElement2($ALL(singlearray2[zaehler]));
		}
		for(var zaehler=0;zaehler<singlearray3.length;zaehler++) {
			setDOMMenuElement3($ALL(singlearray3[zaehler]));
		}
	}
	refillImages("menu_options_menu");
	refillImages("body");
}

register("Loaded",autorefill);
register("Loaded",menuLoad);
function menuLoad() {
	setTimeout(function() {
		menuiteration=configGetKey("gui.menu.menuiteration") || 4;
		triggerEvent("OX_menu_Change_Height",true);
	},0);
}
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2010 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

var ExecAfterUpload =  function (){};
var ExecErrorAfterUpload = null;

function attachmentDialog(sDialogNum, fkt_On_OK)
{
	this.template_id = 'attachPopupTemplate';
	this.popup = $('attachPopupTemplate');
	this.popup.id = this.template_id + '_' + this.dialog_num;
	this.dialog_num = sDialogNum;
	this.att_server_rem = new Array();	
	this.callOnOK = fkt_On_OK;
	this.form_name = 'attFile_' + this.dialog_num;
	this.form =  document.attFile;
	this.form.name = this.form_name;
	
	//this.sel_files_area = $("selectedFilesArea");
	this.files_area_id = "selectedFilesArea" + '_' + this.dialog_num;
	//this.sel_files_area.id = this.files_area_id;
	this.live_grid_container = $("sel_files_area");
	this.file_storage = new Storage(0, [], "", 0, 0,  null, function(x){ return x[0];});
	this.file_input_count = 0; 
	this.attachmentsChanged = false;
	
	var Self = this;
	register("OX_Attachment_Dialog_Cancel", function(){Self.closePopup();});
	addOnClose (this.popup,function(){
		  triggerEvent("OX_Attachment_Dialog_Cancel");
		});
	register("OX_Object_Add_Attachment", function(){Self.openPopup();});
	register("OX_Attachments_Add_File", function(){Self.addFile();});
	register("OX_Attachments_Remove_File", function(){Self.removeFile();});
	register("OX_Attachment_Dialog_OK", function(){Self.commitPopup();});
	
	this.all_input_fields = new Array();
	this.file_name_list = new Array();
	this.temp_list = new Array();
	
	this.last_input = null;
	
	this.curr_file_input_id;
	
	this.open = false;	
}

attachmentDialog.prototype = {
	attach_changed:function ()
	{
		return (this.att_server_rem.length > 0 || this.file_input_count > 0 || this.attachmentsChanged);
	},
	do_post: function (obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload)
	{
		if(this.att_server_rem.length > 0)
		{
			var aAttIds = new Array();

			for(var indx2=0;indx2<this.att_server_rem.length;indx2++)
			{
				aAttIds.push(this.att_server_rem[indx2].attid);
			}

			var sAction = AjaxRoot + "/attachment?action=detach" + "&session="+session + "&attached=" 
						+ this.att_server_rem[0].item_id + "&module=" 
								+ this.att_server_rem[0].module + "&folder=" + (this.att_server_rem[0].folder || this.att_server_rem[0].folder_id);												 
			this.att_server_rem = new Array();	
			var attJson = new JSON();
			var Self = this;
			function cb_deleted(arg)
			{
				if(arg && arg.error)
					alert(arg.error);			
				else			
				{
					Self.post_new(obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload);
				}				
			}
			attJson.put(sAction,aAttIds,null,cb_deleted);
		}
		else
		{
			this.post_new(obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload);
		}
		return;
	},
	post_new:function (obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload)
	{
		ExecAfterUpload = fn_exec_afterupload;
		ExecErrorAfterUpload = fn_error_exec_afterupload;
		if(sActionParam)
		{
			this.form.action = sActionParam;
		}
		else				
			this.form.action = AjaxRoot + "/attachment?action=attach&session=" + session;
		if(sTargetParam)
			this.form.target = sTargetParam;
		var  sObj = JSON.serialize(obj);
		if(this.file_input_count == 0)
		{
			var oNodeJson;
			if(this.form["json_0"] == undefined)
			{
				oNodeJson = newnode('input',0,{
										type:"hidden",
										name:'json_0'
										});								
				this.form.appendChild(oNodeJson);
			}
			else
			{
				oNodeJson = this.form["json_0"];
			}
			oNodeJson.value = sObj;
		}		
		else
		{
			for(var nCount=0;nCount<this.file_input_count;nCount++)
			{
				if(this.form['json_'+nCount])
					this.form['json_'+nCount].value = sObj;
			}
		}
		this.attachmentsChanged = true;
		this.form.submit();
	},
	createFileInput: function()
	{
		var sId = 'file_' + (this.file_input_count);
		var oNode = newnode('input',0,{
										type:"file",
										size:"40",
										name:sId,
										id:sId,
										className:"inputElementAttachment"
										});
		var oNodeJson = newnode('input',0,{
										type:"hidden",
										name:'json_'+(this.file_input_count),
										id:'json_'+(this.file_input_count)
										});						
		this.last_input = oNode;
		var outerDiv1 = newnode("div");
		var outerDiv2 = newnode("div");		
		outerDiv1.appendChild(oNode);
		outerDiv2.appendChild(oNodeJson);
		this.form.appendChild(outerDiv1);
		this.form.appendChild(outerDiv2);
		this.all_input_fields.push(oNode);
		this.all_input_fields.push(oNodeJson);		
		return sId;
	},
	openPopup:function ()
	{
		if(!this.open)
			this.curr_file_input_id = this.createFileInput();	
		this.open = true;			
		this.temp_list = new Array();
		if ($("modal-dialog")) {
		    ox.api.setModal(true);
//            showNode("modal-dialog");
//            $("modal-dialog").style.display = "block";
        }
        centerPopupWindow(this.popup);
		this.popup.style.display = 'block';		
		//create
		if(this.live_grid == null)
		{
			this.live_grid = new LiveGrid([ 
				{
					text:" ",				
					index: 1,	
					style: {overflowX:"auto"},
					set: function(div, text) {
						text = text || "\u00a0";
						if (div.firstChild)
							div.firstChild.data = text;
						else
							div.appendChild(document.createTextNode(text));
					},					
					clear: LiveGrid.makeClear("")
				}
			],new Selection());			
	
			this.live_grid.emptylivegridtext ="";
			this.live_grid.getHeader();		
			this.live_grid.getTable(this.live_grid_container);
			this.live_grid_container.style.overflowX = "auto";
			//this.live_grid_container.firstChild.style.width = "";			
			//this.live_grid_container.firstChild.style.overflowX = "auto";			
		}
		else
			this.live_grid.enable(this.file_storage = new Storage(0, [], "", 0, 0,  null, function(x){ return x[0];}));

	},
	closePopup:function ()
	{
		//this.form.reset();
		//var oNode;
		//empty lg
		//removeChildren(this.sel_files_area);		
		/*
		while(oNode = this.all_input_fields.pop())
		{
			if(oNode)
			{
				this.form.removeChild(oNode);
			}
		}*/
		if ($("modal-dialog")) {
		    ox.api.setModal(false);
//            hideNode("modal-dialog");
//            $("modal-dialog").style.display = "none";
        }
		this.popup.style.display = 'none';	
		/*
		this.file_input_count = 0;	
		*/
		this.open = false;
		var aToDel = new Array();
		for (var indxTd in this.temp_list)
		{
			aToDel.push(this.temp_list[indxTd].id);
		}
		this.removeFiles(aToDel);
		this.temp_list = new Array();		
		this.live_grid.disable();
		if(this.last_input != null)
			this.form.removeChild(this.last_input.parentNode);
		this.last_input = null;
		this.file_input_count++;
	},	
	commitPopup:function ()
	{
		if ($("modal-dialog")) {
		    ox.api.setModal(false);
//            hideNode("modal-dialog");
//            $("modal-dialog").style.display = "none";
        }
		this.popup.style.display = 'none';	
		this.file_name_list = this.file_name_list.concat(this.temp_list);
		this.callOnOK(this.file_name_list);	
		this.live_grid.disable();
	},
	showAttachedFiles: function ()
	{
		return this.file_name_list;
	},
	addFile:function ()
	{	
		//ie7 bugfix
		//var currFileInput = this.form.elements[this.curr_file_input_id];
		
		var currFileInput = document.getElementById(this.curr_file_input_id);
		
		if(currFileInput.value.length == 0)
			return;		
		var fileName = separateFilenameFromPath(currFileInput.value);		
		var file = {id:fileName+'_'+this.file_input_count,filename:fileName};
		this.temp_list.push(file);
		
		//add file to lg
		var aFileObjects =  [[file.id,fileName]];
		this.file_storage.append(aFileObjects);
		this.live_grid.enable(this.file_storage);
		
		//update styles here (IE BUG FIX horizontal scroll bar)
		this.live_grid.rowTemplate.style.tableLayout = "auto";
		
		//this.sel_files_area.appendChild(newnode("option", 0,
		//	{value: file.id}, [document.createTextNode(fileName)]));

		currFileInput.style.display = "none";
		
		this.file_input_count++;
		this.curr_file_input_id = this.createFileInput();			
	},
	removeFile: function() {	
		//var files = this.sel_files_area.childNodes;
//		var len = files.length;
//		var selected = [];
//		for (var i = 0; i < len; i++)
//			if (files[i].selected) selected.push(files[i].value);
		var aSelItems = this.live_grid.selection.getSelected();
		if(aSelItems.length > 0)
			this.removeFiles(aSelItems);
//		removSelected;
	},
	getLocalPath:function (sId)
	{
			sFileName = sId.split('_')[0]; 
			for(var nField=0;nField<this.all_input_fields.length;nField++)
			{
				if((this.all_input_fields[nField].name == 'file_' + sId.split('_')[1]))
				{					
					return this.all_input_fields[nField];
				}
			}
	},
	removeFiles:function (aFiles)
	{
		function removeFileNameFromString(sStr,sFileName)
		{
			sFileName += '; ';
			var sReturnStr = sStr.replace(sFileName,'');
			return sReturnStr;
		}
		var Self = this;
		function removeFileNameFromList(sId)
		{
			for(var indx in Self.file_name_list)
			{
				if(Self.file_name_list[indx].id == sId)
				{
					Self.file_name_list.splice(indx,1);
					break;
				}
			}
			for(var indx in Self.temp_list)
			{
				if(Self.temp_list[indx].id == sId)
				{
					Self.temp_list.splice(indx,1);
					break;
				}
			}
		}
		//aFiles
		//get files from lg
		//var options = this.sel_files_area.childNodes;
		if(this.live_grid && this.live_grid.storage != null)
			this.live_grid.deleteIDs(aFiles);
		for(var nIndex=0;nIndex<aFiles.length;nIndex++)
		{
			var filename = aFiles[nIndex];
			//var len = options.length;
			//remove fildes from lg
			/*
			for (var i = 0; i < len; i++)
				if (options[i].value == filename) {
					//this.sel_files_area.removeChild(options[i]);
					break;
				}
*/
			var sFileName = expandFileNames(filename);
			removeFileNameFromList(filename);
			var aToRemoveArray = new Array();
			for(var nField in this.all_input_fields)
			{
				if(((this.all_input_fields[nField].name == 'file_' + expandIDS(filename))
							|| (this.all_input_fields[nField].name == 'json_' + expandIDS(filename))) 
											&& this.all_input_fields[nField].name != 'json_0')
				{
					this.form.removeChild(this.all_input_fields[nField].parentNode);
					aToRemoveArray.push(nField);
				}
			}
			for(var nRemItem in aToRemoveArray)
			{
				this.all_input_fields.splice(aToRemoveArray[nRemItem],1);							
			}
		}
	}
}

function expandIDS(sFileWithId)
{
	var aTempArray = sFileWithId.split('_');	
	return aTempArray[(aTempArray.length-1)];
}
function expandFileNames(sFileWithId)
{
	var aTempArray = sFileWithId.split('_');
	var sFileName = "";
	for(var nIndxx=0;nIndxx<aTempArray.length-1;nIndxx++)
	{
		sFileName += aTempArray[nIndxx];
		if(nIndxx < aTempArray.length-2)
			sFileName += "_";
	}
	return sFileName;
}

/*
 * remove is possible in new/edit window only
 * */
function attachmentGrid(sContainerId,nId,nFolder,sModule,oDialog)
{
	this.container = $(sContainerId);
	this.containerHeader = $(sContainerId + "Header");
	this.module  = sModule;
	this.nItemId = nId;
	this.folder = nFolder;	
	this.liveGrid = null;
	this.viewGrid();
	this.attachmentStorage;// = new Storage(0, []);
	this.bDetailAttachmentsLoaded = false;
	
	this.selection_dialog = (oDialog)?oDialog:false;
	
	this.timestamp = 0;
	
	this.addData = new Array();
	this.selectedRtfFlag = false;
	this.selectedId = null;
	this.selectedFilename = null;	
	
	this.numberOfAttachments = 0;
	
	Self = this;
	this.openAttachedFile = function() {
				if(Self.selectedRtfFlag)
					return;
				var sURL = 
				AjaxRoot + "/attachment/" + Self.selectedFilename + "?action=document&session="
					+ session + "&attached=" + Self.nItemId  + "&module=1&folder="
					+ activefolder + "&id=" + Self.selectedId;
				newWindow(sURL, getWindowOptions(null, null, "scrollbars=yes"));
	};
	this.saveAttachedFile = function() {

				if(Self.selectedRtfFlag)
					return;		
				var sContentType = 'application%2Foctet-stream';	
				var sURL = 
				AjaxRoot + "/attachment/" + Self.selectedFilename + "?action=document&session="
					+ session + "&attached=" + Self.nItemId  + "&module=1&folder="
					+ activefolder + "&id=" + Self.selectedId + '&content_type=' +sContentType;
				if (IE6) {
					newWindow(sURL, getWindowOptions());
				} else {
					var frame = $ALL("dlIframe") ? getFrameElement('dlIframe') : parent.frames['dlIframe'];
					frame.location.href = sURL;
				}
	};
	this.saveAttachInInfoStore = function() {
		if (Self.selectedRtfFlag) return;
		if (activemodule == "mail") return;
		var nNumModule = -1;
		switch (activemodule) {
			case "calendar": 	nNumModule = 1;
								break;
			case "tasks": 	nNumModule = 4;
								break;
			case "contacts": 	nNumModule = 7;
								break;																
		}
		
		// use new api
		ox.api.infostore.compose({
		    params: {
		        attachmodule: nNumModule,
		        filename: Self.selectedFilename,
		        attid: Self.selectedId,
		        attobjid: Self.nItemId,
		        attobjfolder: Self.folder || Self.folder_id,
		        folder: configGetKey("folder.infostore")
		    },
		    id: [ Self.selectedId, Self.nItemId, (Self.folder || Self.folder_id)]
		});
		// TODO: remove this block
//		propertiesPopUp = newWindow(
//		      "newInfoItemMain.html#attachmodule=" + nNumModule+ "&edit_id=" + -1
//		      + "&filename=" + encodeURIComponent(Self.selectedFilename)
//              + "&attid=" + encodeURIComponent(Self.selectedId)
//              + "&attobjid=" + encodeURIComponent(Self.nItemId)                        
//              + "&attobjfolder=" + encodeURIComponent((Self.folder || Self.folder_id))      
//              + "&folder=" + encodeURIComponent(configGetKey("folder.infostore")), 
//		      getWindowOptions(), 
//		      [ Self.selectedId, Self.nItemId, (Self.folder || Self.folder_id)]);	
//		propertiesPopUp.focus();			
	}
	
	var Self = this;
	this.remAttachedFile  = function() {
		if(Self.selectedRtfFlag) return;		
		function cbyes() {
			Self.remove(Self.liveGrid.selection.getSelected(), function() {
				Self.updateGrid(Self.selection_dialog.file_name_list);
			});										
		}
		newConfirm(_("Delete Attachment"),_('Are you sure you want to delete the selected attachment?'),AlertPopup.YESNO,null,null,cbyes,null);
										
	};
										
	register("OX_Attachment_Open", this.openAttachedFile);		
	register("OX_Attachment_Save", this.saveAttachedFile);		
	register("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);	
	
	if(this.selection_dialog)
		register("OX_Object_Attachment_Delete", this.remAttachedFile);	
}

attachmentGrid.prototype = {
updateGrid:function (data)
{	
	var aNewData = new Array();
	for(var indx in data)
	{
		var bFound = false;
		for(var indx2=0;indx2<this.addData.length;indx2++)
		{	
			if(data[indx].id == this.addData[indx2].id)
			{
				bFound = true;
				break;
			}
		}
		if(!bFound)
			aNewData.push(data[indx]);
	}	
	for(var indx2=0;indx2<this.addData.length;indx2++)
	{	
		var bFound = false;
		for(var indx in data)
		{
			if(data[indx].id == this.addData[indx2].id)		
			{
				bFound = true;
				break;				
			}
		}
		if(!bFound)
		{
			//IE7 bugfix
			//this.attachmentStorage.remove(this.attachmentStorage.ids.indexOf(this.addData[indx2].id));
			var indexToDelete = -1;
			var aIds = this.attachmentStorage.ids;
			for (var i = 0; i < aIds.length; i++) {
				if(aIds[i] == this.addData[indx2].id)
				{
					this.liveGrid.deleteIDs([this.addData[indx2].id]);
					indexToDelete = i; 
				}
			}
//			if(indexToDelete != -1)
//				this.attachmentStorage.remove(indexToDelete);
			this.addData.splice(indx2,1);
		}
	}
	this.addData = this.addData.concat(aNewData);
	var aNewObj =  new Array();
	for(var i in aNewData)
	{
		sFileName = aNewData[i].filename;
		aNewObj.push(new Array(aNewData[i].id,sFileName,'','',''));
		this.numberOfAttachments++;
		triggerEvent("OX_Attachments_Changed_InGrid",this.numberOfAttachments);
	}
	if(aNewObj.length == 0)
		triggerEvent("SubSelected", 0);
	else
		this.attachmentStorage.append(aNewObj);
	this.enableGrid();

},
remove:function (ids, callback) {
    var local = [], remote = [];
    for (var i = 0; i < ids.length; i++) {
        var id = ids[i];
        if (typeof id == "string" && id.indexOf("_") >= 0) {
            local.push(id);
        } else {
            remote.push(id);
            this.selection_dialog.att_server_rem.push({
                attid: id, item_id: this.nItemId, module: this.module,
                folder: this.folder || this.folder_id
            });
        }    
    }
    if (local.length) this.selection_dialog.removeFiles(local);
    if (remote.length) this.attachmentStorage.removeIDs(remote);
    this.numberOfAttachments -= ids.length;        
    triggerEvent("OX_Attachments_Changed_InGrid",this.numberOfAttachments);
    if (callback) callback();
},
enableGrid:function ()
{
	this.liveGrid.enable(this.attachmentStorage);		
	register("OX_Attachment_Open", this.openAttachedFile);		
	register("OX_Attachment_Save", this.saveAttachedFile);	
	register("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);		
},
disableGrid:function()
{
		this.liveGrid.disable();
		unregister("OX_Attachment_Open", this.openAttachedFile);		
		unregister("OX_Attachment_Save", this.saveAttachedFile);
		unregister("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);
},
getAttachments:function(nId,nFolder,fn_update_opt)
{
	var  Self = this;	
	this.attachmentStorage = new Storage(0, []);
	if(this.nItemId === false)
		return;		
	function cb_attachments(arg)
	{
		var aData = new Array();
		Self.numberOfAttachments = 0;
		//check rtf_flags here
		for (var indx in arg.data)
		{			
			aData.push(arg.data[indx]);
			Self.numberOfAttachments++;		
		}
		
		triggerEvent("OX_Attachments_Changed_InGrid",Self.numberOfAttachments);
		Self.attachmentStorage.append(aData);
		Self.attachmentStorage.timestamp = arg.timestamp;
		Self.liveGrid.enable(Self.attachmentStorage);
		Self.bDetailAttachmentsLoaded = true; 
		if(fn_update_opt)
			fn_update_opt();			
	}
	if(nId != 0 && nId != undefined && 
						nFolder != 0 && nFolder != undefined)
	{
		this.nItemId = nId;
		this.folder = nFolder;		
	}		
	this.doAjaxFetchAllAttachments(cb_attachments);
},
viewGrid: function ()
{	
		var Self = this;
		var clear = LiveGrid.makeClear("...");
		function setAttachmentsTest1 (div, text){
			removeChildNodes(div);
			if(text[5])
				div.style.fontStyle = "italic";
			else
				div.style.fontStyle = "";				
			div.appendChild(document.createTextNode(text[1]));		
		}
		function setAttachmentsTest2 (div, text){
			removeChildNodes(div);
			if(text[5])
				div.style.fontStyle = "italic";
			else
				div.style.fontStyle = "";				
			div.appendChild(document.createTextNode(text[2]));		
		}	
		function setAttachmentsTest3 (div, text){
			removeChildNodes(div);
			if(text[5])
				div.style.fontStyle = "italic";
			else
				div.style.fontStyle = "";	
			div.appendChild(document.createTextNode( text[3] && text[3].length != 0 ? bytesToString(text[3]) : "") );		
		}			
		function setAttachmentsTest4 (div, text){
			removeChildNodes(div);
			if(text[5])
				div.style.fontStyle = "italic";
			else
				div.style.fontStyle = "";				
			if(text[4].length==0)
				div.appendChild(document.createTextNode(""));		
			else				
				div.appendChild(document.createTextNode(formatDate(text[4], "date")));		
		}								
		this.liveGrid = new LiveGrid([ 
			{
				text: "File name", /*i18n*/
				i18n: true,
				sortable: true,
				set: setAttachmentsTest1,
				clear: clear
			}, {
				text: "Mime type", /*i18n*/
				i18n: true,				
				sortable: true,
				width: "20%",
				set: setAttachmentsTest2,
				clear: clear
			}, {
				text: "Size", /*i18n*/
				i18n: true,				
				sortable: true,
				width: "15%",
				set: setAttachmentsTest3,
				clear: clear
			}, {
				text: "Last modified", /*i18n*/
				i18n: true,					
				sortable: true,
				width: "15%",
				set: setAttachmentsTest4,
				clear: clear
			}
		], new Selection());
		this.liveGrid.emptylivegridtext="No Attachments available";/*i18n*/
		this.containerHeader.appendChild(this.liveGrid.getHeader());
		this.liveGrid.getTable(this.container);
				
		this.liveGrid.events.register("Activated", function(ids){
			if (!ids || ids == 0) return;
			(menucheckRight("WRITE")) ? triggerEvent("OX_Object_Delete_Attachment") :
				triggerEvent("OX_New_Error", 4, _("You're not allowed to delete this attachment!"));
		});
	
		var aIds = Self.liveGrid.selection.getSelected();
		var Self = this;		
		function fn_triggerSubSel(ids){
			triggerEvent("SelectedAttachment",ids);
			if (ids == 1) {				
				var aIDS = Self.liveGrid.getSelectedIDs();
				Self.selectedId = aIDS[0];
				Self.selectedFilename = Self.liveGrid.storage.data.get(Self.selectedId)[1];		
				Self.selectedRtfFlag = !(Self.liveGrid.storage.data.get(Self.selectedId)[5] == false);
				if(Self.liveGrid.storage.data.get(Self.selectedId)[5] == undefined)
				{
					Self.selectedRtfFlag = false;
				}
				triggerEvent("SubSelected", ids,Self.selectedRtfFlag);				
			} 		 

		}
		this.liveGrid.events.register("Selected", fn_triggerSubSel);
},
doAjaxFetchAllAttachments:function (cb)
{
	json.get(AjaxRoot + "/attachment?action=all&session=" + session + "&folder=" +
			(this.folder || this.folder_id) + "&attached=" + this.nItemId + "&module="+this.module+"&" + 
			"columns=1%2C803%2C805%2C804%2C4%2C806&sort=803&order=asc", null,cb);		
}
}

function callback_attach(cb) {
	if(typeof savePending != "undefined" && savePending) savePending = false;
	if (!cb.error)
	{
		ExecAfterUpload();	
	}
	else {
		//triggerEvent("OX_New_Error", 4, cb.toString());
	}
}

function callback_document(cb) {
	if(typeof savePending != "undefined" && savePending) savePending = false;
	if (cb.error)
	{
		newServerError(cb);
	}
	
}
function callback_error(arg)
{
	if(typeof savePending != "undefined" && savePending) savePending = false;
	if(ExecErrorAfterUpload && typeof ExecErrorAfterUpload != "undefined") 
		ExecErrorAfterUpload(arg);
	else 
		newServerError(arg);
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2010 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Suphi Basdemir <suphi.basdemir@open-xchange.com>
 * 
 */
 
registerView("contact_new",
	function() {
	 	register("OX_Picture_Add",myNewContactFunctions.addPicutre);
	 	register("OX_Picture_Remove",myNewContactFunctions.deletePicture);
	 	var menu = new ContextMenu();
        var item = new MenuItem("Add", /*i18n*/
            function() { triggerEvent('OX_Picture_Add'); });
        item.setIcon("img/menu/add_picture.gif", "img/menu/add_picture_d.gif");
        menu.addItem(item);
        item = new MenuItem("Remove", /*i18n*/
            function() { triggerEvent('OX_Picture_Remove'); });
        item.setIcon("img/menu/remove_picture.gif",
                     "img/menu/remove_picture_d.gif");
        menu.addItem(item);
        addDOMEvent($("imageContactTd"), "contextmenu", function(e) {
            menu.display(e.clientX, e.clientY);
        });
	},
	null, 
	null,
	null
);

registerView("contact_new/business",
	function() { 
		$("tabContact1").style.display="block";
		$("panelContact1").className="tabPanelFirstHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";	
	},
    function() {
        try {
            setTimeout(function() {
                if ($("last_name")) $("last_name").focus();
            },0);
        } catch (e) {
            
        }
    }, 
    null,
	function() {
		$("tabContact1").style.display="none";
		$("panelContact1").className="tabPanelFirst tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";		
	},
	function() {
		try {
			setTimeout(function() {
				if ($("last_name")) $("last_name").focus();
			},0);
		} catch (e) {
			
		}
	}
);

registerView("contact_new/personal",
	function() { 
		$("tabContact2").style.display="block";
		$("panelContact2").className="tabPanelHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";
		try {
            setTimeout(function() {	
            	$("contactForm").profession.focus();
            },0);
        } catch (e) {
            
        }     	
		if(!birthdayCalendar && !anniversaryCalendar)
			createMiniCalendar();
		enableBirthdayAppointment();
	},
	null, 
	 null,
	function() {
		$("tabContact2").style.display="none";
		$("panelContact2").className="tabPanel tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";	
	}
);

registerView("contact_new/additional",
	function() { 
		$("tabContact3").style.display="block";
		$("panelContact3").className="tabPanelHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";	
        try {
            setTimeout(function() { 		
            	$("contactForm").street_other.focus();
            },0);
        } catch (e) {
            
        }             	
	},
	null, 
	 null,
	function() {
		$("tabContact3").style.display="none";
		$("panelContact3").className="tabPanel tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";		
	}
);
registerView("contact_new/attachment",
	function() { 
		$("tabContact5").style.display="block";
		$("panelContact5").className="tabPanelHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";	
	},
	function() {
		
		if(!bAttachmentGridCreated)
		{
			initAttachmentsGrid();
			bAttachmentGridCreated = true;
			tmp_attachment.getAttachments();
		}
		else		{

			tmp_attachment.enableGrid();			
		}
		register("OX_Attachments_Changed_InGrid",setContactsNewNumberOfAtt);
		register("OX_Timestamp_Changed_By_Attach",setContactsNewTimeStampByAtt);
		
	}, 
	 function() {
	 	unregister("OX_Attachments_Changed_InGrid",setContactsNewNumberOfAtt);
		register("OX_Timestamp_Changed_By_Attach",setContactsNewTimeStampByAtt);
		if(bAttachmentGridCreated)
			tmp_attachment.disableGrid();
	 },
	function() {
		$("tabContact5").style.display="none";
		$("panelContact5").className="tabPanel tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";		
	}
);

var json = new JSON();
var contactDetailId = 0;
var activefolderLocal = "";
var session = null;
var lastTimestamp = 0;
var modulPopup = "new";
var contact_object = {};
var contact_categories = "";
var dataFromDb = null;
var dateAction = new Array();
var myNewContactFunctions = null;
var clickedItemForSave = "";
var contactTreeLoaded = false;
var tmp_attachment = null;
var treeVisible = false;
var miniBirthdayVisible = false;
var miniAnniversaryVisible = false;
var configGetKey = corewindow.configGetKey;
var configSetKey = corewindow.configSetKey;
var configContainsKey = corewindow.configContainsKey;
var optFolderState = corewindow.optFolderState;
var bAttachmentGridCreated = false;
var newContactId = 0;
var messageOnCancel = false;
var birthdayCalendar = null;
var anniversaryCalendar = null;
var savePending = false;
var newContactFolderTree = null;

var tmp_attachmentDialog = null;
var messageCloseWindow = _("Do you really want to discard your changes and close the window?");

function setContactsNewTimeStampByAtt(arg)
{
	lastTimestamp = arg;
}
/********************************** before on unload *****************************************************************/
function unloadMessage(){
    return messageCloseWindow;
}

function setBeforeUnload(on){
    window.onbeforeunload = (on) ? unloadMessage : null;
    messageOnCancel = on;
}

/********************************** Init *****************************************************************/
function initAttachmentsGrid() {
	tmp_attachment = new attachmentGrid("attachmentsNewContactGrid", (url.id || false),
			 clickedItemForSave , 7, tmp_attachmentDialog);	
}

function NewContactFunctions() {
	this.salutationComboBox = null;
	this.cardColumns = (Math.min(Math.ceil(corewindow.countContactCards / 4)));
	this.imageExist = false;
	this.deleteImageOnServer = false;
	this.searchPath = "";
	this.searchAlreadyActivated = false;
}

NewContactFunctions.prototype = {
	deletePicture: function() {		
		if(myNewContactFunctions.imageExist) {
			removeChildNodes($('imageContactTd'));	
			$('imageContactTd').appendChild(newnode("div", 0, {className : "contactDummyImage border-color-design"}, [newnode("img", 0, { src : getFullImgSrc("img/contacts/dummypicture.gif")})]));
			contact_object.image1 = "";
			this.deleteImageOnServer = true;
		} else {
			$("contactUploadImage").reset();
		}
	},	
	applyUploadImage: function() {		
		$('contact_upload_image').style.display = "none";
		ox.api.setModal(false);
//		hideNode("modal-dialog");
//        $("modal-dialog").style.display="none"; 
		if(document.getElementById("image1").value != "" && document.getElementById("image1").value != myNewContactFunctions.searchPath) 
			triggerEvent("OX_New_Info",4,_("Your selected picture will be displayed after saving"));
	},	
	cancelUploadImage: function() {
		if(document.getElementById("image1").value != "" && document.getElementById("image1").value != myNewContactFunctions.searchPath) {
			document.getElementById("image1").value = "";
			$("contactUploadImage").reset();
		}
		$('contact_upload_image').style.display = "none";
		ox.api.setModal(false);
//		hideNode("modal-dialog");
//        $("modal-dialog").style.display="none";
	},
	addPicutre: function() {
	    ox.api.setModal(true);
//		showNode("modal-dialog");
//		$('modal-dialog').style.display = "block";        
		centerPopupWindow($('contact_upload_image'));
		$('contact_upload_image').style.display = "block";
		if(document.getElementById("image1").value != "") {
			myNewContactFunctions.searchPath = document.getElementById("image1").value;
			myNewContactFunctions.searchAlreadyActivated = true;
		} else {
			myNewContactFunctions.searchAlreadyActivated = false;
		}
	},	
	closeWindow : function() {
		function cbyes() {
			window.onbeforeunload=null;
			ox.api.window.close(url.guid);
		}
		if(messageOnCancel)
			newConfirm(_("Close Window"),_(messageCloseWindow),AlertPopup.YESNO,null,null,cbyes,null);	
		else
			cbyes();
	},
	initCategories: function() {		
		// add click on categories button
		addDOMEvent($("newcontact_categories_button"), "click", function(e) {
			myNewContactFunctions.openCategoriesDialog();
		});
		
		// handle dbl click which attachs an inplace input field to div
		addDOMEvent($("newcontact_categories_list"), "dblclick", function(e) {
			ox.categories.ui.attachInplaceInput($("newcontact_categories_list"),
				function(value) {				
					// handle value
					var list = clone(ox.categories.getByString(contact_categories, ox.categories.match.ALL, true));
					// add only if not empty!
					if (value && trimStr(value).length && !ox.categories.utils.existsInObject(trimStr(value), list)) {
						var category = { name: value, color: 0 };
						list.push(category);
						contact_categories = ox.categories.utils.paramToString(list, "name");				
					}
					ox.categories.ui.drawCategoriesList(
							ox.categories.getByString(contact_categories), 
							$("newcontact_categories_list"));
				}
			);		
		});		
	},
	openCategoriesDialog: function() {
		ox.categories.ui.open((contact_categories || ""), function(list, str) {
			contact_categories = str;
			ox.categories.ui.drawCategoriesList(ox.categories.getByString(contact_categories), 
					$("newcontact_categories_list"));
		});
	},
	folderPath : function() {
		if(!clickedItemForSave || clickedItemForSave=="null")
				clickedItemForSave = corewindow.configGetKey("folder.contacts");
		oMainFolderTree.cache.get_folder(clickedItemForSave,function (ofolder){			
			if(ofolder.oxfolder.data.type != 1){
				$("newcontact_personal_tr").style.visibility = "hidden";
			} else {
				$("newcontact_personal_tr").style.visibility = "visible";
			}
			
			
			var nPermission = checkPermission(ofolder);
			
			oMainFolderTree.get_folder_path(clickedItemForSave, cb_getpath);
			var folderViewSettingsNewContact = new Object();
			var folderViewSettingsNewContactById = new Object();
			//Disable Email... 
			folderViewSettingsNewContact["mail"] = 4;
			folderViewSettingsNewContactById["default"] = 4;
			folderViewSettingsNewContact["contacts"] = 8;
			folderViewSettingsNewContact["calendar"] = 4;
			folderViewSettingsNewContact["tasks"] = 4;
			folderViewSettingsNewContact["infostore"] = 4;
			if(!contactTreeLoaded){
				newContactFolderTree = new cFolderTree(	$('folder_tree_info'),
												folderAction,										
												false,
												oMainFolderTree.cache,
												optFolderState.getState('folder_tree_info'));
				newContactFolderTree.enabled_modules = {contacts:true};										
	
				newContactFolderTree.load();
				contactTreeLoaded = true;
				newContactFolderTree.setSaveConfiguration(optFolderState);				
			}									
		});
	}
}
function checkPermission(oFolderPermissions) {
	var oPermissions = oFolderPermissions.oxfolder.data.own_rights;
	var nPermission = getPermAsString(true, oPermissions, 0).bit;
	return nPermission;
}

function cb_getpath(sPath)
{
	document.getElementsByName('newcontact_folder')[0].value = sPath;
}	

function folderAction(ofolder) {
	toggleTree();
	clickedItemForSave = ofolder.oxfolder.data.id;
	newContactFolderTree.get_folder_path(clickedItemForSave, cb_getpath);

}

function showTree(){
	$("treeDialogNewContact").style.display = "block";

}
function hideTree(){
	$("treeDialogNewContact").style.display = "none";	
}

function toggleTree(){
	if(newContactFolderTree == null)
	{
		myNewContactFunctions.folderPath();
	}
	if(!treeVisible){
		$("treeDialogNewContact").style.display = "block";
		treeVisible = true;

	}
	else{
		$("treeDialogNewContact").style.display = "none";
		treeVisible = false;
	}
}

/**
 * init() onLoad
 */
function newContactOnload() {
	activemodule="contact_new";	
	initContents("contact_new");
	initAll();
	
	var themeStyle = corewindow.oxThemeStyle || { name: "Default", path: "default" };
    removeCSSFilesForNewWindow(themeStyle.path);
	loadCSSFileForNewWindow("themes/"+themeStyle.path+"/css/popup.css");
	
	window.setTimeout(function() {
		initContactContent();
	}, 0);
	
	
	
}
//register("Loaded",initContactContent);
var internalCache = corewindow.internalCache;
var configContainsKey = corewindow.configContainsKey;
var	configGetKey = corewindow.configGetKey;
var	configSetKey = corewindow.configSetKey;
var oMainFolderTree = corewindow.oMainFolderTree;

function initContactContent() {	
	// extend url object
	url = jQuery.extend((url || {}), ox.api.window.getData(url.guid));
	
	// fixed extended fu.ck3l, don't use german vars
	url.module = url.modul || "new";
	
	// instance is required now
	myNewContactFunctions = new NewContactFunctions();
	
	clickedItemForSave = url.folder || configGetKey("folder.contacts");
	session = corewindow.session;
	activemoduleLocal = corewindow.activemodule;
	setModulPopup();
	activefolderLocal =	url.folder;
		
	addOnClose($("contact_upload_image"), myNewContactFunctions.cancelUploadImage);
		
	register("OX_SAVE_OBJECT", saveContact);	
	register("OX_Cancel_Object", function() {
		myNewContactFunctions.closeWindow()
	});	
		
	loadingComplete();
	
	function callMeOnOK(parameter) {
		tmp_attachment.updateGrid(parameter);
	}
	tmp_attachmentDialog = new attachmentDialog(0,callMeOnOK); 
	triggerEvent("OX_menu_Change_Height",true);
	
	// register keydown and mouseover for the autfill of the display name
	addDOMEvent($("last_name"), "keyup", autofillDN);
	addDOMEvent($("first_name"), "keyup", autofillDN);			
	addDOMEvent($("last_name"), "mouseout", autofillDN);
	addDOMEvent($("first_name"), "mouseout", autofillDN);
	
	if (clickedItemForSave == 6) {
		$("email1").disabled = true;
		$("email1").removeAttribute("onkeydown");
	}
	
	myNewContactFunctions.initCategories();
	
	window.setTimeout(function() {
		  oMainFolderTree.get_folder_path(clickedItemForSave, cb_getpath);		
	   },0);	
    setTabLists(tabsList, panelsList, eventList);
    window.setTimeout(function() {
            triggerEvent("OX_Switch_View","contact_new/business");
        },0);     
}

function callback_new(arg) {
	if(savePending) savePending = false;
	if(arg.error)
	{
		document.getElementById("contactUploadImage").reset();
		newServerError(arg);
	}
	else
	{
		newContactId = arg.data.id;
		if(document.getElementById('image1')) {
            myNewContactFunctions.new_contains_image1 = $("image1").value ? 1 : 0;
            document.getElementById('image1').value = "";
        }
		if (tmp_attachmentDialog.attach_changed()) 
		{
			var obj = new Object();
			obj['attached'] = newContactId;
			obj['module'] = 7; 				
			obj['folder'] = clickedItemForSave;
			tmp_attachmentDialog.do_post(obj,finalFunction);
		} else
			finalFunction();
	}	
}

function callback_update(arg)
{
	if(savePending) savePending = false;
	if(arg.error)
	{
		document.getElementById("contactUploadImage").reset();
		newServerError(arg);
	}
	else
	{
		if(document.getElementById('image1')) {
            myNewContactFunctions.new_contains_image1 = $("image1").value ? 1 : 0;
			document.getElementById('image1').value = "";
        }
		if (tmp_attachmentDialog.attach_changed()) 
		{
			var obj = new Object();
			obj['attached'] = contactDetailId;
			obj['module'] = 7; 				
			obj['folder'] = clickedItemForSave;
			tmp_attachmentDialog.do_post(obj,finalFunction);
		} else
			finalFunction();
	}
}

/********************************** Datepicker *****************************************************************/

function createMiniCalendar(){
	birthdayCalendar = new cMiniCalendar(	$("birthday_header"), 
										$("birthday_container"), 
										setBirthday,
										false,
										"id_birthday",
										$("birthday_header_month"),
										$("birthday_header_year"));
										
	anniversaryCalendar = new cMiniCalendar(	$("anniversary_header"), 
										$("anniversary_container"), 
										setAnniversary,
										false,
										"id_anniversary",
										$("anniversary_header_month"),
										$("anniversary_header_year"));
}

function setBirthday() {
	var tmp = $("contactForm");
	birthdayCalendar.setSelected(this.id);
	tmp.birthday.value = formatDate(birthdayCalendar.selectedTime, "date");
	$("mini_birthday").style.display = "none";
	miniBirthdayVisible = false;
	enableBirthdayAppointment();
}

function showMiniBirthday(){
	var tmp = $("mini_birthday");
	tmp.style.display = "block";
	tmp.left = 0;
	tmp.top = "1.6em";	
}

function toggleMiniBirthday(){
	var tmp = $("mini_birthday");
	tmp.left = 0;
	tmp.top = "1.6em";	
	if(!miniBirthdayVisible){
		if(miniAnniversaryVisible){
			$("mini_anniversary").style.display = "none";
			miniAnniversaryVisible = false;
		}
		var birthday_date = parseDateString($("birthday").value, "date");
		if(birthday_date) {
			birthdayCalendar.setSelectedByDate(birthday_date.getUTCFullYear(),
											birthday_date.getUTCMonth(),
											birthday_date.getUTCDate());
		} else {
			birthdayCalendar.setUnselected();
		}
		tmp.style.display = "block";
		miniBirthdayVisible = true;
	} else {
		tmp.style.display = "none";
		miniBirthdayVisible = false;
	}
}

var bDayObj = new Object();
var bDaySubmit = false;
/**
 * checks if we have all information and enables/disables the create birthday
 * appointment button/image
 */
function enableBirthdayAppointment() {
	var img = getFullImgSrc("img/menu/add_appointment_d.gif");
	var cursor = "default";
	if (parseDateString($("birthday").value, "date") != null
	    && trimStr($("display_name").value).length != 0) {
	   img=getFullImgSrc("img/menu/add_appointment.gif");
	   cursor = "pointer";
	}
	if ($("mini_calender_add_appointment_img").src != img) {
		$("mini_calender_add_appointment_img").src=img;
		$("mini_calender_add_appointment_img").style.cursor=cursor;
	}
}

/**
 * handles the birthday appointment dialog
 */
function createBirthdayAppointment() {
	var bday = parseDateString($("birthday").value, "date");
	if (!bday || bDaySubmit) return;
	bday.setUTCFullYear(new Date().getFullYear());
	bday.setUTCHours(bday.getUTCHours());
    bday.setUTCMinutes(bday.getUTCMinutes());    
	
    var jparam = "?action=new";
	if (bDayObj["id"]) {
		jparam = "?action=update";
		jparam += "&id=" + bDayObj["id"];		
		jparam += "&timestamp=" + bDayObj["timestamp"];		
	}
	jparam+="&folder=" + configGetKey("folder.calendar");

    bDayObj["folder_id"] = configGetKey("folder.calendar");
	bDayObj["start_date"] = Date.UTC(bday.getUTCFullYear(), bday.getUTCMonth(), bday.getUTCDate(), 0, 0, 0);
	bDayObj["end_date"] = Date.UTC(bday.getUTCFullYear(), bday.getUTCMonth(), bday.getUTCDate(), 0, 0, 0);
	//#. New contact window: Used to create a pre-filled title at the new birthday appointment dialog  
	//#. %s will be replaced with the display name of the contact
	//#, c-format
	bDayObj["title"] = format(_("Birthday of %s."), $("display_name").value);
	bDayObj["full_time"] = true;
	if (bDayObj["private_flag"] == undefined) bDayObj["private_flag"] = true;
	bDayObj["shown_as"] = 4;
	bDayObj["alarm"] = 1440;
	bDayObj["recurrence_type"] = 4;
	bDayObj["day_in_month"] = bday.getDate();
	bDayObj["month"] = bday.getMonth();
	bDayObj["interval"] = 1;
	
	var ap_titleInp = newnode("input", { width:"75%" }, { type:"text", value:bDayObj["title"] });
	var ap_privCbk  = newnode("input", { paddingRight:"15px" }, { type:"checkbox", checked:bDayObj["private_flag"], className:"noborder" });
		
	var myDiv = newnode("div", { lineHeight:"1.8em", verticalAlign:"middle" }, null,
           [ newnode("span", null, null, [ 
                    document.createTextNode(_("Would you like to create the following birthday series appointment?"))]),
             newnode("div", { width:"98%"  }, null, [ 
                    newnode("span", { paddingRight:"15px" }, null, [ document.createTextNode(pgettext("description", "Title:")) ]),
                    ap_titleInp]), 
             newnode("div", { width:"98%" }, null, [ ap_privCbk, 
                    newnode("span", { paddingLeft:"10px" }, null, [ document.createTextNode(_("Private appointment")) ])
                    ])           
           ]);
	
	function cb_Ok() {
		bDayObj["title"] = ap_titleInp.value;
		bDayObj["private_flag"] = ap_privCbk.checked;
	    bDaySubmit = true;
	    new JSON().put(AjaxRoot + "/calendar" + jparam + "&session=" + session, bDayObj, null, function(cb) {     
	        if (cb.data && !cb.error) {
	            var resp = _("Birthday appointment has been created."); /*i18n*/
	            if (bDayObj["id"])
	                 resp = _("Birthday appointment has been changed."); /*i18n*/
	            bDayObj["id"]=cb.data.id;
	            bDayObj["timestamp"]=cb.timestamp;
	            triggerEvent("OX_New_Info",4,resp);         
	        }
	        bDaySubmit = false;
	    }); 
	}
	
	newConfirm(_("Birthday Appointment") /*i18n*/, null, AlertPopup.OKCANCEL, 
	       cb_Ok, function() { return; }, null, null, null, null, null, 
	       null, null, myDiv);

	if (IE6) setTimeout(function() { ap_privCbk.checked=bDayObj["private_flag"]; }, 0);
	
}

function setAnniversary(){
	var tmp = $("contactForm");
	anniversaryCalendar.setSelected(this.id);

	tmp.anniversary.value = formatDate(anniversaryCalendar.selectedTime, "date");
	$("mini_anniversary").style.display = "none";
	miniAnniversaryVisible = false;
}

function showMiniAnniversary(){
	var tmp = $("mini_anniversary");
	tmp.style.display = "block";
	tmp.left = 0;
	tmp.top = "1.6em";	
}

function toggleMiniAnniversary(){
	var tmp = $("mini_anniversary");
	tmp.left = 0;
	tmp.top = "1.6em";	
	if(!miniAnniversaryVisible){
		if(miniBirthdayVisible){
			$("mini_birthday").style.display = "none";
			miniBirthdayVisible = false;
		}
		var anniversary_date = parseDateString($("anniversary").value, "date");
		if(anniversary_date) {
			anniversaryCalendar.setSelectedByDate(anniversary_date.getUTCFullYear(),
											anniversary_date.getUTCMonth(),
											anniversary_date.getUTCDate());
		} else {
			anniversaryCalendar.setUnselected();
		}
		tmp.style.display = "block";
		miniAnniversaryVisible = true;
	} else {
		tmp.style.display = "none";
		miniAnniversaryVisible = false;
	}
}

var autofillmatch = true;
function autofillDN() {
	var dn = $("display_name");
	var ln = $("last_name").value;
	var fn = $("first_name").value;
	if (dn.value == "" || autofillmatch) {
		dn.value = ln + (fn && ln ? ", " : "") + fn;
		editContact(dn);
	}
}

function autofillDN_turn_off(e) {
	if (!e) e = window.event;
	// turn off autocomplete only if characters are entered
	// ignores control, alt, shift, tab, etc.
	if (e.keyCode >= 32) autofillmatch = false;
}

/********************************** Save Contact *****************************************************************/
/**
 * triggerEvent -> save Button
 * switch: new, edit, dublicate, newmember
 */
function saveContact()
{
	if(savePending) return;
	else savePending = true;
	
	if(modulPopup == "new" || modulPopup == "duplicate") {
		writeNewContact();
	} else if(modulPopup == "edit") {
        /********************************** update Contact ********************************************************/	
		var ct = $("contactForm");
		//check if Birthday changed
		if(!checkDateFormat("birthday") || !checkDateFormat("anniversary")) {
			savePending = false;
			return;
		}
			
		var date = $("birthday").value;
		if (date) {
		    var d = parseDateString(date);
		    if (d) contact_object.birthday = d.getTime();
		} else if (dataFromDb.data.birthday != null) {
		    contact_object.birthday = null;
		}

		//check if anniversary changed
		date = $("anniversary").value;
		if (date) {
            var d = parseDateString(date);
            if (d) contact_object.anniversary = d.getTime();
        } else if (dataFromDb.data.anniversary != null) {
            contact_object.anniversary = null;
        }
		
		for (i=0; i<ct.elements.length; i++) {
			if(ct.elements[i].value != "" && ct.elements[i].name != "")	{
				if(ct.elements[i].name != "anniversary" && ct.elements[i].name != "birthday" && ct.elements[i].name.indexOf("newcontact_") == -1)
					contact_object[ct.elements[i].name] = ct.elements[i].value;
			}				
		}
		
		if (typeof(contact_categories) != "undefined") {
			contact_object.categories = contact_categories;
		}
				
		if (activefolderLocal != clickedItemForSave) {
			contact_object.folder_id = clickedItemForSave;
		}
		
		if($('newcontact_personal').checked && ($("newcontact_personal_tr").style.visibility == "visible" || $("newcontact_personal_tr").style.visibility == "")) 
		{
			contact_object.private_flag = true;
		} else {
			contact_object.private_flag = false;
		}
		
		checkModified(dataFromDb.data, contact_object)
		
		if($("image1").value != "" || myNewContactFunctions.deleteImageOnServer) {
				with 	($('contactUploadImage')) 
				{					
						action = AjaxRoot + "/contacts?action=update&session=" + session + "&id="+contactDetailId+"&folder="+activefolderLocal+"&timestamp="+lastTimestamp+ "&time=" + new Date().getTime();		
						json.value = JSON.serialize(contact_object);		
						submit();
				}
			}
		else {
			json.put(AjaxRoot + "/contacts?action=update&session=" + session + "&id="+contactDetailId+"&folder="+activefolderLocal+"&timestamp="+lastTimestamp, 
				contact_object, 
				null, 
				function(updatedFields)
				{	
					if(updatedFields) {
						if(updatedFields.error) {
							//error
						} else {

							if (tmp_attachmentDialog.attach_changed()) 
							{
								var obj = new Object();
								obj['attached'] = contactDetailId;
								obj['module'] = 7; 				
								obj['folder'] = clickedItemForSave;
								tmp_attachmentDialog.do_post(obj,finalFunction);
							}
							else {
								finalFunction();
							}
						}
					}
				}
			);
		}
		
	}
}


/*
 * use the global function to get a Date Object
 * returns the long from this dateobject
 * */

function formatDateToUTC(formDate) {
	var longTime = parseDateString(formDate);
	if(longTime == null)
		return longTime
	else
		return longTime.getTime();
}


/**
 * Help function for compare two Dates in m/d/y 
 * @param {string} Date in m/d/y  
 * @param {string} Date in m/d/y  
 * @param {string} name of the field  
 */
function compareDate(formDate, dbDate, labelDate)
{
	dateAction[0] = "";
	dateAction[1] = "";
	
	if(formDate != "") {
		
		var UTCformated = formatDateToUTC(formDate);
		if (UTCformated == 0) UTCformated = 1; // 0 -> fix for 01.01.1970
		dateAction[1] = UTCformated;	
		if(!UTCformated || UTCformated == "") { 
			dateAction[0] = "error";
		}
		else if(UTCformated != dbDate) {
			dateAction[0] = "save";
		} 
		else if(contact_object[labelDate]) {
			dateAction[0] = "save";
		}
	} 
	else if(dbDate != "") {
		dateAction[0] = "clear";
	}
	return dateAction;
}

/********************************** Contact Obj for Update *****************************************************************/
/**
 * If Modus is 'edit', the json objekt (contact_object) will be created for Update DB, whith changed fields
 */
var myKeyTimeout = null;
function editContact(field) {	
	if(myKeyTimeout) {
		clearTimeout(myKeyTimeout);
	}
	myKeyTimeout = setTimeout(
		function() {
			switch(modulPopup) {
			
				case "edit" 		:		if(dataFromDb && document.getElementsByName(field.name)[0] && document.getElementsByName(field.name)[0].value != dataFromDb.data[field.name]) {	
												contact_object[field.name] = document.getElementsByName(field.name)[0].value || "";
												setBeforeUnload(true);
											}
											break;
							
				case "duplicate" 	:		if(dataFromDb && document.getElementsByName(field.name)[0] && document.getElementsByName(field.name)[0].value != dataFromDb.data[field.name]) {	
												setBeforeUnload(true);
											}
											break;
											
				case "new" 	:		if(document.getElementsByName(field.name)[0] && document.getElementsByName(field.name)[0].value != "") {	
												setBeforeUnload(true);
											}
											break;
				
			}
		},200
	)
}

function checkDateFormat(field) {
	var valueDate = $(field).value;
	if(valueDate != "") {
		var checkedDate = formatDateToUTC(valueDate);
		if((!checkedDate || checkedDate == "") && checkedDate != 0) { // !=0 -> fix for 01.01.1970
			triggerEvent("OX_New_Error", 4, _("Invalid date format. The valid format is dd.mm.yyyy"));		
			$(field).className = $(field).className + "borderColorError"; 
			return checkedDate;
		} else {
			$(field).className = $(field).className + "border-color-default";
			return true;
		}
	} else {
		$(field).className = $(field).className + "border-color-default";
		return true;
	}
}

/********************************** set var Module *****************************************************************/
/**
 * Init Popup for setting the Modul
 * @param {String} parameters from the url 
 */
function setModulPopup(params) {
	clickedItemForSave= trimStr(url.folder) || configGetKey("folder.contacts");
	
	// new
	if (url.module == "new") {
		fillFields(url);
        autofillDN();
        // disable loading screen
        $("loading_data_bg").style.display="none";
	} else {
		// edit or duplicate
		modulPopup = url.module;
		contactDetailId = url.id;
		activefolder = url.folder;
		session = url.session;
		currentView = url.currentView;
		fillFieldById();
	}
}

/********************************** get ContactById *****************************************************************/

/**
 * fill the Fields which comes from DB 
 * id is a Param in the url, see {@link setModulPopup}
 */
function fillFieldById()
{
	new JSON().get(AjaxRoot + "/contacts?action=get&session=" + session +"&id="+contactDetailId+"&folder="+clickedItemForSave+"&"
		,
		null,
			function(reply) {
				dataFromDb = reply;
				fillFields(reply.data);
				lastTimestamp = reply.timestamp;
				// disable loading screen
                $("loading_data_bg").style.display="none";
			}
		); 		
}

function fillFields(data) {
    for (field in data) {
        if(document.getElementsByName(field)[0] && data[field] != "") {
            document.getElementsByName(field)[0].value = data[field];
        }
        
        if(field=="birthday")
        {
            $("birthday").value = formatDate(data[field],"date");
        }
        if(field=="anniversary")
        {
            $("anniversary").value = formatDate(data[field],"date");
        }
        
        if(field=="number_of_attachments")
        {
            if (url.module == "duplicate")
                setContactsNewNumberOfAtt(0);
            else
                setContactsNewNumberOfAtt(data.number_of_attachments);
        }
        
        if(field=="private_flag" && data[field] == true) {
            $("newcontact_personal").checked = "checked";
        }
        
        if(field=="disribution_list")
        {
            if(data[field] && data[field].length > 0) {
                
                if(myDistrListAdressBook) {
                    
                    myDistrListAdressBook.findContactForDistrList       = {};
                    myDistrListAdressBook.findContactForDistrList.data  = new Array();
                    
                    for(i=0; i<data[field].length;i++){
                        myDistrListAdressBook.findContactForDistrList.data[i] =
                            [data[field][i].id, data[field][i].display_name,
                             data[field][i].mail];
                        myDistrListAdressBook.tmpIdsForSave[i] =
                            data[field][i].id; //ID
                    }
                }
            }
        }
        /* if an image is existing */
        if (field == "number_of_images" && data[field] > 0 && url.module != "duplicate") {
            myNewContactFunctions.imageExist = true;
            removeChildNodes($('imageContactTd'));
            $('imageContactTd').appendChild(newnode("img", 0, {src: data.image1_url + "&random=" + new Date().getTime(), alt: ""}));
        }
    }
    if (data["categories"]) {
        contact_categories = data["categories"];
        // draw list
        if ($("newcontact_categories_list")) {
            ox.categories.ui.drawCategoriesList(ox.categories.getByString(contact_categories),
                    $("newcontact_categories_list"));
        }
    }
    try {
        // dn autofill: check if the dn still matches                       
        var fn = data.first_name || "";
        var ln = data.last_name || "";
        var dn = data.display_name || "";
        autofillmatch = (dn == (ln + (fn && ln ? ", " : "") + fn));
    } catch (e) { }
}

function setContactsNewNumberOfAtt(nNumAttParam) {
	$('contact_number_of_attachments').firstChild.nodeValue = nNumAttParam;
}

/**
 * Validation email
 * @param {string} email for validation
 * @return {boolean} true if is valid
 */
function checkEmailAdr(feld) {
	var supported = 0;
	if (window.RegExp) {
		var tempStr = "a";
		var tempReg = new RegExp(tempStr);
		if (tempReg.test(tempStr)) supported = 1;
	}
	if (!supported)
		return (feld.indexOf(".") > 2) && (feld.indexOf("@") > 0);
		
		var r1 = new RegExp("(@.*@)|(\\.\\.)|(@\\.)|(^\\.)");
		var r2 = new RegExp("^.+\\@(\\[?)[a-zA-Z0-9\\-\\.]+\\.([a-zA-Z]{2,4}|[0-9]{1,3})(\\]?)$");
		return (!r1.test(feld) && r2.test(feld));
}

/********************************** Write new Contact *****************************************************************/
/**
 * Write all filled fields in DB
 * json.put -> contact_object
 */
 
function writeNewContact()
{
	var ct = $("contactForm");	
	contact_object = {};
	//Convert Date to UTC
	var datepart = "";
	
	var birthdayData = $("birthday").value;
	
	var birthdayUTC = "";
	
	if(birthdayData != "") {
		birthdayUTC = formatDateToUTC(birthdayData);
		if(!birthdayUTC || birthdayUTC != "") {
			contact_object.birthday = birthdayUTC;
		}		
	}
	
	var anniversaryData = $("anniversary").value;
	var anniversaryUTC = "";
	if(anniversaryData != "") 
	{
		anniversaryUTC = formatDateToUTC(anniversaryData);
		
		if(!anniversaryUTC || anniversaryUTC != "") {
			contact_object.anniversary = anniversaryUTC;
		}		
	}
	
	var privatEmailData = ct.email1.value;
		
	for (i=0; i<ct.elements.length; i++) {
		if(ct.elements[i].value != "" && ct.elements[i].name != "")	{
			if(ct.elements[i].name != "anniversary" && ct.elements[i].name != "birthday" && ct.elements[i].name.indexOf("newcontact_") == -1)
				contact_object[ct.elements[i].name] = ct.elements[i].value;
		}				
	}
	contact_object.folder_id = activefolderLocal;

	if (contact_categories) {
		contact_object.categories = contact_categories;
	}
	
	if (activefolderLocal != clickedItemForSave) {
		contact_object.folder_id = clickedItemForSave;
	}
	
	if($('newcontact_personal').checked && ($("newcontact_personal_tr").style.visibility == "visible" || $("newcontact_personal_tr").style.visibility == "")) {
		contact_object.private_flag = true;
	} else {
		contact_object.private_flag = false;
	}
	
	if(document.getElementById("image1").value != "") {	
		with (document.getElementById('contactUploadImage')) {					
			action = AjaxRoot + "/contacts?action=new&session=" + session + "&folder="+clickedItemForSave+"&timestamp="+lastTimestamp;		
			json.value = JSON.serialize(contact_object);		
			submit();
		}				
	} else {		
		json.put(AjaxRoot + "/contacts?action=new&session=" + session +"&folder="+clickedItemForSave+ "&" , contact_object, null, 
		function(idObj){
			if(idObj) {	
				newContactId = idObj.data.id;
				if (tmp_attachmentDialog.attach_changed()) {
					var obj = new Object();
					obj['attached'] = idObj.data.id;
					obj['module'] = 7; 				
					obj['folder'] = clickedItemForSave;
					tmp_attachmentDialog.do_post(obj,finalFunction);
				} else finalFunction();
			}
		});
	}

}


function finalFunction(myObject) {	
    if ("new_contains_image1" in myNewContactFunctions) {
        contact_object.contains_image1 =
            myNewContactFunctions.new_contains_image1;
    }
    if (tmp_attachmentDialog.attach_changed()) {
        contact_object.number_of_attachments =
            tmp_attachmentDialog.file_storage.ids.length;
        corewindow.triggerEvent("OX_Quota_Update");
    }
	if(modulPopup == "new" || modulPopup == "duplicate") {
       setBeforeUnload(false);
       corewindow.OXContactMapping.createObject(contact_object);
       corewindow.closeContactPopUp(window, clickedItemForSave);
    } else if(modulPopup = "edit") {
        setBeforeUnload(false);
        corewindow.OXCache.newRequest(null, "contacts", { columns: null,
            objects: [corewindow.OXContactMapping.createKeyFromObject({
                module: "contacts", folder_id: clickedItemForSave,
                id: contactDetailId
            })] }, null, emptyFunction, true);
       corewindow.closeContactPopUp(window, clickedItemForSave);
    }
	
}

/********************************** Tabs *****************************************************************/
register("OX_Contact_New_Switch",function(param) { menuswitchContactNew(param) });
/**
 * global vars for new Contact
 */
var tabsList   =	new Array('tabContact1','tabContact2', 'tabContact3', 'tabContact4', 'tabContact5', 'tabContact6' );
var panelsList = 	new Array('panelContact1','panelContact2', 'panelContact3', 'panelContact4', 'panelContact5', 'panelContact6' );
//var eventList  =	null;
var eventList =
		new Array(	['OX_Contact_New_Switch','business'],
					['OX_Contact_New_Switch','personal'],
					['OX_Contact_New_Switch','additional'],
					['OX_Contact_New_Switch','distributionlist'],
					['OX_Contact_New_Switch','attachment'],
					['OX_Contact_New_Switch','links']);
									
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2010 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * 
 */

// take care of new/edit windows. in this case the base object ox 
// doesn't exists so we have to create it
if ("ox" in window == false) {
	ox = {};
}

ox.categories = { cache: [], utils: {}, ui: { temp: {}, add: {} } };

ox.categories.setCache = function(categories) {
	ox.categories.cache = categories;
}

/**
 * Returns a list of categories available in the internal cache
 * @returns {Array} array of category objects
 */
ox.categories.list = function() {
	return ox.categories.cache;
}

/**
 * Gets a category by name
 * @param name of the category
 * @returns {object} the category object
 */
ox.categories.get = function(name) {	
	// get all categories
	var categories = ox.categories.list();
	// loop over
	for (var i=0; i<categories.length; i++) {		
		// compare case-insensitive
		if (categories[i].name.toLowerCase() == name.toLowerCase()) {
			delete(categories[i].active); // just in case
			return categories[i];
		}
	}
	return null;
}

/**
 * Checks if a category exists
 * @param the name of the category
 * @returns {object} the category object
 */
ox.categories.exists = function(name) {
	return ox.categories.get(name) ? true : false;
}

/**
 * Adds a new category to the internal cache
 * @param {String} name = the name, {int} color = the color id
 * @returns {object} the category object
 */
ox.categories.add = function(name, color) {
	name = trimStr(name);
	// do already exists or is name empty?
	if (ox.categories.exists(name) || !name.length) {
		return null;
	}
	var category = { name: name, color: (color || 0) };
	ox.categories.cache.push(category);	
	return category;
}

/**
 * Edits a category in the internal cache
 * @param {String} id = identifier of the category (likely the name), 
 * 		  {String} name = the name, {int} color = the color id
 * @returns {object} the category object
 */
ox.categories.edit = function(id, name, color) {
	name = trimStr(name || "");
	// name empty?
	if (!name.length && !ox.categories.exists(id)) {
		return null;
	}
	var category = ox.categories.get(id);
	if (category) {
		delete(category.active); // just in case
		category.name = name
		category.color = color;
	}
	return category;
}

/**
 * Removes a set of categories from the cache
 * @param {Array} an array of names which should be removed from 
 * 		  the internal cache
 */
ox.categories.remove = function(names) {
	if (typeof names != "object") {
		names = [ names ];
	}
	$l1 = names.length;
	for (var i=0; i < ox.categories.list().length; i++) {
		for (var ia=0; ia<$l1; ia++) {
			if (ox.categories.cache[i] && ox.categories.cache[i].name == names[ia]) {
				ox.categories.cache.splice(i,1);				
			}
		}
	}
}

/**
 * Saves the current categories to the users configuration
 */
ox.categories.save = function() {
	// without corewindow we have to leave
	if (!corewindow) return;
	corewindow.configuration_changed_fields["gui"] = true;
//	var cats = (ox.categories.list() || []), $l = cats.length, categories = [];
//	for (var i=0; i < $l; i++) {
//		categories.push(corewindow.clone(cats[i]));
//	}
	var categories = corewindow.clone(ox.categories.list() || [], window);
	corewindow.configSetKey("gui.categories.local", categories);	
	corewindow.triggerEvent("OX_Save_Configuration", false, true);
	
	// are we in a new/edit window? if so we are updating the cache in the 
	// corewindow. 
	// @todo: we should think about a smarter way to force an cache update at
	// the corewindow. could lead to problems if the user edit categories in the
	// corewindow at the same time!
//	if (corewindow.ox.Configuration) {
//		corewindow.ox.categories.cache = categories;
//	}
}

ox.categories.match = { ALL: 1, MATCH: 2, NON_MATCH: 4 };

ox.categories.getByString = function(names, match, noDuplicates) {	
	var list = [];
	var ids = names.split(","), $l = ids.length;
	for (var i=0; i < $l; i++) {
		var name = trimStr(ids[i]);		
		if (name != "" && (!noDuplicates || 
				!ox.categories.utils.existsInObject(name, list))) {
			var cat = ox.categories.get(name);
			switch (match) {
				case 4:
					if (!cat) list.push({ name: name, color: 0 });
					break;
				case 2:
					if (cat == null) break;
					/* no break */
				default:
					list.push(cat || { name: name, color: 0 });
					break;
			}
		}
	}
//	list.sort(function(a,b) {
//		return (a.color < b.color ? 1 : -1);
//	});
	return list;
}

/**
 * Removes the given category out of the comma separated list of categories
 * @param {String} the name of the category which should be removed
 * @param {String} comma separated list of categories
 * @returns {String} a new list without the given category. note: any duplicated
 * 		    category will be filtered out as well!
 */
ox.categories.removeCategoryFromString = function(name, categories) {
	var cats = ox.categories.getByString(categories, ox.categories.match.ALL, true);
	var retVal = "";
	for (var i=0; i < cats.length; i++) {
		if (cats[i].name !== name) {
			retVal += cats[i].name + (i+1 < cats.length ? ", " : "");
		}
	}
	return retVal;
}

/**
 * Gets the first category from cache matching with one of the 
 * categories of the given string.
 * @param {String} single category name or likely a comma separated 
 * 		  list of categories 
 */
ox.categories.getFirstMatch = function(str) {
	var ids = (str || "").split(/,/);
	var i = 0, $l = ids.length;
	// loop over names
	for (; i < $l; i++) {
		var id = trimStr(ids[i]);
		if (ox.categories.exists(id)) {			
			return ox.categories.get(id); // match!
		}
	}	
	return { name: "", color: 0 }; // no match
}


/*** Categories Selection Dialog ***/

ox.categories.ui.open = function(tags, cb) {	
	var grid, color, tags = (tags || "");	
	ox.categories.ui.final_cb = cb;	
	
	// initiate grid
	if (!ox.categories.ui.grid) {		
		ox.categories.ui._initGrid();
		
		// add handler on delete button
		addDOMEvent($("categories_sel_but_delete-button"), "click", function(e) {
			var ids = ox.categories.ui.grid.selection.getSelected();
			if (ids && ids.length) {
				ox.categories.ui.temp.changed = true;
				ox.categories.ui.grid.storage.removeIDs(ids);
			}
			return false;
		});
		
		// add handler on rename button
		addDOMEvent($("categories_sel_but_rename-button"), "click", function(e) {
			var ids = ox.categories.ui.grid.selection.getSelected();
			if (ids && ids.length == 1) {
				var inplace, self = this;
				var node = ox.categories.ui.grid.rows[ox.categories.ui.grid.focus].cells[2];
				if (!node || !node.firstChild) return;
				inplace = new inplaceEdit(
						node, 
						node.firstChild.data, 
						function(new_name) {
							ox.categories.ui.grid.storage.localUpdate(ids, function(index, object) {
								if (object.name != new_name) {
									ox.categories.ui.temp.changed = true;
									object.name = new_name;
								}
								return object;
							});
							delete(self.inplace);
						}
				);
				inplace.style.border = "1px black dotted";
				inplace.style.background = "white";
				inplace.on();
				cancelBubbling(e);
			}
			return false;
		});	
		
		// add handler on new button
		addDOMEvent($("categories_sel_but_new-button"), "click", function(e) {
			ox.categories.ui.add.open(null, function(category) {
				//does it exists in cache or in the grid? then return
				if (!category || ox.categories.exists(category.name) || 
						ox.categories.ui.grid.storage.indices[category.name]) return;
				category.active = true;
				ox.categories.ui.grid.storage.append([category]); // append to grid
				if (category.color != 0) {
					ox.categories.ui.temp.changed = true;
				}
			});
		});
	}
	
	// initiate color selection combo
	if (!ox.categories.ui.color) {
		var color = ox.categories.ui.getColorSelect();
		// color change event
		color.onChange = function(new_color, color_before) {
			var ids = ox.categories.ui.grid.selection.getSelected();
			// anything selected and new color is not 0
			if (ids && ids.length && new_color != 0) {
				// updating grid storage
				ox.categories.ui.grid.storage.localUpdate(ids, function(index, object) {
					if (object.color != new_color) {
						object.color = new_color;
						if (new_color != 0) {
							ox.categories.ui.temp.changed = true;
						}
					}
					return object;
				});		
			} else if (new_color == 0) {
				// if color is 0 reset to the color before
				color.setKey(color_before, true);
			}
	    };
		ox.categories.ui.color = color;
		$("categories_sel_color").appendChild(color.getDomNode());
	}
	// enable grid with storage
	grid = ox.categories.ui.grid;
	grid.enable(new Storage(0, [], 0, 0, 0, 0, function(data) { return data.name; }));
	//grid.storage.remove(0, grid.storage.ids.length);

	// find matching categories by the given list and mark them as selected
	var mCat = clone(ox.categories.getByString(tags, ox.categories.match.MATCH));
	var lCat = clone(ox.categories.list()), $l = lCat.length, $la = mCat.length;
	for (var i=0; i < $l; i++) {
		var t_cat = lCat[i];
		for (var ia=0; ia < $la; ia++) {
			var t_cat2 = mCat[ia];
			if (t_cat.name == t_cat2.name) {
				t_cat.active = true; // mark as active
				break;
			} else {
				delete(t_cat.active); // just in case
			}
		}
	}
	
	// getting non matching categories and mark them as active
	var nCat = clone(ox.categories.getByString(tags, ox.categories.match.NON_MATCH));
	var $l = nCat.length;
	for (var i=0; i < $l; i++) {
		nCat[i].active = true;
		lCat.push(nCat[i]);
	}
	
	// append concatenated tags to grid storage
	grid.storage.append(lCat);
		
	// show dialog
	ox.api.setModal(true);
//	showNode("modal-dialog");
//	$("modal-dialog").style.display="block";
	
	showNode("disable_confirm_window");
	$("disable_confirm_window").style.display="block";
		
	showNode("window_categories");
	centerPopupWindow($("window_categories"));
	$("window_categories").style.display="block";
}

ox.categories.ui.close = function(cancel) {
	var selCat = [], finCat = [];
	// get selected categories and disable grid
	if (ox.categories.ui.grid) {
		var grid = ox.categories.ui.grid;
		// iterate through storage and get selected cats 
		grid.storage.newIterate(grid.storage.ids, emptyFunction, function(id, obj) {
			if (obj) {				
				if (obj.active) {
					selCat.push(obj);
				}
				if (obj.color != 0) {
					finCat.push(obj);
				}
				delete(obj.active); // just temp so delete
			}
		});
		grid.disable();
	}
	
	// rearrange order of categories in the way the user selected them
	var order = (ox.categories.ui.temp.clickOrder || []), $l = order.length, $la = selCat.length;
	for (var i=$l-1; i >= 0; i--) {
		for (var ia=0; ia < $la; ia++) {
			var object = selCat[ia];
			if (object.name == order[i]) {
				selCat.splice(ia,1);
				selCat.unshift(object);
			}
		}
	}
	// remove instance here to prevent a save trigger later!
	delete(ox.categories.ui.temp.clickOrder);
	
	// do we have a action or did the user just pressed cancel?
	if (!cancel) {	
		if (ox.categories.ui.temp.changed) {
			ox.categories.setCache(finCat);
			ox.categories.save();
		}
		
		// trigger given callback
		if (ox.categories.ui.final_cb) {
			ox.categories.ui.final_cb(selCat, ox.categories.utils.paramToString(selCat, "name"));
		}
	}
	// clean-up
	delete(ox.categories.ui.final_cb);
	delete(ox.categories.ui.temp);
	ox.categories.ui.temp = {};
	
	// close modal window
	if (this.closecb) { 
		globalalert.cbclose(); 
	}
	hideNode("window_categories");
	$("window_categories").style.display="none";
		
	hideNode("disable_confirm_window");
	$("disable_confirm_window").style.display="none";
	var childs=	$("modal-dialog").childNodes;
	var closeall=true;
	for(var i=0;i<childs.length;i++) {
		if(childs[i].tagName && childs[i].tagName == "DIV") {
			if(childs[i].style.display && childs[i].style.display!= "none" ) {
				closeall=false;
			}
		}
	}
	if (closeall) {
	    ox.api.setModal(false);
//		hideNode("modal-dialog");
//		$("modal-dialog").style.display="none";
	}
}

/**
 * Creates a new color combobox
 * @return {ComboBox3} object 
 */
ox.categories.ui.getColorSelect = function() {
	var ncol = new ComboBox3(window, null, "10em", 0, true, null, 7);
	for (var i=0; i<=25; i++) {
		ncol.addElement(newnode("div", 0, 
				{ className: "colorLabelCont bs ha colorLabel" + i }), i);
	}
	ncol.headTable.style.height="1.8em";
    return ncol;	
}

/*
 * Initiate a new grid for the category selection dialog
 * @private
 */
ox.categories.ui._initGrid = function() {
	// temporary store the click sequence to get the correct order 
	function changeOrder(id, action) {
		var order = (ox.categories.ui.temp.clickOrder || []), $l = order.length;
		for (var i=0; i < $l; i++) {
			if (order[i] == id) {
				order.splice(i,1);
				break;
			}
		}
		if (action) order.push(id);
		ox.categories.ui.temp.clickOrder = order;
	}
	function addCheckBox() {
	    var checkbox = newnode("input", 0, { type: "checkbox", className: "noborder" });
	    addDOMEvent(checkbox, "click", function() {
	    	// clicked on check-box 
	    	var ids = ox.categories.ui.grid.selection.getSelected();
	    	if (ids && ids.length) {
	    		// setting status in storage
	    		var obj = ox.categories.ui.grid.storage.data.data[ids[0]];
	    		if (obj.active) delete(obj.active);
	    		else obj.active = true;
	    		changeOrder(obj.name, obj.active);
	    	}
	    	return false;
	    });
	    return checkbox;
    }
	var self = this;
	var grid = new LiveGrid([
          {
			  text: "&#xa0;",
			  width: "2em",
			  style: { paddingTop: "2px" },
			  set: function(div, data) {
			        if (!div.firstChild) div.appendChild(addCheckBox());
			        div.firstChild.style.display = "";
			        div.firstChild.checked = data["active"];
			  },
			  clear: function(div) {
			        if (!div.firstChild) div.appendChild(addCheckBox());
			        div.firstChild.style.display = "none";
			  }
		  },
	      { 
	          text: "&#xa0;",
	          width: "2em",
	          clear: function(div) {
		    	  if (div.firstChild)
	                  div.firstChild.className = "";
	              else
	                  div.appendChild(
	                		  newnode("div", 0, { className: "colorLabelCont bg hb" }));
	      	  },
	          set: function(div, data) {
	              if (div.firstChild)
	                  div.firstChild.className = "colorLabelCont bg hb colorLabel"+data.color;
	              else
	                  div.appendChild(
	                		  newnode("div", 0, 
	                				  { className: "colorLabelCont bg hb colorLabel" + data.color }));
	          }
	      },
	      {
	          text: "Name",
	          i18n: true,
	          clear: LiveGrid.makeClear(""),		          
	          set: function(div, data) {        	
	              if (div.firstChild)
	                  div.firstChild.data = data.name;
	              else
	                  div.appendChild(document.createTextNode(data.name));
	          }
	      }
      ], new Selection());
	
	grid.lineHeight = 1.9;
	grid.rowHeight = 24;
	grid.emptylivegridtext = "";
	grid.events.register("Selected", function() {
    	// get selected signature
    	var ids = self.grid.selection.getSelected();    	
    	if (!ids || !ids.length) {    		
    		ox.categories.ui.color.setKey(0, true);
    	} else {    		
	    	var object = ox.categories.get(ids[0]);	    	
	    	if (ids.length && object) {
	    		ox.categories.ui.color.setKey(object.color, true);
	    	} else {	    		
	    		ox.categories.ui.color.setKey(0, true);
	    	}
    	}    	
    });
	grid.events.register("Activated", function(ids) {		
            if (ids && ids.length > 0) {
            	ox.categories.ui.grid.storage.localUpdate(ids, function(index, object) {
            		if (object.active) delete(object.active);
    	    		else object.active = true;
    	    		changeOrder(object.name, object.active);
    	    		return object;
            	});
            }
        }
    );    
    $("categories_sel_grid_header").appendChild(grid.getHeader());
	grid.getTable($("categories_sel_grid"));
	ox.categories.ui.grid = grid;
}


/*** Categories Add/Edit Dialog ***/

ox.categories.ui.add.open = function(tag, cb) {
	var color;
	ox.categories.ui.add.final_cb = cb;
	
	// init color selection
	if (!ox.categories.ui.add.color) {
		color = ox.categories.ui.getColorSelect();
		$("categories_new_color").appendChild(color.getDomNode());
		color.setKey(0);
		ox.categories.ui.add.color = color;
	} else {
		color = ox.categories.ui.add.color;
	}
	
	if (tag) {
		color.setKey(tag.color || 0);
		$("categories_new_id").value = (tag.id || tag.name || "");
		$("categories_new_name").value = (tag.name || "");
	}
	
	if (!ox.api.isModal()) {
	    ox.api.setModal(true);
//		showNode("modal-dialog");
//		$("modal-dialog").style.display="block";
		showNode("disable_confirm_window");
		$("disable_confirm_window").style.display="block";
	}
	
	showNode("window_categories_new");
	centerPopupWindow($("window_categories_new"));
	$("window_categories_new").style.display="block";
	$("categories_new_name").focus();
}

ox.categories.ui.add.close = function(cancel) {		
	if (!cancel && ox.categories.ui.add.final_cb) {
		ox.categories.ui.add.final_cb({ id: $("categories_new_id").value, 
			name: $("categories_new_name").value, color: ox.categories.ui.add.color.getKey() });
	}	
	$("categories_new_id").value = "";
	$("categories_new_name").value = "";
	ox.categories.ui.add.color.setKey(0);
	delete(ox.categories.ui.add.final_cb);
	
	if (this.closecb) { 
		globalalert.cbclose(); 
	}
	hideNode("window_categories_new");
	$("window_categories_new").style.display="none";
	// hide background only if the main selection dialog isn't visible
	if ($("window_categories") && $("window_categories").style.display == "none") {
		hideNode("disable_confirm_window");
		$("disable_confirm_window").style.display="none";
		var childs=	$("modal-dialog").childNodes;
		var closeall=true;
		for (var i=0; i < childs.length; i++) {
			if (childs[i].tagName && childs[i].tagName == "DIV") {
				if (childs[i].style.display && childs[i].style.display!= "none" ) {
					closeall=false;
				}
			}
		}
		if (closeall) {
		    ox.api.setModal(false);
//			hideNode("modal-dialog");
//			$("modal-dialog").style.display="none";
		}
	}
}

/*
 * draws a list of category divs to a given DOM node
 * @param {Array} list of category objects
 * @param {DOM} node to attach category divs
 * @param {Boolean} true = show just only color divs, without names
 */
ox.categories.ui.drawCategoriesList = function(categories, node, withoutNames) {
	var $l = categories.length;
	removeChildNodes(node);
	var cNode = newnode("div", { flt: "left", border: "1px solid #c0c0c0", minHeight: "10px",
		padding: "0 4px 0 4px", margin: "1px 1px 0 0" }, { className: "colorLabelCont bs" }, 
		[ newtext("\u00a0") ]);	
	for (var i=0; i < $l; i++) {
		var category = categories[i];
		var tn = cNode.cloneNode(true);		
		tn.className += " colorLabel" + category.color;
		if (!withoutNames) {
			tn.firstChild.data = category.name;
		}
		tn.title = (category.name || "");
		tn.onselectstart = function() { return false; };
		node.appendChild(tn);
	}
}

/*
 * attach an inplace input field to the given DOM node. the developer
 * needs to take care that this node got removed afterwards. the callback 
 * will be triggered as soon the user leave the element and/or hit enter
 * or esc. 
 * @param {DOM} node to attach the inplace input
 * @param {function} callback which receive the input value. if the user
 * 		  hit ESC the value will be null
 */
ox.categories.ui.attachInplaceInput = function(node, callback) {
	if (!node || !callback) return;
	var key, blur;
	var bNode = newnode("div", { flt: "left", border: "1px solid #c0c0c0", 
		padding: "0 4px 0 4px", margin: "1px 1px 0 0", MozUserSelect: "normal" }, 
		{ className: "colorLabelCont bs" });
	var input = newnode("input", { width: "15em", border: "none" });
	bNode.appendChild(input);
	node.appendChild(bNode);
	function finalCb(value) {
		removeDOMEvent(input, "blur", blur);
		removeDOMEvent(input, "keypress", key);
		callback(value);
	}
	key = function(e) {
		switch (e.keyCode || e.which) {
			// enter
			case 13:
				finalCb(input.value);
				break;
			// esc
			case 27:
				finalCb(null);
				break;
			default:
				return;
		}
		return false;
	}
	blur = function(e) {
		finalCb(input.value);
	}
	addDOMEvent(input, "blur", blur);
	addDOMEvent(input, "keypress", key);
	
	// set focus and select
	input.focus();
	input.select();
}

register("Loaded", function () {
	addOnClose($("window_categories"), function() { 
		ox.categories.ui.close(true);
	});
	addOnClose($("window_categories_new"), function() { 
		ox.categories.ui.add.close(true);
	});
	
	// need to init cache here in the new/edit windows
	if (!ox.Configuration) {
		ox.categories.setCache(clone(configGetKey("gui.categories.local"), corewindow));
	}
})

register("OX_Configuration_Loaded_Complete", function() {
	ox.categories.setCache(configGetKey("gui.categories.local"));
});

corewindow.register("OX_Configuration_Changed", function(location) {
	if ("ox" in window) {
		if (!ox.Configuration) {
			ox.categories.setCache(clone(configGetKey("gui.categories.local"), corewindow));
		} else {
			ox.categories.setCache(configGetKey("gui.categories.local"));
		}
	}
});


/*** Categories Utils ***/

ox.categories.utils.migrateTags = function() {
	var tags = (configGetKey("gui.private_categories") || "").split(","), color = 1;	
	for (var i=0; i<tags.length; i++) {
		var name = trimStr(tags[i]);
		// only add tags where name not empty and if not exists 
		if (name.length != 0 && ox.categories.exists(name) == false) {
			ox.categories.add(name, color++);
			if (color == 25) color = 1;
		}
	}
	delete(config.gui.private_categories);
	delete(config.gui.global_categories);
	ox.categories.save();
}

ox.categories.utils.paramToString = function(categories, parameter, delimeter) {
	var $l = categories.length, retVal = [];
	for (var i=0; i < $l; i++) {
		if (categories[i][parameter]) {
			retVal.push(categories[i][parameter]);
		}
	}
	return retVal.join(delimeter || ", ");
}

/**
 * Check if the given name already exists in the list of categories
 * @param {String} the name to check
 * @param {Array} list of category objects
 */
ox.categories.utils.existsInObject = function(name, categories) {
	var $l = categories.length;
	for (var i=0; i < $l; i++) {
		if (categories[i].name == name) return true;
	}
	return false;
}

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2010 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */
 
 /**
 * Inplace editing functionality.
 * @param {Object} content The DOM node which will be replaced by input tag
 * @param {Object} content The DOM node which contains editable text
 * @param {Function} which saves new text and call the update function. 
 */
function inplaceEdit(div, text, fn_save) {
	this.container_edit = div;
	this.old_content = new Array();
	this.input_elem = null;
	this.old_text = text;
	this.really_edit_check = true;
	this.style = { fontSize: "9pt", color: "black", height: "1.3em", margin: "0", padding: "0", 
			width:"100%", borderWidth: "0px", background: "transparent" };
	this.fn_save = fn_save;
	this.mode = "off";
}

inplaceEdit.prototype = {
	
	setSelection: function(bool) {
		this.container_edit.style.MozUserSelect = bool ? "text" : null;
	},

	on: function() {
		var Self = this;
		if (this.mode=="on") return;
		triggerEvent("OX_Clear_All_Edit_Lines");
		
		function save_checkTarget(event) {		
			if (Self.mode!="on" || event.target == Self.input_elem || 
			    event.srcElement == Self.input_elem) {
				return true;
			}
            save();
		}
		
	    function save(event) {
            if (Self.input_elem.value != Self.old_text || !Self.really_edit_check) {
                Self.fn_save(Self.input_elem.value);
            }
            clear_input(event);
        }
		
		function stop_click_bubbl(evtt) {
			cancelBubbling(evtt);
		}
		
	    //catch esc. event on body
        function on_key_body(event) {
            if (event && event.keyCode == 27) {
                clear_input(event);
            }
            return event;
        }
			
		//replace contect of the container div with old content
		function clear_input(e) {
			Self.mode = "off";
			Self.setSelection(false);
			if (typeof(Self.input_elem) != "object") return;
			removeDOMEvent(Self.input_elem,"blur",save);
			removeDOMEvent(body,"click",save_checkTarget);
			removeDOMEvent(body,'keydown',on_key_body);
			removeDOMEvent(Self.input_elem,'keydown',on_key);
			removeDOMEvent(Self.input_elem,'keypress',on_key);
			removeDOMEvent(Self.container_edit,"click",stop_click_bubbl);
			removeDOMEvent(Self.container_edit,"mousedown",stop_click_bubbl);
			if (Self.input_elem.parentNode.parentNode == Self.container_edit)
			    Self.container_edit.removeChild(Self.input_elem.parentNode);
			for (var nIndx in Self.old_content) {
				Self.container_edit.appendChild(Self.old_content[nIndx]);
			}
			unregister("OX_Clear_All_Edit_Lines",clear_input);	
			cancelfunc=true;		
			draggingdisable = false;
			triggerEvent("OX_Dummy", e);
		}
		
		//store old content
		for(var nIndx in this.container_edit.childNodes) {
			if(typeof(this.container_edit.childNodes[nIndx]) == "object") {
				this.old_content[nIndx] = this.container_edit.childNodes[nIndx].cloneNode(true);
			}
		}
		
		//replace old content
		removeChildNodes(this.container_edit);
		this.setSelection(true);
		
		//create input element		
		this.input_elem = newnode('input', this.style, { type:'text', value: this.old_text });	
		var oDiVtest = newnode("div", 
		       { overflow: "hidden", position: "relative", width:"100%" }, null,
		       [ this.input_elem ]);
		this.container_edit.appendChild(oDiVtest);	
        addDOMEvent(oDiVtest, "selectstart", function() { menuselectstart=true; });
        addDOMEvent(oDiVtest, "mousedown", function() { menumousedown=true; });        

		if (Self.input_elem && Self.mode != "on") {		
			Self.input_elem.focus();				
			Self.mode = "on";
			draggingdisable = true;
			cancelfunc=false;					
			Self.input_elem.value = Self.old_text;					
			Self.input_elem.select();
		}
	
		function on_key(event) {			
			if (event.keyCode == 13) {
				if (Self.input_elem.value != Self.old_text || !Self.really_edit_check) {
					Self.input_elem.blur();
				}
			} else if (event.keyCode == 27) {
                clear_input(event);
            }
			cancelBubbling(event);
			return event;
		}

		addDOMEvent(this.input_elem,'keydown',on_key);
		addDOMEvent(this.input_elem,'keypress',on_key);
		addDOMEvent(this.input_elem,"blur",save);
		addDOMEvent(this.container_edit,"click", stop_click_bubbl);
		addDOMEvent(this.container_edit,"mousedown", stop_click_bubbl);
        addDOMEvent(body,"click",save_checkTarget);
		addDOMEvent(body,'keydown',on_key_body);
		register("OX_Clear_All_Edit_Lines",clear_input);
	}
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2010 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */
 
/**
 * define day
 */
function cDay(nDateParam,nCurrMonthParam,bWeekendParam)
{
	this.nDate = nDateParam;
	this.nCurrMonth = nCurrMonthParam; 		 //flags: 0 last month, 1 current month, next month
	this.bWeekend = bWeekendParam;			 //true, false
}

/**
 * define week
 */
function cWeek()
{
	this.nKW;	
	this.aDays= new Array();	
	this.addDay = function (nDay,oDay)
	{
		this.aDays[nDay] = oDay;
	}
	this.setKW = function (nKWParam)	
	{
		this.nKW = nKWParam;
	}
}

/*
 * defines calender:
 */
function cCalendar(nMonthParam,nYearParam)
{
	this.nMonth = nMonthParam;
	this.nYear = nYearParam;
	this.aWeeks= new Array();
	/*
	 * compute Calendar
	 */
	this.addWeek = function (nNumWeek,oWeekParam)
	{
		this.aWeeks[nNumWeek] = oWeekParam;			
	}	
	 
	this.init = function ()
	{
		var oCalendarTool = new calendarTool(this.nMonth, this.nYear);
		oCalendarTool.init();		
		var nNumWeeks = oCalendarTool.getNumWeeks();
		var	startByDate = oCalendarTool.endDate - oCalendarTool.firstDay+1;			
		var nDayCounter = 0; var nDayNextMonth = 1;var nDayCurrMonth = 1;
		for(nWeek=0;nWeek < nNumWeeks;nWeek++)
		{			
			var oWeek = new cWeek();
			var oThDate = new Date();
			oThDate.setFullYear(oCalendarTool.nYear);
			oThDate.setDate(1);	
			oThDate.setMonth(oCalendarTool.nMonth);				
			
			for(indexDay=0;indexDay<7;indexDay++)
			{				
				if(indexDay > 4)
				 	bWeekend = true;
				else				 	
				 	bWeekend = false;				 	
				if(nDayCounter<oCalendarTool.firstDay)
				{
					var oDay = new cDay(startByDate+nDayCounter,0,bWeekend);
					if(indexDay==3) //th
					{
						oThDate.setDate(startByDate+nDayCounter);
						oThDate.setMonth(oThDate.getMonth()-1);						
					}
				}				
				else if(nDayCounter>=(oCalendarTool.nDays+oCalendarTool.firstDay))
				{
					var oDay = new cDay(nDayNextMonth,2,bWeekend);
					if(indexDay==3) //Th
					{
						oThDate.setDate(nDayNextMonth);
						oThDate.setMonth(oThDate.getMonth()+1);		
					}
					nDayNextMonth++;
				}				
				else
				{
					var oDay = new cDay(nDayCurrMonth,1,bWeekend);
					if(indexDay==3)
					{					
						oThDate.setDate(nDayCurrMonth);
						oThDate.setMonth(oThDate.getMonth());
					}
					nDayCurrMonth++;
				}	
				oWeek.addDay(indexDay,oDay);
				oWeek.setKW(oCalendarTool.getKW(oThDate.getFullYear(),oThDate.getMonth(),oThDate.getDate()));				
				nDayCounter++;
			}
			this.addWeek(nWeek,oWeek);
		}		
	}
	
	this.init();	

}

/*
 * tools for calendar computing
 */
function calendarTool(nMonthParam,nYearParam) {
	this.firstDay;
	this.startWeek;
	this.endDate;
	this.nDays;	
	
	this.nMonth = nMonthParam;	
	this.nYear = nYearParam;	
	this.curr_date;	
	this.init = function () {
		var currDate = new Date();
		currDate.setFullYear(this.nYear);
		currDate.setDate(1);
		currDate.setMonth(this.nMonth);
		currDate.setUTCDate(currDate.getUTCDate()-1);

		this.endDate = currDate.getDate();	
		currDate.setUTCDate(currDate.getUTCDate()+1);	
		this.startWeek =  this.getKW(currDate.getFullYear(),currDate.getMonth(),1);
		this.firstDay = currDate.getDay();
		if(this.firstDay>0) this.firstDay -= 1;	
		else if(this.firstDay==0) this.firstDay=6;		
		//compute num days	
		currDate.setMonth(currDate.getMonth()+1);
		currDate.setUTCDate(currDate.getUTCDate()-1);
		this.nDays = currDate.getDate();		
		this.curr_date = currDate;
	}
	
	this.getNumWeeks = function() {	
		var fullWeeks = parseInt(this.nDays/7);
		var overflow = this.nDays - fullWeeks*7;
		if(this.firstDay > 0)
			fullWeeks++;
		if ((7 - this.firstDay) < overflow || (overflow>0 && this.firstDay==0)) {
			fullWeeks++;
		}
		return fullWeeks;
	}
	
	//private functions
	/*
	 * compute calendar week
	 */
	this.getKW = function (j,m,t) {
		var DoDat = this.donnerstag(new Date(j,m,t));
		var DoKW1 = this.donnerstag(new Date(this.getKWYear(j,m,t),0,4));
		var kw = Math.floor(1.5+(DoDat.getTime()-DoKW1.getTime())/86400000/7);
		return kw;
	}
	
	this.getKWYear = function(j,m,t) {
		return this.donnerstag(new Date(j,m,t)).getFullYear();
	}
	
	/*
	 * compute first thursday, getKW need it
	 */
	this.donnerstag = function (datum) {
	  var Do=new Date();
	  Do.setTime(datum.getTime() + (3-((datum.getDay()+6) % 7)) * 86400000);
	  return Do;
	}
	
	this.sonntag = function (datum) { 
	  var Do=new Date();
	  Do.setTime(datum.getTime() + (3-((datum.getDay()+6) % 7)) * 86400000);
	  Do.setUTCDate(Do.getUTCDate()-4);
	  return Do;
	}	
	
	this.init();
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2010 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */
function cAnimMiniCalendar(actionFunction, oDOMHeader) {
		this.initDate = new Date();
		this.actionFunction = actionFunction;
		this.MiniRefer = null;
		this.selectedDate = this.initDate.getDate();
		this.selectedMonth = this.initDate.getMonth();
		this.selectedYear = this.initDate.getFullYear();
		this.animationInProgress = false;
		this.todayYear = this.selectedYear;
		this.selectedTime = this.initDate.getTime();
		this.selectedId;
		this.header = oDOMHeader;
		this.header0;
		this.enable_action = configGetKey("modules.calendar.module");
		var bDisplayApps = configGetKey("modules.calendar.module");		
		if (!this.enable_action) {
			actionFunction = function () { 
				triggerEvent("Feature_Not_Available", "modules/calendar/mini_calender"); 
			};
		}
		this.MiniRefer = new cMiniCalendar(oDOMHeader,
							$("container_mini"), actionFunction,bDisplayApps,
					 		'mini_subcontainer_0', $("header_mini_month"),
					 		$("header_mini_year"), this.initDate);
		this.MiniRefer.dnd_enabled = true;
		this.MiniRefer.enable_action = this.enable_action;
		var Self = this;
		
		function fn_KWAction(arg) {		
			var DOMTarget = (arg.target)?arg.target:arg.srcElement;
			var sId = DOMTarget.id;
			for (var indx in Self.MiniRefer.miniCalendarAssoc) {
				var aInf = Self.MiniRefer.miniCalendarAssoc[indx];
				if(aInf[3] == sId.split('_')[1]) {
					break;
				}
			}	
			var nDate = aInf[0];
			var oDate = new Date();
			oDate.setDate(1);
			oDate.setMonth(Self.MiniRefer.currentMonth);						
			oDate.setFullYear(Self.MiniRefer.currentYear);						
			if (aInf[1] == 1) {
				oDate.setMonth(oDate.getMonth());
			} else if (aInf[1] == 0) {
				oDate.setMonth(oDate.getMonth()-1);
			} else if (aInf[1] == 2) {
				oDate.setMonth(oDate.getMonth()-1);
			}			
			oDate.setDate(nDate);
			function fn() {			    
			    if (currentpath2[1] != "team") {
			    	if (currentpath2[2] != "week") {
			    		triggerEvent('OX_Switch_View','calendar/calendar/week');
			    	}
			    	objWeekCalendarTool.init(oDate.getFullYear(),oDate.getMonth(),oDate.getDate());
					objWeekCalendarTool.setKW();
					// notify via event
				    triggerEvent("OX_Mini_Calendar_Date_Picked", oDate.getUTCFullYear(), 
				    		oDate.getUTCMonth(), oDate.getUTCDate());
			    }
			    Self.MiniRefer.setSelectedByDate(oDate.getFullYear(),oDate.getMonth(),oDate.getDate());
			}
			// checking if activefolder is type of 'calendar', otherwise jump to standard folder 
            var folder = oMainFolderTree.cache.fast_access[activefolder];
            if (folder && folder.oxfolder.data.module == "calendar") {
            	folder = activefolder;
            } else {
            	folder = configGetKey("folder.calendar");
            }
            setActiveFolder(folder,fn);            
		}
		function fn_DBLAction(arg) {
			triggerEvent('OX_Before_Create_Calendar');
			Self.MiniRefer.setSelectedByDate(Self.selectedYear, Self.selectedMonth, Self.selectedDate);
		}
		// don't implement functions for CW clicks and double clicks; simple clicks are disabled in the constructor
		if (this.enable_action) {
			this.MiniRefer.setfnKWAction(fn_KWAction);
			this.MiniRefer.setfnDBLAction(fn_DBLAction);	
		} else {
			this.MiniRefer.setfnKWAction(function() { 
				    triggerEvent("Feature_Not_Available", "modules/calendar/mini_calender"); 
			});		
		}
}
cAnimMiniCalendar.prototype = {
	destroy: function() {
		this.MiniRefer.destroy();
	},
	
	load: function() {
		this.MiniRefer.load(this.MiniRefer);		
	},
	
	setSelectedByDate: function (year, month, day) {
		this.MiniRefer.setSelectedByDate(year, month, day);
	},
	
	update: function () {
		this.MiniRefer.update();
		this.MiniRefer.setToday();
	},	
	
	setSelected: function(sId) {
		this.MiniRefer.setUnselected();	
		//find calendar where id is defined
		if (this.MiniRefer.miniCalendarAssoc[sId]) {
			this.MiniRefer.setSelected(sId);
			this.selectedDate = this.MiniRefer.selectedDate;
			this.selectedMonth = this.MiniRefer.selectedMonth;
			this.selectedYear  = this.MiniRefer.selectedYear;
			this.selectedTime = Date.UTC(this.MiniRefer.selectedYear,
												this.MiniRefer.selectedMonth,
														this.MiniRefer.selectedDate);		
		}
	},	
	
	checkloaded: function() {		
		return this.MiniRefer.loaded;		
	},
	
	scroll: function(nDirection,cb_fn){
		var Self = this;
		var nStart = $("minical_slider").scrollLeft;
		function do_scroll(nStep) {
			if (nDirection > 0)
				$("minical_slider").scrollLeft = Math.log(Math.pow(nStep,0.66))*66;
			else
				$("minical_slider").scrollLeft = nStart - Math.log(Math.pow(nStep,0.66))*66;
		}
		animate((configGetKey("gui.effects.fading") ? 750 : 0), 245, do_scroll,cb_fn);
	},
	
	next: function(num) {
		var Self = this;		
		if (!this.checkloaded() || this.animationInProgress) return;
		var NextDate = new Date();
		NextDate.setUTCFullYear(this.MiniRefer.currentYear);
		NextDate.setUTCDate(1);	
		NextDate.setUTCMonth(this.MiniRefer.currentMonth);			
		NextDate.setUTCMonth(NextDate.getUTCMonth()+num);
		Self.MiniRefer.set_header(NextDate);		
		this.MiniRefer.appointmentList = new Array();	
		Self.MiniRefer.currentMonth = NextDate.getUTCMonth();
		Self.MiniRefer.currentYear = NextDate.getUTCFullYear();																
		Self.MiniRefer.oCalendar = new cCalendar(NextDate.getUTCMonth(),NextDate.getUTCFullYear());		
		var oNextTable = this.MiniRefer.getTable(Self.MiniRefer.oCalendar);
		var switchsubContainer = newnode('div',{ left:"239px", position:"absolute" });
		switchsubContainer.appendChild(oNextTable);
		$("container_mini").appendChild(switchsubContainer);
		this.animationInProgress = true;
		$("minical_slider").scrollLeft = 0;
		this.MiniRefer.subcontainer.style.left = "0px";		
		this.scroll(1, function(){
								$("container_mini").removeChild(Self.MiniRefer.subcontainer);
								Self.MiniRefer.subcontainer = switchsubContainer;
								Self.animationInProgress = false;
								if(Self.MiniRefer.displayAppointments)
									Self.MiniRefer.update();						
							});
	},
	
	back: function(num) {
		var Self = this;		
		if (!this.checkloaded() || this.animationInProgress) return;
		var NextDate = new Date();
		NextDate.setUTCFullYear(this.MiniRefer.currentYear);
		NextDate.setUTCDate(1);	
		NextDate.setUTCMonth(this.MiniRefer.currentMonth);			
		NextDate.setUTCMonth(NextDate.getUTCMonth()-num);
		Self.MiniRefer.set_header(NextDate);	
		this.MiniRefer.appointmentList = new Array();	
		Self.MiniRefer.currentMonth = NextDate.getUTCMonth();								
		Self.MiniRefer.currentYear = NextDate.getUTCFullYear();																
		Self.MiniRefer.oCalendar = new cCalendar(NextDate.getUTCMonth(),NextDate.getUTCFullYear());		
		var oNextTable = this.MiniRefer.getTable(Self.MiniRefer.oCalendar);
		var switchsubContainer = newnode('div',{ left:"0px", position:"absolute" });
		switchsubContainer.appendChild(oNextTable);
		$("container_mini").insertBefore(switchsubContainer, this.MiniRefer.subcontainer);
		this.animationInProgress = true;
		this.MiniRefer.subcontainer.style.left = "239px";
		$("minical_slider").scrollLeft = 245;
		this.scroll(-1,function (){
								$("container_mini").removeChild(Self.MiniRefer.subcontainer);
								Self.MiniRefer.subcontainer = switchsubContainer;
								Self.animationInProgress = false;
								if(Self.MiniRefer.displayAppointments)
									Self.MiniRefer.update();
							});
	},
	go_to: function(oDate){
		this.MiniRefer.go_to(oDate);
	},
	
	today: function() {
		if (!this.checkloaded() || this.animationInProgress) return;
        
	    var today = new Date();
	    activeDay=today.getUTCDate();
        activeMonth=today.getUTCMonth();
        activeYear=today.getUTCFullYear();
        
        // notify via event
        triggerEvent("OX_Mini_Calendar_Date_Picked", activeYear, activeMonth, activeDay);
        
        if (currentpath2[0] == "calendar") {
        	switch(currentpath2[2]) {
        		case "week":
        		    objWeekCalendarTool.init(activeYear,activeMonth,activeDay);
	                objWeekCalendarTool.setKW();
	                break;
                case "month":
                    loadMonthView();
                    break;
        	}
            triggerEvent("OX_Switch_View",currentpath.join("/"));
        } else if (configContainsKey("folder.calendar")) {
	        setActiveFolder(configGetKey("folder.calendar"), function () {
	            triggerEvent("OX_Switch_View","calendar/calendar/day"); 
	        });
        }
		this.MiniRefer.go_to(new Date());		
	},
	
	addView: function() {
		this.initDate.setMonth(this.initDate.getMonth()+1);		
		if(!this.header0)	
		{
			var oHeader0 = newnode('div',0,{id:'DOMHeaderMini0'});	
			this.header0  = oHeader0;
			this.MiniCalWidgets[0].header = oHeader0;			
			this.MiniCalWidgets[0].subcontainer.insertBefore(oHeader0,this.MiniCalWidgets[0].table);
			this.MiniCalWidgets[0].updateHeaderMini();	
			//this.header.innerHTML = this.MiniCalWidgets[0].currentYear;
		}
		var oHeader = newnode('div',0,{id:'DOMHeaderMini' + this.MiniCalWidgets.length});			
		var oMiniCalendarNext = new cMiniCalendar(oHeader,
	 			$("container_mini"), this.actionFunction,true,'mini_subcontainer_'+this.MiniCalWidgets.length,
	 													$("header_mini_month"),$("header_mini_year"),this.initDate);
		if (oMiniCalendarNext.table)	 
			oMiniCalendarNext.subcontainer.insertBefore(oHeader
															,oMiniCalendarNext.table);
		else
			oMiniCalendarNext.subcontainer.appendChild(oHeader);
		this.MiniCalWidgets.push(oMiniCalendarNext);
	},
	
	removeView: function() {
		if(this.header0) {
			this.MiniCalWidgets[0].subcontainer.removeChild(this.header0);			
			this.MiniCalWidgets[0].header = this.header;
			this.header0 = null;
			this.MiniCalWidgets[0].updateHeaderMini();				
		}
		this.initDate.setMonth(this.initDate.getMonth()-1);
		var oMonthView = this.MiniCalWidgets.pop();
		if (oMonthView) {
			oMonthView.subcontainer.removeChild(oMonthView.header);
			oMonthView.destroy();
		}
	}	
}

function cMini3XCalendar(actionFunction, oDOMHeader) {
		this.initDate = new Date();
		this.actionFunction = actionFunction;
		this.MiniCalWidgets = new Array();
		
		this.selectedDate = this.initDate.getDate();
		this.selectedMonth = this.initDate.getMonth();
		this.selectedYear = this.initDate.getFullYear();
		
		this.todayYear = this.selectedYear;
		
		this.selectedTime = this.initDate.getTime();
		this.selectedId;
		
		this.header = oDOMHeader;
		this.header0;
		this.enable_action = configGetKey("modules.calendar.module");
		var bDisplayApps = configGetKey("modules.calendar.module");
		if(!this.enable_action) {
			actionFunction = function () { triggerEvent("Feature_Not_Available", "modules/calendar/mini_calender"); };
		}
		var oMiniCalendar1 = new cMiniCalendar(oDOMHeader,
							$("container_mini"),actionFunction,bDisplayApps,
						 		'mini_subcontainer_0',$("header_mini_month"),$("header_mini_year"),this.initDate);
		oMiniCalendar1.enable_action = this.enable_action;
		function fn_KWAction(arg)
		{		
			var DOMTarget = (arg.target)?arg.target:arg.srcElement;
			var sId = DOMTarget.id;
			for (var indx in oMiniCalendar1.miniCalendarAssoc)
			{
				var aInf = oMiniCalendar1.miniCalendarAssoc[indx];
				if(aInf[3] == sId.split('_')[1])			
				{
					break;
				}
			}	
			var nDate = aInf[0];
			var oDate = new Date();
			oDate.setDate(1);
			oDate.setMonth(oMiniCalendar1.currentMonth);						
			oDate.setFullYear(oMiniCalendar1.currentYear);						
			if(aInf[1] == 1)
			{
				oDate.setMonth(oDate.getMonth());
			}
			else if(aInf[1] == 0)
			{
				oDate.setMonth(oDate.getMonth()-1);
			}
			else if(aInf[1] == 2)			
			{
				oDate.setMonth(oDate.getMonth()-1);
			}
			oDate.setDate(nDate);		
			function fn()
			{				
				if((currentpath2[0] == "calendar") && 
							(currentpath2[1] == "calendar") &&
									(currentpath2[2] == "week"))
				{
					objWeekCalendarTool.init(oDate.getFullYear(),oDate.getMonth(),oDate.getDate());
					objWeekCalendarTool.setKW();			
				}
				else
				{
					triggerEvent('OX_Switch_View','calendar/calendar/week');		
					objWeekCalendarTool.init(oDate.getFullYear(),oDate.getMonth(),oDate.getDate());
					objWeekCalendarTool.setKW();
				}
			}
			setActiveFolder(configGetKey("folder.calendar"),fn);
		}						 		
		function fn_DBLAction(arg) {
			triggerEvent('OX_Before_Create_Calendar');
		}
		
		//don't implement functions for CW clicks and double clicks; simple clicks are disabled in the constructor
		if(this.enable_action) {
			oMiniCalendar1.setfnKWAction(fn_KWAction);
			oMiniCalendar1.setfnDBLAction(fn_DBLAction);	
		} else {
			// if feature is not available
			this.MiniRefer.setfnKWAction(function() { triggerEvent("Feature_Not_Available", "modules/calendar/mini_calender"); });
		}
			
		oMiniCalendar1.setSelectedByDate(this.selectedYear,this.selectedMonth,this.selectedDate);
		this.MiniCalWidgets.push(oMiniCalendar1);
}
function comboMonthChanged(param,minical)
{
	var NextDate = new Date();
	NextDate.setUTCFullYear(minical.currentYear);
	NextDate.setUTCDate(1);	
	NextDate.setUTCMonth(param);	
	minical.go_to(NextDate);
}
function comboYearChanged(param,minical)
{
	var NextDate = new Date();
	NextDate.setUTCFullYear(param);
	NextDate.setUTCDate(1);	
	NextDate.setUTCMonth(minical.currentMonth);			
	minical.go_to(NextDate);
}
cMini3XCalendar.prototype = {
	destroy: function ()
	{
		for(var nIndx=0;nIndx<this.MiniCalWidgets.length;nIndx++)
		{
			this.MiniCalWidgets[nIndx].destroy();
		}
	},
	load: function ()
	{
		for(var nIndx=0;nIndx<this.MiniCalWidgets.length;nIndx++)
		{
			this.MiniCalWidgets[nIndx].load(this.MiniCalWidgets[nIndx]);
		}
	},
	setSelectedByDate: function (year, month, day)
	{
		for(var nIndx=0;nIndx<this.MiniCalWidgets.length;nIndx++)
		{
			this.MiniCalWidgets[nIndx].setSelectedByDate(year, month, day);
		}
	},
	update: function ()
	{
		for(var nIndx=0;nIndx<this.MiniCalWidgets.length;nIndx++)
		{
			this.MiniCalWidgets[nIndx].update();
			this.MiniCalWidgets[nIndx].setToday();
		}
	},	
	setSelected: function (sId)
	{
		for(var nIndx=0;nIndx<this.MiniCalWidgets.length;nIndx++)
		{
			//find calendar where id is defined
			this.MiniCalWidgets[nIndx].setUnselected();	
		}		
		for(var nIndx=0;nIndx<this.MiniCalWidgets.length;nIndx++)
		{
			//find calendar where id is defined
			if(this.MiniCalWidgets[nIndx].miniCalendarAssoc[sId])
			{
				this.MiniCalWidgets[nIndx].setSelected(sId);
				this.selectedDate = this.MiniCalWidgets[nIndx].selectedDate;
				this.selectedMonth = this.MiniCalWidgets[nIndx].selectedMonth;
				this.selectedYear  = this.MiniCalWidgets[nIndx].selectedYear;
				this.selectedTime = Date.UTC(this.MiniCalWidgets[nIndx].selectedYear,
													this.MiniCalWidgets[nIndx].selectedMonth,
															this.MiniCalWidgets[nIndx].selectedDate);
				for(var nIndx2=0;nIndx2<this.MiniCalWidgets.length;nIndx2++)
				{
					this.MiniCalWidgets[nIndx2].selectedDate	= this.selectedDate;
					this.MiniCalWidgets[nIndx2].selectedMonth	= this.selectedMonth;	
					this.MiniCalWidgets[nIndx2].selectedYear	= this.selectedYear;
					this.MiniCalWidgets[nIndx2].selectedTime	= this.selectedTime;
			
				}					
			}
		}
	},	
	checkloaded: function ()
	{
		//check all views were loaded
		var bAllLoaded = 1;
		for(var nIndx=0;nIndx<this.MiniCalWidgets.length;nIndx++)
		{
			bAllLoaded &= this.MiniCalWidgets[nIndx].loaded;
		}
		return bAllLoaded;		
	},
	next: function (num)
	{	
		if(!this.checkloaded())
			return;
		for(var nIndx=0;nIndx<this.MiniCalWidgets.length;nIndx++)
		{
				this.MiniCalWidgets[nIndx].next(num);
		}
		
		this.initDate.setMonth(this.initDate.getMonth()+num);
		/*
		if(this.header0)
		{
			this.header.innerHTML = this.MiniCalWidgets[0].currentYear;
		}*/
	},
	back: function (num)
	{
		if(!this.checkloaded())
			return;
		for(var nIndx=0;nIndx<this.MiniCalWidgets.length;nIndx++)
		{
			this.MiniCalWidgets[nIndx].back();
		}
		this.initDate.setMonth(this.initDate.getMonth()-num);	
		/*
		if(this.header0)
		{
			this.header.innerHTML = this.MiniCalWidgets[0].currentYear;
		}		
		*/
	},
	addView: function ()
	{
		this.initDate.setMonth(this.initDate.getMonth()+1);		
		if(!this.header0)	
		{
			var oHeader0 = newnode('div',0,{id:'DOMHeaderMini0'});	
			this.header0  = oHeader0;
			this.MiniCalWidgets[0].header = oHeader0;			
			this.MiniCalWidgets[0].subcontainer.insertBefore(oHeader0,this.MiniCalWidgets[0].table);
			this.MiniCalWidgets[0].updateHeaderMini();	
			//this.header.innerHTML = this.MiniCalWidgets[0].currentYear;
		}
		var oHeader = newnode('div',0,{id:'DOMHeaderMini' + this.MiniCalWidgets.length});			
		var oMiniCalendarNext = new cMiniCalendar(oHeader,
	 			$("container_mini"),this.actionFunction,true,'mini_subcontainer_'+this.MiniCalWidgets.length,
	 													$("header_mini_month"),$("header_mini_year"),this.initDate);
		if(oMiniCalendarNext.table)	 
			oMiniCalendarNext.subcontainer.insertBefore(oHeader
															,oMiniCalendarNext.table);
		else
			oMiniCalendarNext.subcontainer.appendChild(oHeader);
		this.MiniCalWidgets.push(oMiniCalendarNext);
	},
	removeView: function ()
	{
		if(this.header0)
		{
			this.MiniCalWidgets[0].subcontainer.removeChild(this.header0);			
			this.MiniCalWidgets[0].header = this.header;
			this.header0 = null;
			this.MiniCalWidgets[0].updateHeaderMini();				
		}
		this.initDate.setMonth(this.initDate.getMonth()-1);
		var oMonthView = this.MiniCalWidgets.pop();
		if(oMonthView)
		{
			oMonthView.subcontainer.removeChild(oMonthView.header);
			oMonthView.destroy();
		}
	}	
}

function cMiniCalendar(displayPanelContainer, container, actionFunction,
			bDisplayAppointments, subcontainerid, displayPanelContainerM,
				displayPanelContainerY, initDate, selectedDate) {
	this.enable_action = true;
	this.aMonthNames = new Array('January','February','March','April','May',
								'June','July','August','September','October','November','December');
	this.container = container;
	this.table;
	this.loaded = false;
	this.dnd_enabled = false;
	this.subcontainerid = subcontainerid || "min_subcontainer_default";
	this.subcontainer = newnode('div');	
	this.container.appendChild(this.subcontainer);
	addTMPId(this.subcontainer);
	this.header = displayPanelContainer;
	this.header_month = displayPanelContainerM;
	this.header_year = displayPanelContainerY;	
	this.actionFN = actionFunction;
	this.displayAppointments = bDisplayAppointments;
	var odat = new Date();
	this.todayDate = odat.getDate();
	this.todayMonth = odat.getMonth();	
	this.todayYear = odat.getFullYear();
	if (initDate) {
		this.currentMonth = initDate.getUTCMonth();
		this.currentYear = initDate.getUTCFullYear();
	} else {
		this.currentMonth = this.todayMonth;
		this.currentYear = this.todayYear;
	}
	this.selectedDate = (selectedDate)?selectedDate.getUTCDate():this.todayDate;
	this.selectedMonth = (selectedDate)?selectedDate.getUTCMonth():this.todayMonth;
	this.selectedYear = (selectedDate)?selectedDate.getUTCFullYear():this.todayYear;
	this.selectedTime = Date.UTC(this.todayYear,this.todayMonth,this.todayDate);
	this.appointmentList = new Array();	
	this.selectedID;
	this.miniCalendarAssoc = new Object();
	this.load(this);
	this.oCalendar;
	this.oComboMonth;
	this.oComboYear;	
	this.fnKWAction = null;
	this.actionDBLFN = null;
	
	this.open_in_calendar = newnode("img", { verticalAlign:"middle" }, 
			{ src:getFullImgSrc("img/toolbar/calnder.png"), 
			  alt: _("Show in Calendar"), title: _("Show in Calendar")});
	register("LanguageChanged",(function(Self) {
		return function() {
			Self.open_in_calendar.title = _("Show in Calendar");
			Self.open_in_calendar.alt = _("Show in Calendar");
		}
	})(this));
}	

cMiniCalendar.prototype = {
	setfnDBLAction: function (fn) {
		this.actionDBLFN = fn;
	},
	
	setfnKWAction: function(fn) {
		this.fnKWAction = fn;
	},
	
	setDate: function (year, month, date) { },
	
	destroy: function() {	
		this.selectedID = undefined;	
		this.subcontainer.removeChild(this.table);
		removeTMPId(this.subcontainer.id+"_table");
		for (var i=0; $2(this.subcontainer.id+"mc_"+i+"_0"); i++) {
			for (var i2=0; $2(this.subcontainer.id+"mc_"+i+"_"+i2); i2++) {
				removeTMPId(this.subcontainer.id+"mc_"+i+"_"+i2);
			}
		}	
		for (var i=0; i<54; i++) {
			if ($2("kw_month_"+i)) {
				removeTMPId("kw_month_"+i);
			}
		}
		//TODO REMOVE FROM TMPIDS
		this.loaded = false;
	},
	
	next: function(num) {
		if(num == undefined) num = 1;
		if(!this.loaded) return;
		this.destroy();
		var oDateLoc = new Date();
		oDateLoc.setFullYear(this.currentYear);
		oDateLoc.setDate(1);	
		oDateLoc.setMonth(this.currentMonth);
		oDateLoc.setMonth(oDateLoc.getMonth()+num); 
		this.oComboYear.setDynamicKey(oDateLoc.getFullYear());		
		this.oComboMonth.setKey(oDateLoc.getMonth());

		this.currentMonth = oDateLoc.getMonth();
		this.currentYear = oDateLoc.getFullYear();		
		this.load(this);
	},
	
	back: function(num) {
		if(num == undefined) num = 1;
		if(!this.loaded) return;
		this.destroy();
		var oDateLoc = new Date();
		oDateLoc.setFullYear(this.currentYear);
		oDateLoc.setDate(1);	
		oDateLoc.setMonth(this.currentMonth);
		oDateLoc.setMonth(oDateLoc.getMonth()-num); 
		this.oComboYear.setDynamicKey(oDateLoc.getFullYear());
		this.oComboMonth.setKey(oDateLoc.getMonth());
		
		this.currentMonth = oDateLoc.getMonth();
		this.currentYear = oDateLoc.getFullYear();		
		this.load(this);
	},
	
	go_to: function(oDateLoc) {
		if (!this.loaded) return;
		this.destroy();
		this.set_header(oDateLoc);
		this.currentMonth = oDateLoc.getMonth();
		this.currentYear = oDateLoc.getFullYear();		
		this.load(this);
	},
	
	set_header: function(oDateLoc){
		unregister('OX_Select_MiniMonth',comboMonthChanged);
		unregister('OX_Select_MiniYear',comboYearChanged);
		this.oComboYear.setDynamicKey(oDateLoc.getUTCFullYear());
		this.oComboMonth.setKey(oDateLoc.getUTCMonth());		
		register('OX_Select_MiniMonth',comboMonthChanged);
		register('OX_Select_MiniYear',comboYearChanged);		
	},
	
	load: function(obj) {
		this.oCalendar = new cCalendar(this.currentMonth,this.currentYear);
		if (this.header_month && !this.oComboMonth && !this.oComboYear) {
			this.oComboMonth = new ComboBoxSpecial(window, this.header_month.id, '7em', this.todayMonth, 
																	false, 'OX_Select_MiniMonth', 6,this) ;
			this.oComboYear = new ComboBoxSpecial(window, this.header_year.id, '3em', 5, 
																	false, 'OX_Select_MiniYear', 10,this) ;
			this.oComboYear.optWidth = "4em";
			this.oComboYear.show_buttons = true;
			for (var nKeyIndx=-5; nKeyIndx < 5; nKeyIndx++){
				this.oComboYear.addElement((this.todayYear+nKeyIndx),(this.todayYear+nKeyIndx));
			}
			for (var nKeyIndx=0;nKeyIndx<this.aMonthNames.length;nKeyIndx++) {
				this.oComboMonth.addElement(this.aMonthNames[nKeyIndx], nKeyIndx);
			}
			this.oComboYear.getDomNode();
			this.oComboMonth.getDomNode();
			register('OX_Select_MiniMonth', comboMonthChanged);
			register('OX_Select_MiniYear', comboYearChanged);			
		}
		var oFirstDayDate = new Date();
		var oLastDayDate = new Date();		

		oFirstDayDate.setUTCHours(0);
		oFirstDayDate.setUTCMinutes(0);		
		oFirstDayDate.setUTCSeconds(0);				
		oFirstDayDate.setUTCDate(1);
		oLastDayDate.setUTCHours(0);
		oLastDayDate.setUTCMinutes(0);		
		oLastDayDate.setUTCSeconds(0);			
		oLastDayDate.setUTCDate(1);		
		
		oFirstDayDate.setUTCFullYear(this.currentYear);
		oLastDayDate.setUTCFullYear(this.currentYear);		

		var aDay = this.oCalendar.aWeeks[0].aDays[0];
		var aDay2 = this.oCalendar.aWeeks[(this.oCalendar.aWeeks.length-1)].aDays[6];		

		oFirstDayDate.setUTCMonth(this.currentMonth);		
		oLastDayDate.setUTCMonth(this.currentMonth);			

		if (aDay.nCurrMonth == 0) {
			oFirstDayDate.setUTCMonth(oFirstDayDate.getUTCMonth()-1);
		}
		if (aDay2.nCurrMonth == 2) {
			oLastDayDate.setUTCMonth(oLastDayDate.getUTCMonth()+1);
		}
			
		oFirstDayDate.setUTCDate(aDay.nDate);
		oLastDayDate.setUTCDate(aDay2.nDate);

		oLastDayDate.setUTCDate(oLastDayDate.getUTCDate()+1);
		
		if (!this.displayAppointments){
			this.create();
		} else {
			function cb_fkt_mc(cbobjCalendar)  {						
				if (cbobjCalendar && cbobjCalendar.data) {
					obj.appointmentList = cbobjCalendar.data;					
				} else if(cbobjCalendar && cbobjCalendar.error) {
					newServerError(cbobjCalendar,4);
				} else
					triggerEvent('OX_New_Error', 2 ,'Internal Error: No callback parameter in MINICALENDER');
				obj.create();
			}
			this.getCalObjMC(oFirstDayDate,oLastDayDate,cb_fkt_mc);					
		}
	},
	
	getCalObjMC: function(oFirstDayDate,oLastDayDate,callback) {
		var start = oFirstDayDate.getTime();
		var end = oLastDayDate.getTime();		
		var sAjaxRequest = AjaxRoot + "/calendar?action=has&session=" + session +"&start=" + start + "&end=" + end;
		calendarMiniJson.get(sAjaxRequest, null, callback);
	},	
	
	update: function() {
		//TODO
		var oFirstDayDate = new Date();
		var oLastDayDate = new Date();		
		this.loaded = false;
		oFirstDayDate.setUTCHours(0);
		oFirstDayDate.setUTCMinutes(0);		
		oFirstDayDate.setUTCSeconds(0);				
		oFirstDayDate.setUTCDate(1);
		oLastDayDate.setUTCHours(0);
		oLastDayDate.setUTCMinutes(0);		
		oLastDayDate.setUTCSeconds(0);			
		oLastDayDate.setUTCDate(1);	

		oFirstDayDate.setUTCFullYear(this.currentYear);
		oLastDayDate.setUTCFullYear(this.currentYear);		

		var aDay = this.oCalendar.aWeeks[0].aDays[0];
		var aDay2 = this.oCalendar.aWeeks[(this.oCalendar.aWeeks.length-1)].aDays[6];		
		
		oFirstDayDate.setUTCMonth(this.currentMonth);		
		oLastDayDate.setUTCMonth(this.currentMonth);			

		if(aDay.nCurrMonth == 0)
			oFirstDayDate.setUTCMonth(oFirstDayDate.getUTCMonth()-1);
		if(aDay2.nCurrMonth == 2)
			oLastDayDate.setUTCMonth(oLastDayDate.getUTCMonth()+1);
			
		oFirstDayDate.setUTCDate(aDay.nDate);
		oLastDayDate.setUTCDate(aDay2.nDate);
		oLastDayDate.setUTCDate(oLastDayDate.getUTCDate()+1);		
		var Self = this;
		function fn_refreshCurrentMiniCal(cbobjCalendar) {
			if (cbobjCalendar && cbobjCalendar.data) {
				Self.appointmentList = cbobjCalendar.data;					
			} else if(cbobjCalendar && cbobjCalendar.error) {
				newServerError(cbobjCalendar);
			} else {
				triggerEvent('OX_New_Error', 2 ,'Internal Error: No callback parameter in MINICALENDER');
			}
			Self.refreshView();			
		}
		if (this.displayAppointments) {
			this.getCalObjMC(oFirstDayDate,oLastDayDate,fn_refreshCurrentMiniCal);
		}
	},	
	
	refreshView: function() {		
		var nAllDaysCount=0;
		//loop weeks
		for (var indexWeek=0; indexWeek<this.oCalendar.aWeeks.length; indexWeek++){
				var currentWeek = this.oCalendar.aWeeks[indexWeek];
				//loop days
				for (var indexDay=0; indexDay<7; indexDay++) {
					var bAppExist = false;
					if (this.displayAppointments) {
						bAppExist = this.appointmentList[nAllDaysCount];
					}
					var oTD = $2(this.subcontainer.id + 'mc_' + indexWeek + '_' + indexDay);
					oTD.className = removeClass(oTD.className,"font-style-lable");
	 				if(bAppExist) {
	 					oTD.className += " font-style-lable";		 			
	 				}
	 				nAllDaysCount++;
				}
				this.loaded = true;
		}	
	},	
	
	create: function() {
		var oCalminiMain = this.subcontainer;
		oCalminiMain.appendChild(this.getTable());
		this.updateHeaderMini();
	},
	
	getTable: function(oCalObj){
		var Self = this;
		var nAllDaysCount = 0;
		var oTable = newnode("table", {}, { 
			className: "CalMiniMainTable1 background-color-content border-color-content-default", 
				cellPadding: 0, cellSpacing: 0, border: 0 });
		this.table = oTable;
		var oTableBody = newnode('tbody');	// IE specific
		var oTRHead = newnode('tr');
		var weekDays = [
            { c: "monday"   /*i18n context*/, t: "M"/*i18n*/ },
            { c: "tuesday"  /*i18n context*/, t: "T"/*i18n*/ },
            { c: "wednesday"/*i18n context*/, t: "W"/*i18n*/ },
            { c: "thursday" /*i18n context*/, t: "T"/*i18n*/ },
            { c: "friday"   /*i18n context*/, t: "F"/*i18n*/ },
            { c: "saturday" /*i18n context*/, t: "S"/*i18n*/ },
            { c: "sunday"   /*i18n context*/, t: "S"/*i18n*/ }];
        
        var _nTd = newnode('td', { height:"2em", padding:"0px" }, { className: "cursorPointer" });
        if (this.fnKWAction != null) {
        	 _nTd.appendChild(Self.open_in_calendar);        
        	 _nTd.onclick = function(e) {
	            activeDay=1;
	            activeMonth=Self.currentMonth;
	            activeYear=Self.currentYear;
	            
	            Self.setSelectedByDate(activeYear, activeMonth, activeDay);
	            if (currentpath2[0] == "calendar") {
                    loadMonthView();
                    triggerEvent("OX_Switch_View","calendar/calendar/month");
	            } else if (configContainsKey("folder.calendar")) {
	                setActiveFolder(configGetKey("folder.calendar"), function () {
	                    triggerEvent("OX_Switch_View","calendar/calendar/month"); 
	                });
	            }
	        };       	
        }
        oTRHead.appendChild(_nTd);
        for (var i=0; i<weekDays.length; i++) {
            var HeadTD = newnode('td', { height:"2em", padding:"0px" }, 0,
                [addTranslated(weekDays[i].t, weekDays[i].c)]);
			oTRHead.appendChild(HeadTD);
		}
		oTRHead.className = "miniCalendarTRHead dateCalendarFontSize background-color-additional-content font-style-headline";
		oTableBody.appendChild(oTRHead);
		var locCalObj = (oCalObj != undefined) ? oCalObj : this.oCalendar;
		//loop weeks
		for (var indexWeek=0; indexWeek<locCalObj.aWeeks.length; indexWeek++) {
				var oTR = newnode('tr', { border:"0" });
				var currentWeek = locCalObj.aWeeks[indexWeek];
				var oKWTD = newnode('td', 0, { height:"1.5em", padding:"0px", verticalAlign:"middle",
								className:"miniCalendarTDKW background-color-additional-content font-size-footer border-color-default",
								id:'kw_'+currentWeek.nKW });			
				var KWTDText = document.createTextNode(currentWeek.nKW);							
				oKWTD.appendChild(KWTDText);
				if (!this.enable_action || !this.fnKWAction) {
 					oKWTD.className += " cursorReset";		 			
 				}
				if (this.fnKWAction != null) {	
					addDOMEvent(oKWTD, "click", this.fnKWAction);
				}
				oTR.appendChild(oKWTD);
				addTMPId(oKWTD);
				//loop days
				for (var indexDay=0; indexDay<7; indexDay++) {
					var bAppExist = false;
					if(this.displayAppointments) {
						var bAppExist = this.appointmentList[nAllDaysCount];
					}
					var oTD = newnode('td', { height:"1.5em", padding:"0px" });
					sID = this.subcontainer.id+'mc_' + indexWeek + '_' + indexDay;				
	 				var cDay = currentWeek.aDays[indexDay];	
					var TDText = document.createTextNode(cDay.nDate);			
	 				oTD.appendChild(TDText);
	 				//save id, date  & appointments info in assoc array
					this.miniCalendarAssoc[sID] = new Array(cDay.nDate, cDay.nCurrMonth, bAppExist, currentWeek.nKW);
	 				if (cDay.nCurrMonth==0 || cDay.nCurrMonth==2) {
						oTD.className = "miniCalendarTDNotCurr dateCalendarFontSize font-color-disabled";
	 				} else {
						oTD.className = "miniCalendarTD dateCalendarFontSize";
	 				}
	 				if (bAppExist) {
	 					oTD.className += " font-style-lable";		 			
	 				}
	 				if (!this.enable_action) {
	 					oTD.className += " cursorReset";		 			
	 				}
	 				
	 				var oDateOthMonth = new Date();
	 				oDateOthMonth.setFullYear(this.currentYear);
	 				oDateOthMonth.setDate(cDay.nDate);
	 				oDateOthMonth.setMonth(this.currentMonth);	 
					
					oDateOthMonth.setMonth(oDateOthMonth.getMonth()-1);
 					nLastMonth = oDateOthMonth.getMonth();
 					nLastYear = oDateOthMonth.getFullYear();	 				
 					oDateOthMonth.setMonth(oDateOthMonth.getMonth()+2);	 					
 					nNextMonth = oDateOthMonth.getMonth();
	 				nNextYear = oDateOthMonth.getFullYear();	 				
					if ((cDay.nCurrMonth == 1 && this.currentYear == this.todayYear
	 														 && this.currentMonth == this.todayMonth
	 																	 && this.todayDate == cDay.nDate)
						|| (cDay.nCurrMonth == 0 && nLastYear == this.todayYear
	 													&& nLastMonth == this.todayMonth
	 																	 && this.todayDate == cDay.nDate)
						|| (cDay.nCurrMonth == 2 && nNextYear == this.todayYear
	 													&& nNextMonth == this.todayMonth
	 																	 && this.todayDate == cDay.nDate)) 
					{
		 				oTD.className += " miniCalendarToday todaySelectionBorder";
		 			
		 			}
					if((cDay.nCurrMonth == 1 && this.currentYear == this.selectedYear
	 													&& this.currentMonth == this.selectedMonth
	 																	 && this.selectedDate == cDay.nDate)										
						|| (cDay.nCurrMonth == 0 && nLastYear == this.selectedYear
	 													&& nLastMonth == this.selectedMonth
	 																	 && this.selectedDate == cDay.nDate)
						|| (cDay.nCurrMonth == 2 && nNextYear == this.selectedYear
	 													&& nNextMonth == this.selectedMonth
	 																	 && this.selectedDate == cDay.nDate))
	 				{
	 					oTD.className += ' background-color-PMG-selection-elements';
 						this.selectedID = sID;
	 				}	 				
					oTD.id = sID;
					if (this.actionDBLFN != null) {
						oTD.onselectstart = function() { return false; };
						oTD.style.MozUserSelect = "none";
						oTD.ondblclick = this.actionDBLFN;
					}
					oTD.onclick = this.actionFN;		
					oTR.appendChild(oTD);
					addTMPId(oTD);
					function fnOver(node) {
						return function(e, dragType, draggedObjects, mouseposition, targetNode) {
							    minicalenable(e,dragType,draggedObjects,mouseposition,targetNode,node);
                                var mynode = e.currentTarget || e.srcElement || false;												
								mynode.className += " dndOver";
							}
					}
					function clearOpenNOdeOver(e, dragType, draggedObjects, mouseposition, OutOpen, dropNode) {
						if (dropNode) {
							dropNode.className = removeClass(dropNode.className,'dndOver');									
						} else if(e) {
							var mynode = e.currentTarget || e.srcElement || false;
							if (mynode) { 
								mynode.className = removeClass(mynode.className,'dndOver'); 
							}
						}
					}
					if (this.dnd_enabled) {
						var tObj = new Object();
						tObj["mail"] = function (event,dragType,draggedObjects,mouseposition,targetNode,dropNode) {
										clearOpenNOdeOver(event,dragType,draggedObjects,mouseposition,null,dropNode);
										openMailToApp(Self.getDateByID(dropNode.id),draggedObjects.currentObjects,"mail");}	
						tObj["contacts"] = function (event,dragType,draggedObjects,mouseposition,targetNode,dropNode) {
										clearOpenNOdeOver(event,dragType,draggedObjects,mouseposition,null,dropNode);
										openMailToApp(Self.getDateByID(dropNode.id),draggedObjects.currentObjects,"contacts");}											
						tObj["calendar"] = function (event,dragType,draggedObjects,mouseposition,targetNode,dropNode) {
							clearOpenNOdeOver(event,dragType,draggedObjects,mouseposition,null,dropNode);
							var collection={};     
							collection.columns = null;
				            collection.objects = [];
				            for (var i in draggedObjects.currentObjects) {
				            	var myObj = draggedObjects.currentObjects[i];
				            	collection.objects.push(
				            			OXCalendarMapping.createKeyFromObject(
					                      { module: "calendar", 
					                        folder_id: myObj.folder || myObj.folder_id, 
					                        id: myObj.id,
					                        recurrence_position: myObj.recurrence_position || 0 }
					                  )
				            	)
				            }
				            OXCache.newRequest(null, "calendar", collection, null,
				                function(daten) {
				                    for (var j in daten.objects) {
				                    	
				                    	var oDate = Self.getDateByID(dropNode.id);
				                    	var myObj = daten.objects[j];
				                    	myObj.start_date = new Date(myObj.start_date);
										myObj.end_date = new Date(myObj.end_date);
										oDate.setUTCHours(myObj.start_date.getUTCHours());
										oDate.setUTCMinutes(myObj.start_date.getUTCMinutes());
										var changes=oDate.getTime()-myObj.start_date.getTime();
										var oDateEnd=new Date(myObj.end_date.getTime()+changes);
										moveAppToNewStart(myObj, oDate, oDateEnd, function () { Self.update(); });
				                    }	
				                },
				                true
				            );
						}										
						registerTarget(oTD, tObj,null,null,fnOver(oTD),fnOver(oTD),clearOpenNOdeOver,true);										
					}
					nAllDaysCount++;
				}
				oTableBody.appendChild(oTR);
				this.loaded = true;
		}
		//display 6 rows in any case
		for(var indexWeek=0; indexWeek< 6; indexWeek++) {
			var oTR = newnode('tr');
			var oTD = newnode('td', { height:"1.5em", padding:"0px" }, { colspan:"8", className:"miniCalendarTDNotCurr dateCalendarFontSize font-color-disabled minicalendar6thline"});			
			oTD.innerHTML = '&#xa0;';
			oTR.appendChild(oTD);
			oTableBody.appendChild(oTR);
		}
		oTable.appendChild(oTableBody);		
		addTMPId(oTable);		
		return oTable;
	},
	
	setSelectedByDate: function(year, month, day) {
		this.selectedDate = day;
		this.selectedMonth = month;		
		this.selectedYear = year;
		this.selectedTime = Date.UTC(year,month,day);
		this.setUnselected(this.selectedID);
		if (this.selectedYear == this.currentYear && this.selectedMonth == this.currentMonth) {
			for (var sId in this.miniCalendarAssoc) {					
				var nCurrMonthFlag = this.miniCalendarAssoc[sId][1];
				var nDay = this.miniCalendarAssoc[sId][0];
 				var oDateOthMonth = new Date();
 				oDateOthMonth.setFullYear(this.currentYear);
 				oDateOthMonth.setDate(nDay);
 				oDateOthMonth.setMonth(this.currentMonth);	 
				
				oDateOthMonth.setMonth(oDateOthMonth.getMonth()-1);
 					nLastMonth = oDateOthMonth.getMonth();
 					nLastYear = oDateOthMonth.getFullYear();	 				
				oDateOthMonth.setMonth(oDateOthMonth.getMonth()+2);	 					
 					nNextMonth = oDateOthMonth.getMonth();
	 				nNextYear = oDateOthMonth.getFullYear();	
				if ((nCurrMonthFlag == 1 && nDay == this.selectedDate
												 && this.currentMonth == this.selectedMonth
												 			&& this.currentYear == this.selectedYear)
						|| (nCurrMonthFlag == 0 && nLastYear == this.selectedYear
	 													&& nLastMonth == this.selectedMonth
	 																	 && nDay == this.selectedDate)												 			
						|| (nCurrMonthFlag == 2 && nNextYear == this.selectedYear
	 													&& nNextMonth == this.selectedMonth
	 																	 && nDay == this.selectedDate)) 																	 
				{
					this.selectedID = sId;
					var markTDSelected = $2(sId);
					if(markTDSelected != undefined)
						markTDSelected.className += " background-color-PMG-selection-elements";
					break;
				}
			}
		} else {
			var oDateLoc = new Date();
			oDateLoc.setFullYear(this.selectedYear);
			oDateLoc.setDate(1);
			oDateLoc.setMonth(this.selectedMonth);
			this.go_to(oDateLoc);
		}
	},
	setToday: function() {
		var todayDate = new Date();
		this.todayDate = todayDate.getDate();
		this.todayMonth = todayDate.getMonth();	
		this.todayYear = todayDate.getFullYear();
		for(var sId in this.miniCalendarAssoc)
		{
			//deselect today selection
			var currDayDate = $2(sId);
			/*
			 * should not happen. however, results in some strange errors if not
			 * set and prevent executing updates within the calender views so we
			 * better check this.
			 */
			if (!currDayDate) {
				return;
			}
			currDayDate.className = removeClass(currDayDate.className,"todaySelectionBorder");
			currDayDate.className = removeClass(currDayDate.className,"miniCalendarToday");			
			
			var nCurrMonthFlag = this.miniCalendarAssoc[sId][1];
			var nDay = this.miniCalendarAssoc[sId][0];
			var oDateOthMonth = new Date();
			oDateOthMonth.setFullYear(this.currentYear);
			oDateOthMonth.setDate(nDay);
			oDateOthMonth.setMonth(this.currentMonth);	 
			
			if(nCurrMonthFlag == 0)
				oDateOthMonth.setMonth(oDateOthMonth.getMonth()-1);
			if(nCurrMonthFlag == 2)
				oDateOthMonth.setMonth(oDateOthMonth.getMonth()+1);
			if(oDateOthMonth.getMonth() == this.todayMonth
					&& oDateOthMonth.getDate() == this.todayDate
						&& oDateOthMonth.getFullYear() == this.todayYear) 
			{
				currDayDate.className += " miniCalendarToday todaySelectionBorder";	
 			} 				 			
		}
	},	
	setSelected: function (sId)
	{
		//deselect
		if(this.selectedID)
			this.setUnselected();
		
		//select
		this.selectedID = sId;
		var oDateOthMonth = new Date();
		oDateOthMonth.setFullYear(this.currentYear);
		oDateOthMonth.setDate(1);	
		oDateOthMonth.setMonth(this.currentMonth);	 	
		var back=1;
		if(this.miniCalendarAssoc[sId][1] == 0)	
		{
			oDateOthMonth.setMonth(oDateOthMonth.getMonth()-1);
			var back=0;
		}
		else if(this.miniCalendarAssoc[sId][1] == 2)	
		{
			oDateOthMonth.setMonth(oDateOthMonth.getMonth()+1);			
			var back=2;			
		}
		oDateOthMonth.setDate(this.miniCalendarAssoc[sId][0]);				
		this.selectedMonth = oDateOthMonth.getMonth();
		this.selectedYear = oDateOthMonth.getFullYear();
		this.selectedDate = oDateOthMonth.getDate();
		
		this.selectedTime = oDateOthMonth.getTime();

		oTD = $2(sId);
		oTD.className += ' background-color-PMG-selection-elements';
		if(back==0)
			this.back();
		if(back==2)
			this.next();			
	},
	getDateByID : function (sId)
	{
		var oDateOthMonth = new Date(null);
		oDateOthMonth.setUTCFullYear(this.currentYear);
		oDateOthMonth.setUTCDate(1);	
		oDateOthMonth.setUTCMonth(this.currentMonth);
		
		if(this.miniCalendarAssoc[sId][1] == 0)	
		{
			oDateOthMonth.setUTCMonth(oDateOthMonth.getUTCMonth()-1);
		}
		else if(this.miniCalendarAssoc[sId][1] == 2)	
		{
			oDateOthMonth.setUTCMonth(oDateOthMonth.getUTCMonth()+1);			
		}		
		oDateOthMonth.setUTCDate(this.miniCalendarAssoc[sId][0]);			
		return oDateOthMonth;		
	},
	setUnselected: function ()
	{
		var oTD = $2(this.selectedID);
		if(!oTD) return;
		sClassName = oTD.className;
		var aSplited = sClassName.split(' ');
		var sDeseletedClassName = '';
		for(var nInd=0;nInd < aSplited.length;nInd++)
		{
			if(aSplited[nInd].length>0 && aSplited[nInd] != "background-color-PMG-selection-elements")
			{
				sDeseletedClassName += ' '+aSplited[nInd];
			}
		}			
		oTD.className = sDeseletedClassName;
	},
	
	updateHeaderMini: function ()
	{
		//var showHeader = _(this.aMonthNames[this.currentMonth]) + ' ' + this.currentYear;
		//this.header.innerHTML = showHeader;	
	}	
}
fileloaded();
