/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2010 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

var bInfoListLoaded = false;
var bInfoListCreated = false;
var gridInfoList;
var editInfoItemId = -1;
var bSearchInfoItemMode = false;
var lockedDetailInformation;

//works only in editr mode...
function deleteSearchInfoItem() {
	if(currentpath[0] == "infostore" && currentpath[1] == "list") {
		loadLiveGridInfo();		
	} else if(currentpath[0] == "infostore" && currentpath[1] == "split") {
		loadLiveGridInfoSplit();		
	}
	infostoreFolderPath.drawDOMNode("infostoreHsplitHeaderOwner", activefolder);
}
function searchInfoItem(sModule,sPattern) {
	if (sModule=="infostore") {
	    bSearchInfoItemMode = true;
        var criteria={};
        var search={ 
            title : sPattern , url : sPattern, filename : sPattern, 
            version_comment : sPattern, categories : sPattern, description : sPattern 
        }; 
	    if(currentpath2[1]=="list") {
	        gridInfoList.disablehover=!configGetKey("gui.effects.hover.infostore");
            gridInfoList.enable(criteria,search,false);
        } else if(currentpath2[1] == "split") {
           gridInfoSplit.disablehover=!configGetKey("gui.effects.hover.infostore");
           gridInfoSplit.enable(criteria,search,false);
	    } else {
           menuswitchInfoStoreView("list");
           gridInfoList.disablehover=!configGetKey("gui.effects.hover.infostore");
           gridInfoList.enable(criteria,search,false);
	    }
	    infostoreFolderPath.drawSearch(sModule, sPattern);
	}
}

function setTagInfoStore(tag) {
	var newInfoItem = new Object();
	newInfoItem['color_label'] = parseInt(tag);	
	var selected = oLastSelectedInfoObject;
	if (currentpath[1] == "detail" && oLastSelectedInfoObject) {
		selected[0]["timestamp"] = OXCache.cachedObjects.get(oLastSelectedInfoObject[0])["timestamp"];
	}
	OXInfoStoreMapping.setTag(tag,selected);
}

function setLastSelected(ids)
{
	if(gridInfoList && gridInfoList.collection)
	{
		oLastSelectedInfoObject = gridInfoList.getSelectedIDs();
	}
	else if(gridInfoSplit && gridInfoSplit.collection)
	{
		oLastSelectedInfoObject = gridInfoSplit.getSelectedIDs();
	}
}
function lockItem() {
	var oItemToLock;
	var bUnlocked = -1;
	var aData;
	if(gridInfoList && gridInfoList.collection) {
		oItemToLock = gridInfoList.getSelectedIDs();
		var obj = OXCache.cachedObjects.get(oItemToLock[0]);
		bUnlocked = (obj["locked_until"] == 0);
	} else if(gridInfoSplit && gridInfoSplit.collection) {
		oItemToLock = gridInfoSplit.getSelectedIDs();
		var obj = OXCache.cachedObjects.get(oItemToLock[0]);
		bUnlocked = (obj["locked_until"] == 0);
	} else if(oLastSelectedInfoObject) {
		oItemToLock = oLastSelectedInfoObject;
		bUnlocked = (lockedDetailInformation==0);			
	}
	if(oItemToLock)  {
		function cb_lock(arg) {
            for(var indx=0;indx<arg.length;indx++) {
                if(arg[indx].error_id) { newServerError(arg[indx]); }       
                OXInfoStoreMapping.editObjectsInternal(oItemToLock,{});
                checkLockUnLock(oItemToLock);
            }
        }
		var aRequests = new Array();
		for(var indx=0;indx<oItemToLock.length;indx++) {
			var oReqObj = new Object();			
			oReqObj["module"] = "infostore";
			if(bUnlocked) {
				oReqObj["action"] = "lock";
			} else {
				oReqObj["action"] = "unlock";				
			}
			oReqObj["id"] = oItemToLock[indx].id;
			aRequests.push(oReqObj);
		}
		doAjaxLockRequest(aRequests,cb_lock);				
	}
}
function doAjaxLockRequest(aRequests,callback)
{
	var JsonObj = new JSON();	
	JsonObj.put(AjaxRoot + "/multiple?session=" + session,aRequests,null,callback)
}
function unLoadLiveGridInfoList()
{
	if(bInfoListLoaded)
	{
		gridInfoList.disable();
		bInfoListLoaded = false;
	}
	unregister('OX_InfoStore_Delete', deleteItems);
	unregister('OX_InfoStore_Edit', editItem);
	unregister('OX_InfoStore_Lock', lockItem);		
	unregister('OX_InfoStore_Unlock', lockItem);	 			
}

function editItem() {	
	if(gridInfoList && gridInfoList.collection)
		var aEditObjectIds = gridInfoList.getSelectedIDs();
	else if(gridInfoSplit && gridInfoSplit.collection)
		var aEditObjectIds = gridInfoSplit.getSelectedIDs();
	else
		return;
	editInfoItemId = aEditObjectIds[0];
	openNewInfoPopup("infostore",editInfoItemId.folder_id);
}

var delJSON = new JSON();
function deleteItems() {
	function cbyes() {
		var ids=infostoreSelection.getSelected();
		OXInfoStoreMapping.deleteObjects(ids, function() {
			triggerEvent("OX_Quota_Update");		
		});
	}
	
	if(gridInfoList && gridInfoList.collection) { var aDeleteObjectIdsCount = gridInfoList.getSelectedIDs().length; }
	else if(gridInfoSplit.collection) { var aDeleteObjectIdsCount = gridInfoSplit.getSelectedIDs().length; }
	
	if (aDeleteObjectIdsCount > 1) {  var confirmTextForDeleteInfoStore = _('Are you sure you want to delete selected items?'); } 
	else { var confirmTextForDeleteInfoStore = _('Are you sure you want to delete the selected item?'); }
	var confirmHeadForDeleteInfoStore = _("Delete Items");
	newConfirm(confirmHeadForDeleteInfoStore,confirmTextForDeleteInfoStore,AlertPopup.YESNO,null,null,cbyes,null);
}
var infoUserStorage;
var listUserMappingArray = new Array();		
	
function replaceUserNames()
{
	for(var nIndx=0;nIndx<listUserMappingArray.length;nIndx++) {
		var aIds = new Array();
		aIds.push(listUserMappingArray[nIndx].uid);
	}
	internalCache.getUsers(aIds, function (arg) {
		for(var nIndx=0;nIndx<listUserMappingArray.length;nIndx++)
		{	
			if(arg[listUserMappingArray[nIndx].uid]) {
				if (listUserMappingArray[nIndx].div.firstChild) {
					listUserMappingArray[nIndx].div.firstChild.data = arg[listUserMappingArray[nIndx].uid].display_name;
				} else {
					listUserMappingArray[nIndx].div.appendChild(document.createTextNode(arg[listUserMappingArray[nIndx].uid].display_name));
				}
			}
		}
	});		
}	

function gridInfoListSort_Func(id, order) {
	var criteria= { "folder_id" : activefolder };
	gridInfoList.disablehover=!configGetKey("gui.effects.hover.infostore");
    gridInfoList.enable(criteria,false);
    bInfoListLoaded = true; 
};

function loadLiveGridInfo()
{		
	bSearchInfoItemMode = false;
	register('OX_InfoStore_Delete', deleteItems);
	register('OX_InfoStore_Edit', editItem);
	register('OX_InfoStore_Lock', lockItem);
	register('OX_InfoStore_Unlock', lockItem);	
	if(!bInfoListCreated) {		
		bInfoListCreated = true;
		var clear = LiveGrid.makeClear("");
		var DomListDiv = $("lg_info_list");
		var DomListDivHeader = $("lg_info_listHeader");
	    var constructor= LiveGrid2; 
	    
	    temporary.lists.infostore = temporary.MakeList({
	        updated: function() { gridInfoList.recreate(); },
	        columns: [
                {                   
                    name : ["locked_until", "modified_by"],
                    text: "&#xa0;",
                    width: "20px",
                    style: { padding: 0, textAlign: "center" },
                    sortable: false,        
                    set: function(div, content) {
                        if (!div.firstChild)
                            div.appendChild(newnode("img", { paddingTop: "1px", width: "16", height: "16" },{ align: "top" }));
                        div.firstChild.src = content["locked_until"] > 0 ? 
                               getFullImgSrc("img/folder/document_locked.gif") : 
                               getFullImgSrc("img/folder/document.gif");
                    },
                    clear: function(div) {
                        if (!div.firstChild)
                            div.appendChild(newnode("img", { paddingTop: "1px", width: "16", height: "16" },{ align: "top" }));
                        div.firstChild.src = getFullImgSrc("img/mail/noattachment.gif");
                    }
                }, {
                    name : ["file_size", "filename", "id", "folder_id"],
                    text: "&#xa0;",
                    sortable: false,
                    width: "11px",  
                    style: { padding: 0, textAlign: "center" },
                    set: function(div, content) {
                        if (!div.firstChild) {
                            div.appendChild(newnode("img", { paddingTop: "2px", width: "7", height: "14" },{ align: "top" }));
                        }
                        div.firstChild.src = (content["file_size"]>0) ? getFullImgSrc("img/mail/attachment.gif")
                                                     : getFullImgSrc("img/mail/noattachment.gif");
                                                     
                        if (content["file_size"]>0) {
                            div.firstChild.onclick = (function(idvalue, object) { 
                                 return function(e) {
                                    openInfostoreFile(e || event, idvalue, object["id"]);
                                 } 
                            })(content["filename"], content);
                            div.firstChild.style.cursor="pointer";
                            div.firstChild.title=_("Download") + " " + content["filename"];
                        } else {
                            div.firstChild.onclick = null;
                            div.firstChild.style.cursor="default";
                            div.firstChild.title="";
                        }
                    },
                    clear: function(div) {
                        if (!div.firstChild) {
                            div.appendChild(newnode("img", { paddingTop: "2px", width: "7", height: "14" },{ align: "top" }));
                        }
                        div.firstChild.src = getFullImgSrc("img/mail/noattachment.gif");
                    }
                }, {
                    name : ["title"],
                    i18n: "description", /*i18n context*/
                    text: "Title", /*i18n*/
                    sortable: true,
                    sort : "title",
                    set: LiveGrid.defaultSet,                   
                    clear: LiveGrid.makeClear("")
                }, {
                    name : ["file_size"],
                    text: "Size", /*i18n*/
                    i18n: true,
                    sortable: true,
                    sort : "file_size",
                    width: "6em",
                    set: function (div, text) {
                        if(text < 0 )
                            var sDisplayString = '';
                        else
                        {
                            var sDisplayString = bytesToString(text);;
                        }
                        if (div.firstChild)
                            div.firstChild.data = sDisplayString;
                        else
                            div.appendChild(document.createTextNode(sDisplayString));
                    },
                    clear: LiveGrid.makeClear("")
                }, {
                    name : ["creation_date"],
                    text: "Created on", /*i18n*/
                    i18n: true,
                    sortable: true,
                    sort : "creation_date",
                    width: "8em",
                    set: LiveGrid.dateSet,
                    clear: LiveGrid.makeClear("")
                }, {
                    name : ["created_by"],
                    text: "Created by", /*i18n*/
                    i18n: true,
                    sortable: true,
                    sort : "created_by",
                    width: "20%",           
                    set: function  (div, text) {
                        var nId = parseInt(text);                                           
                        function cb_fetchUserFromCache(){
                            return function (arg)                       
                            {
                                if (div.firstChild)
                                    div.firstChild.data = arg[nId].display_name;
                                else
                                    div.appendChild(document.createTextNode(arg[nId].display_name));
                            }
                        }
                        internalCache.getUsers([nId],cb_fetchUserFromCache());      
                    },
                    clear: LiveGrid.makeClear("")
                }, {
                    name : ["version"],         
                    text: "Version", /*i18n*/
                    i18n: true,
                    style:{textAlign:"center"},
                    sortable: true,
                    sort : "version",
                    width: "6em",           
                    set: LiveGrid.defaultSet,                   
                    clear: LiveGrid.makeClear("")
                }, {                
                    name : ["last_modified"],
                    text: "Last modified", /*i18n*/
                    i18n: true,             
                    sortable: true,
                    sort : "last_modified",
                    width: "10em",
                    set: function(div, modified) {
                        var dateToShow = modified ? formatDate(modified, isToday(modified) ? "time" : "datetime") : "";
                        if (!div.firstChild) {
                            div.appendChild(div.ownerDocument.createTextNode(dateToShow));
                        } else {
                            div.firstChild.data = dateToShow;
                        }
                    },
                    clear: LiveGrid.makeClear("")
                }, {
                    name : ["color_label"],     
                    text: "Flag", /*i18n*/
                    i18n: true,             
                    sortable: true,
                    sort : "color_label",
                    width: "4em",
                    style: { padding: 0, textAlign: "center" },
                    set: function(div, content) {
                        if (!div.firstChild)
                            div.appendChild(newnode("img", { paddingTop: "2px", width: "16", height: "16" },{ align: "top" }));
                        div.firstChild.src = getFullImgSrc("img/menu/tag_"+ (content || 0 ) +".gif");
                    },
                    clear: function(div) {
                        if (!div.firstChild)
                            div.appendChild(newnode("img", { paddingTop: "2px", width: "16", height: "16" },{ align: "top" }));
                        div.firstChild.src = getFullImgSrc("img/menu/tag_0.gif");
                    }
                }
            ]
	    });
	    
	    gridInfoList = new LiveGrid2(temporary.lists.infostore.columns,
	        infostoreSelection, "infostore");
        
        gridInfoList.contextmenu = globalContextMenus.infostore;
		
		DomListDivHeader.appendChild(gridInfoList.getHeader());
		gridInfoList.getTable(DomListDiv);
		gridInfoList.events.register("Selected", function(ids){
				setLastSelected(ids);	
				triggerEvent("Selected",gridInfoList.getSelectedIDs());
				checkLockUnLock(gridInfoList.getSelectedIDs());
		});
		gridInfoList.events.register("Activated", function(ids){
			if(ids && ids.length > 0) {
			    checkLockUnLock.wait(function() {
                    if(   menucheckRight("WRITE")
                       && menucountlockable + menucounteditable == 1)
                    {
    					editItem();
                    } else {
                        triggerEvent("OX_New_Error", 4,
                            _("You do not have write permission for this object."));
                    }
			    });
			} else {
				triggerEvent("OX_Before_Create_InfoStore");
			}
		});		
		gridInfoList.events.register("Delete", function(ids) {
				if(menucheckRight("DELETE") && (ids.length > 0) && (ids.length == menucountlockable))
					deleteItems();
			}	
		);
		gridInfoList.events.register("Changed",infostore_HeaderUpdate);
	    var hv = gridInfoList.addHover(OXInfostoreHover.getContent().node, function(id) {
	        OXInfostoreHover.actualHover=hv;
	        OXInfostoreHover.refillContent(id.id,id.folder_id);                 
	    });
	    hv.setSize(OXInfostoreHover.contentobject.node);
	}
	if (bInfoSplitCreated) { 
		gridInfoList.setSort(gridInfoSplit.sort_id,gridInfoSplit.sort_order); 
	}
	gridInfoListSort_Func(gridInfoList.sort_id, gridInfoList.sort_order);
	
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2010 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

var bInfoSplitLoaded = false;
var bInfoSplitCreated = false;
var gridInfoSplit;
var editInfoItemId = -1;
var newInfoJson = new JSON();
var infostoreRequest;
var gridVersionsInfoSplit;
var aCoumnsToFetch = new Array(705,705,4,702,703,704,710,2,709);
var versionsStorage, nCurrentDetailItemTimestamp = -1;
var bDetailVersionLoaded = false, bVersionCreated = false;
var infostore_folderPathDetail;

function InfoStore() {}
InfoStore.IMAGE_MAX_FILE_SIZE=100000;

register("Loaded", function() {
	infostore_folderPathDetail = new FolderPath("infostore");
	infostore_folderPathDetail.className="linkstyle";
});

function fn_infostore_getDetails(objects, forceUpdate) {	
    if (!objects.length || activemodule != "infostore") return;
        
    // changing the selection jumps back to overview tab
    if (currentpath2[1] == "split" && currentpath2[2] != "overview") { 
        triggerEvent("OX_Switch_View", "infostore/split/overview");
    }
    
    enableInfostoreLoadingScreen(true);
        
    var collection={}
    collection.objects=[objects[0]];
    collection.columns=null;
    if (infostoreRequest) {
        OXCache.unregister(infostoreRequest.uniqueName);
        delete(infostoreRequest);
    }
        
    infostoreRequest=OXCache.newRequest(null, "infostore", collection, function(daten) {
        if (!daten || !daten.objects) {
            enableInfostoreLoadingScreen(false);
            return;
        }
        getVersions(); // updating versions
        updateInfostoreSplit(daten.objects[0]);
    }, function(daten) {
        if (!daten || !daten.objects) {
            enableInfostoreLoadingScreen(false);
            return;
        }
        updateInfostoreSplit(daten.objects[0]);
    }, forceUpdate);
    
}

function expandInfostoreSplitHeader(fullHeader) {
    if (fullHeader) $('infosplit.header_ext').style.display = "";
    $("infosplit.expand_plus").getElementsByTagName("img")[0].src =
        getFullImgSrc("img/" + (fullHeader ? "minus" : "plus") + ".gif");
    configSetKey("gui.infostore.fullsplitheader", fullHeader);    
    var steps = 6*pxPerEm;
    animate(configGetKey("gui.effects.fading") ? 250 : 0, steps, function(stepN) { 
        var an = fullHeader ? stepN : steps-stepN;
        setTimeout(function() { 
           resizeSplit("infosplit.header_ext", Math.round(an/pxPerEm) + "em"); 
        }, 0);
    }, function() { 
        if (!fullHeader) $('infosplit.header_ext').style.display = "none";
    });    
}

function resizeInfostoreSplitHeader(fullHeader) {
   setTimeout(function() {
   	    $('infosplit.header_ext').style.display = fullHeader ? "" : "none";
   	    resizeSplit("infosplit.header_ext", fullHeader ? "6em" : "0em"); 
   }, 0);
}

function enableInfostoreLoadingScreen(enabled) {
    if (enabled && $("infosplit.detail_container.content").style.display != "none") {
        $("infosplit.detail_container.content").style.display="none";
    } else if (!enabled && $("infosplit.detail_container.content").style.display != "block") {
        $("infosplit.detail_container.content").style.display="block";
    }
    if (!enabled && $("infosplit.detail_container.loading").style.display != "none") {
        $("infosplit.detail_container.loading").style.display="none";
    } else if (enabled && $("infosplit.detail_container.loading").style.display != "block") {
        $("infosplit.detail_container.loading").style.display="block";
    }    
}

function openInfostoreFile(evt, sValueCl, nObjectIdCl, triggerSave) {
    var sContentType = 'application/octet-stream';
    var sURL = AjaxRoot + '/infostore/' 
                + encodeURIComponent(sValueCl)
                + '?action=document&session=' + session
                + (triggerSave ? '&content_type=' + encodeURIComponent(sContentType) : "")
                + '&id=' + encodeURIComponent(nObjectIdCl);
    newWindow(sURL, getWindowOptions(null, null, (!triggerSave ? "scrollbars=yes" : "")));
    stopEvent(evt);
}

function updateInfostoreSplit(object) {
    if (!object || activemodule != "infostore") return;
    
    // changing the selection jumps back to overview tab
//    if (currentpath2[2] != "overview") { 
//        triggerEvent("OX_Switch_View", "infostore/split/overview");
//    }
    
    activeTaskId = new Array();
    activeTaskId[0]=object;
    aPrintDetailInfoStore=object;
    
    // disable or enable some of the areas before we go on
    if ($("infosplit.file_info").style.display != "none") {
        $("infosplit.file_info").style.display="none";
    }
    if ($("infosplit.link_info").style.display != "none") {
        $("infosplit.link_info").style.display="none";
    }
    if ($("infosplit.expand_plus").style.display != "") {
    	$("infosplit.expand_plus").style.display = "";
    }
    $("infosplit.preview_image").src=getFullImgSrc("img/dummy.gif");
    $("infosplit.preview_image").style.border="none";
    
    $("infosplit.direct_link").firstChild.data = getDirectLinkLocal(object);
    
    var finalResize = configGetKey("gui.infostore.fullsplitheader");
    writeBottomString(object,"infosplit.bottom_str");
    
    for (idfield in object) {
        var idvalue = object[idfield];         
        switch (idfield) {
        	case "description":
                  removeChildNodes($("infosplit." + idfield));
                  idvalue = idvalue || "";                    
                  var nText = idvalue.split("\n");
                  for (var i in nText) {
                      $("infosplit." + idfield).appendChild(document.createTextNode(nText[i]));
                      $("infosplit." + idfield).appendChild(newnode("br"));
                  }
                  continue;
                  break;            
            case "color_label":
                  var img = idvalue || "0";
                  $("infosplit." + idfield).src = getFullImgSrc("img/menu/tag_"+img+".gif");
                  continue;
                  break;
            case "filename":
                  if (!idvalue) continue;
                  removeChildNodes($("infosplit."+idfield));
                  
                  var oNodAncS = newnode("img", { paddingRight:"5px" },{ className: "cursorPointer", align:"absmiddle", src:getFullImgSrc("img/menu/attachment_save.gif") })
                  oNodAncS.onclick = (function(idvalue, object) { 
            	         return function(e) {
            	         	openInfostoreFile(e || event, idvalue, object["id"], true);
            	         } 
    	          })(idvalue, object);
	              $("infosplit."+idfield).appendChild(oNodAncS);
                  
	              function _openFile(idvalue, object) { 
                	  return function(e) {
                		  openInfostoreFile(e || event, idvalue, object["id"]);
                	  } 
                  }
	              
                  var oNodAnc = newnode("span", 0, {className:"linkstyle"},
                        [ document.createTextNode(idvalue) ]);  
                  oNodAnc.onclick = _openFile(idvalue, object);
                  
                  var img = newnode("img", { paddingRight:"5px" },{ className: "cursorPointer", align:"absmiddle", src:getFullImgSrc("img/mail/open_ISattachment.gif") });
                  img.onclick = _openFile(idvalue, object);
                  
                  $("infosplit."+idfield).appendChild(img);
                  $("infosplit."+idfield).appendChild(oNodAnc);
                  
                  $("infosplit.file_info").style.display="";
                  continue;
                  break;
            case "url":
                  // hide document details if no document is available
                  if (!object["filename"] && $("infosplit.expand_plus").style.display != "none") {
                  	    $("infosplit.expand_plus").style.display="none";                  	
                  	    finalResize = false;
                  }
                  // if URL is available hide show it
                  if (idvalue && $("infosplit.link_info").style.display != "") {
                        $("infosplit.link_info").style.display="";
                  }
                  removeChildNodes($("infosplit."+idfield));
                  $("infosplit."+idfield).appendChild(
                        newnode("a",0,{className:"linkstyle", href: idvalue, target: "_blank"},
                                [ document.createTextNode(idvalue)]));
                  continue;
                  break;
            case "file_size":
                  // image pre-loader
                  $("infosplit.preview_image").width="25";
                  $("infosplit.preview_image").height="25";
                  // check if file is image and smaller as the pre-defined size
                  // if so, we start to pre-load the image              
                  if (idvalue && idvalue <= (InfoStore.IMAGE_MAX_FILE_SIZE) && object["file_mimetype"] && 
                      object["file_mimetype"].match(/image\//g) && object["filename"]) {
                  	   $("infosplit.preview_image").style.border="1px solid";
                  	   $("infosplit.preview_image").src=getFullImgSrc("img/ox_animated_withoutbg.gif");
                  	   img = AjaxRoot + '/infostore/' 
                                        + encodeURIComponent(object["filename"])
                                        + '?action=document&session=' + session
                                        + '&content_type=' + encodeURIComponent(object["file_mimetype"])
                                        + '&id=' + encodeURIComponent(object["id"]);
                       var preImg = new Image();
                       preImg.src = img;
                       var timer, control = 1;
                       // check if image has been loaded, then set new image
                       // the check will be done each second, 10 times max 
                       function checkLoaded() {
                            if (preImg.complete) {
                            	$("infosplit.preview_image").src=preImg.src;                            	
                            	var newWidth = Math.floor(preImg.width/Math.floor(preImg.height/72));
                            	$("infosplit.preview_image").width = newWidth != "Infinity" ? newWidth : preImg.width;
                            	$("infosplit.preview_image").height= preImg.height > 72 ? 72 : preImg.height;
                            	clearTimeout(timer);
                            	delete(timer);
                            } else if (control <= 10) {
                                control++;
                                timer = setTimeout(checkLoaded,1000);
                            }
                       }
                       checkLoaded();               
                  }                  
                  idvalue = idvalue ? bytesToString(idvalue) : null;
                  break;
            case "file_mimetype":
                  if (!idvalue) continue;
                  removeChildNodes($("infosplit."+idfield));
                  $("infosplit."+idfield).appendChild(
                    newnode("img", { paddingRight: "5px"}, { src: getMimeImage(idvalue), align: "absmiddle"}));
                  $("infosplit."+idfield).appendChild(document.createTextNode(idvalue));
                  continue;
                  break;
            case "modified_by":
                  if (!idvalue || !object["locked_until"]) {
                  	idvalue = null;
                  	break;
                  }
                  var fnSetModifiedBy = (function fnSetModifiedBy(idfield, idvalue, lockedUntil) {
                      return function(arg) {
                          $("infosplit." + idfield).firstChild.data =
                                //#. Information about a locked InfoItem
                                //#. %1$s is the name of the user who locked the Infoitem.
                                //#. %2$s is the expiration date of the lock.
                                //#, c-format
                                format(_("by %1$s until %2$s"), arg[idvalue].display_name, 
                                        formatDate(lockedUntil, "datetime")); 
                      }
                  })(idfield, idvalue, object["locked_until"]);
                  internalCache.getUsers([idvalue],fnSetModifiedBy);
                  continue;
                  break;
            case "categories":
        		  var cat = (idvalue || "");
                  $("infosplit."+idfield).style.display = cat.length ? "" : "none";                  
                  if (cat.length) {
	                  if (Object.prototype.toString.call(cat) == "[object Array]") {
	                	  cat = cat.join(", ");
	                  }
	                  ox.categories.ui.drawCategoriesList(ox.categories.getByString(cat), 
	                		  $("infosplit."+idfield+"_d"));
                  } else {
                	  removeChildNodes($("infosplit."+idfield+"_d"));
                  }
                  continue;
                  break;
            case "folder_id":
                  if (!idvalue) continue;
                  infostore_folderPathDetail.drawDOMNode("infosplit.folder_id", idvalue);
                  continue;
                  break;
        }        
        if ($("infosplit." + idfield)) {
            $("infosplit." + idfield).firstChild.data = idvalue != null ? idvalue : _("Not set");
        }
    }
    enableInfostoreLoadingScreen(false);
    setTimeout(function() {
    	   resizeInfostoreSplitHeader(finalResize);
        },0);
}

function cb_infostore_selection_changed() {
    if (!infostoreSelection.getSelected().length) return;   
    fn_infostore_getDetails(infostoreSelection.getSelected());        
}

function clearInfostoreSplitDetails() {
    $("infosplit.detail_container.content").style.display="none";
    $("infosplit.detail_container.loading").style.display="none";
    if ($("infosplit.bottom_str").firstChild) {
    	$("infosplit.bottom_str").firstChild.data="\u00a0"; // clean bottom str
    }
    if (currentpath2[1] == "split" && currentpath2[2] != "overview") { 
        triggerEvent("OX_Switch_View", "infostore/split/overview");
    }
}

function clearInfoTable(sId) {
    var DOMSplitTable = $(sId);
    var aDivs = DOMSplitTable.getElementsByTagName('div');
    var len = aDivs.length;
    for(nDiv=0;nDiv < len;nDiv++) { 
        if(aDivs[nDiv]) { removeChildNodes(aDivs[nDiv]); }
    }
}

function gridInfoSplitSort_Func(id, order) {
	var criteria= { "folder_id" : activefolder };
	gridInfoSplit.disablehover=!configGetKey("gui.effects.hover.infostore");
    gridInfoSplit.enable(criteria,false);
    bInfoSplitLoaded = true;
}

function loadLiveGridInfoSplit() {	
	bSearchInfoItemMode = false;	
	if(!bInfoSplitCreated) {
		bInfoSplitCreated = true;
		var clear = LiveGrid.makeClear("");
		var DomListDiv = $("lg_info_split");
		var DomListDivHeader = $("lg_info_splitHeader");
		gridInfoSplit = new LiveGrid2([
			{					
				name : ["locked_until", "modified_by"],
				text: "&#xa0;",
				width: "20px",
				style: { padding: 0, textAlign: "center" },
				sortable: false,		
				set: function(div, content) {
					if (!div.firstChild) {
						div.appendChild(newnode("img", { paddingTop: "1px", width: "16", height: "16" },{ align: "top" }));
					}
					div.firstChild.src = content["locked_until"] > 0 ? 
					       getFullImgSrc("img/folder/document_locked.gif") : 
					       getFullImgSrc("img/folder/document.gif");
				},
				clear: function(div) {
					if (!div.firstChild) {
						div.appendChild(newnode("img", { paddingTop: "1px", width: "16", height: "16" },{ align: "top" }));
					}
					div.firstChild.src = getFullImgSrc("img/mail/noattachment.gif");
				}
			}, {
				name : ["file_size", "filename", "id", "folder_id"],
				text: "&#xa0;",
				sortable: false,
				width: "11px",	
				style: { padding: 0, textAlign: "center" },
				set: function(div, content) {
					if (!div.firstChild) {
						div.appendChild(newnode("img", { paddingTop: "2px", width: "7", height: "14"  },{ align: "top" }));
					}
					div.firstChild.src = (content["file_size"]>0) ? getFullImgSrc("img/mail/attachment.gif")
					                             : getFullImgSrc("img/mail/noattachment.gif");
					                             
					if (content["file_size"]>0) {
                        div.firstChild.onclick = (function(idvalue, object) { 
                             return function(e) {
                                openInfostoreFile(e || event, idvalue, object["id"]);
                             } 
                        })(content["filename"], content);
                        div.firstChild.style.cursor="pointer";
                        div.firstChild.title=_("Download") + " " + content["filename"];
                    } else {
                    	div.firstChild.onclick = null;
                    	div.firstChild.style.cursor="default";
                        div.firstChild.title="";
                    }
				},
				clear: function(div) {
					if (!div.firstChild) {
						div.appendChild(newnode("img", { paddingTop: "2px", width: "7", height: "14" },{ align: "top" }));
					}
					div.firstChild.src = getFullImgSrc("img/mail/noattachment.gif");
				}
			}, {
				name : ["title"],
                i18n: "description", /*i18n context*/
				text: "Title", /*i18n*/
				sortable: true,
				sort : "title",
				set: LiveGrid.defaultSet,					
				clear: LiveGrid.makeClear("")
			}, {
				name : ["file_size"],
				text: "Size", /*i18n*/
				i18n: true,
				sortable: true,
				sort : "file_size",
				width: "6em",
				set: function (div, text) {
					if (text < 0) {
						var sDisplayString = "";
					} else {
						var sDisplayString = bytesToString(text);
					}
					if (div.firstChild) {
						div.firstChild.data = sDisplayString;
					} else {
						div.appendChild(document.createTextNode(sDisplayString));
					}
				},
				clear: LiveGrid.makeClear("")
			}, {
				name : ["creation_date"],
				text: "Created on", /*i18n*/
				i18n: true,
				sortable: true,
				sort : "creation_date",
				width: "8em",
				set: LiveGrid.dateSet,
				clear: LiveGrid.makeClear("")
			}, {
				name : ["created_by"],
				text: "Created by", /*i18n*/
				i18n: true,
				sortable: true,
				sort : "created_by",
				width: "20%",			
				set: function  (div, text) {
					var nId = parseInt(text);											
					function cb_fetchUserFromCache(){
						return function (arg) {
							if (div.firstChild) {
								div.firstChild.data = arg[nId].display_name;
							} else {
								div.appendChild(document.createTextNode(arg[nId].display_name));
							}
						}
					}
					internalCache.getUsers([nId],cb_fetchUserFromCache());		
				},
				clear: LiveGrid.makeClear("")
			}, {
				name : ["version"],			
				text: "Version", /*i18n*/
				i18n: true,
				style:{textAlign:"center"},
				sortable: true,
				sort : "version",
				width: "6em",			
				set: LiveGrid.defaultSet,					
				clear: LiveGrid.makeClear("")
			}, {				
				name : ["last_modified"],
				text: "Last modified", /*i18n*/
				i18n: true,				
				sortable: true,
				sort : "last_modified",
				width: "10em",
				set: function(div, modified) {
					var dateToShow = modified ? formatDate(modified, isToday(modified) ? "time" : "datetime") : "";
				    if (!div.firstChild) {
				    	div.appendChild(div.ownerDocument.createTextNode(dateToShow));
				    } else {
				    	div.firstChild.data = dateToShow;
				    }
				},
				clear: LiveGrid.makeClear("")
			}, {
				name : ["color_label"],		
				text: "Flag", /*i18n*/
				i18n: true,				
				sortable: true,
				sort : "color_label",
				width: "4em",
				style: { padding: 0, textAlign: "center" },
				set: function(div, content) {
                    if (!div.firstChild) {
                        div.appendChild(newnode("img", { paddingTop: "2px", width: "16", height: "16" },{ align: "top" }));
                    }
                    div.firstChild.src = getFullImgSrc("img/menu/tag_"+ (content || 0 ) +".gif");
                },
                clear: function(div) {
                    if (!div.firstChild) {
                        div.appendChild(newnode("img", { paddingTop: "2px", width: "16", height: "16" },{ align: "top" }));
                    }
                    div.firstChild.src = getFullImgSrc("img/menu/tag_0.gif");
                }
			}
		], infostoreSelection, "infostore");
        gridInfoSplit.contextmenu = globalContextMenus.infostore;
		//gridInfoSplit.sort = gridInfoSplitSort_Func;
		DomListDivHeader.appendChild(gridInfoSplit.getHeader());
		gridInfoSplit.getTable(DomListDiv);
		gridInfoSplit.events.register("Selected", function(ids){
			setLastSelected(ids);			
			if (ids == 1)  {                
                cb_infostore_selection_changed();                
            } else if (currentpath2[1]=="split") {
                clearInfostoreSplitDetails();
            }
            checkLockUnLock(gridInfoSplit.getSelectedIDs());
            triggerEvent("Selected", gridInfoSplit.getSelectedIDs());
		});
		gridInfoSplit.events.register("Activated", function(ids){
			if(ids && ids.length > 0) {
			    checkLockUnLock.wait(function() {
    				if(   menucheckRight("WRITE")
                       && menucountlockable + menucounteditable == 1)
                    {
    					editItem();
                    } else {
                        triggerEvent("OX_New_Error", 4,
                            _("You do not have write permission for this object."));
                    }
			    });
			} else {
				triggerEvent("OX_Before_Create_InfoStore");
			}
		});
		gridInfoSplit.events.register("Delete", function(ids) {
			if (menucheckRight("DELETE") && (ids.length > 0) && (ids.length == menucountlockable))
				deleteItems();
			}	
		);
		gridInfoSplit.events.register("Changed",infostore_HeaderUpdate);
		var hv = gridInfoSplit.addHover(OXInfostoreHover.getContent().node, function(id) {
	        OXInfostoreHover.actualHover=hv;
	        OXInfostoreHover.refillContent(id.id,id.folder_id);                 
	    });
	    hv.setSize(OXInfostoreHover.contentobject.node);
	}
    if (bInfoListCreated) {    
        gridInfoSplit.setSort(gridInfoList.sort_id,gridInfoList.sort_order);        
    }
	gridInfoSplitSort_Func(gridInfoSplit.sort_id, gridInfoSplit.sort_order);
}

/********************************** VERSION TAB **********************************/

function loadDetailDocumentVersions(arg, cb_functionDetail) {   
    if(arg=='version') {
        var oObjectIdObj = oLastSelectedInfoObject[0];
        function setDocSize(div, text) {
            if(text < 0 ) { var sDisplayString = ''; }
            else { var sDisplayString = bytesToString(text); }
            
            if (div.firstChild) { div.firstChild.data = sDisplayString; }
            else { div.appendChild(document.createTextNode(text)); }
        }   
        if(!bVersionCreated) {
	        bVersionCreated = true; 
	        var clear = LiveGrid.makeClear("...");
	        var DomListDiv = $("lg_versions_info_split");
	        var DomListDivHeader = $("lg_versions_info_splitHeader");
	        gridVersionsInfoSplit = new LiveGrid([
	        {
	            index: 1,
	            text: "Version", /*i18n*/
	            i18n: true,                     
	            width: "6em",                               
	            sortable: false,
	            set: LiveGrid.defaultSet,                   
	            clear: LiveGrid.makeClear("...")
	        }, {
	            index: 2,
	            text: "Created", /*i18n*/
	            i18n: true,                     
	            width: "8em",                               
	            sortable: false,
	            set: LiveGrid.dateSet,              
	            clear: LiveGrid.makeClear("...")
	        }, {
	            index: 3,                   
	            text: "File", /*i18n*/
	            i18n: true,                     
	            sortable: false,
	            set: LiveGrid.defaultSet,                   
	            clear: LiveGrid.makeClear("...")
	        }, {
	            index: 4,       
	            text: "Mime Type", /*i18n*/
	            i18n: true,                     
	            sortable: true,
	            width: "15em",          
	            set: LiveGrid.defaultSet,                   
	            clear: LiveGrid.makeClear("...")
	        }, {
	            index: 5,                   
	            text: "Size", /*i18n*/
	            i18n: true,                     
	            width: "8em",                                                       
	            sortable: false, 
	            set: setDocSize,
	            clear: LiveGrid.makeClear("...")
	        }, {
	            index: 6,                   
	            text: "Current", /*i18n*/
	            i18n: true,                     
	            width: "6em",                                                       
	            sortable: false, 
	            set: function (div, text) {
	                if(text) var sDisplayString = _('Yes');
	                else
	                {
	                    var sDisplayString = _('No');
	                }
	                if (div.firstChild)
	                    div.firstChild.data = sDisplayString;
	                else
	                    div.appendChild(document.createTextNode(sDisplayString));
	            },              
	            clear: LiveGrid.makeClear("")
	        }], new Selection());
	        DomListDivHeader.appendChild(gridVersionsInfoSplit.getHeader());
	        gridVersionsInfoSplit.getTable(DomListDiv);
	        gridVersionsInfoSplit.events.register("Selected", function(ids) {
	            refreshDetailVersions(ids);                 
	            triggerEvent("SubSelected",ids);
	        });
	        getVersions();
            var menu = gridVersionsInfoSplit.contextmenu = new ContextMenu();
            var current = new MenuItem("Current"/*i18n*/,
                function() { triggerEvent('OX_InfoStore_Version_Current'); });
            current.setIcon("img/menu/infostorecurrentversion.gif",
                            "img/menu/infostorecurrentversion_d.gif");
            menu.addItem(current);
            var del = new MenuItem("Delete"/*i18n*/,
                function() { triggerEvent('OX_InfoStore_Version_Delete'); });
            del.setIcon("img/menu/delete.gif", "img/menu/delete_d.gif");
            menu.addItem(del);
            var req;
            menu.onShow = function() {
                var collection = {
                    columns: ["created_by", "modified_by", "locked_until",
                              "file_size", "filename"],
                    objects: infostoreSelection.getSelected()
                };
                req = OXCache.newRequest(null, "infostore", collection,
                                   callback, callback);
                function callback(objects) {
                    var count = menu.getContext().count;
                    var hasRights;
                    if (count)
                        hasRights = menuhasRight(objects.objects, "WRITE")
                                 && checkRights(objects.objects);
                    current.setEnabled(count == 1 && hasRights);
                    del.setEnabled(count > 0 && hasRights);
                }
                function checkRights(objects) {
                    var me = configGetKey("identifier");
                    for(var i in objects) {
                        var obj = objects[i];
                        if(obj.locked_until && obj.modified_by != me) return false;
                    }
                    return true;
                }
            };
            menu.onHide = function() { OXCache.unregister(req.uniqueName); };
        } else {  
        	getVersions(cb_functionDetail); 
        }
    }
}

function getVersions(cb_functionVersion) {
    versionsStorage = new Storage(0, []);
    function cb_versions(arg) {
        versionsStorage.append(arg.data);
        versionsStorage.timestamp = arg.timestamp;
        nCurrentDetailItemTimestamp = versionsStorage.timestamp;
        gridVersionsInfoSplit.enable(versionsStorage);
        bDetailVersionLoaded = true; 
        if(cb_functionVersion) cb_functionVersion();
    }
    if (gridVersionsInfoSplit) {
        doAjaxFetchAllVersions(cb_versions);
    } else {
        if (cb_functionVersion) cb_functionVersion();
    };
}

function doAjaxFetchAllVersions(callback) {
    var sColumns = aCoumnsToFetch.join(",");
    var oObjectIdObj = oLastSelectedInfoObject[0];
    var sAjaxRequest = AjaxRoot + "/infostore?action=versions&id=" + oObjectIdObj.id + "&columns="+sColumns+"&session=" + session;
    new JSON().get(sAjaxRequest, null,callback);
}

function refreshDetailVersions(ids) {
    clearInfoTable('version_det_table');
    if (ids > 0) {
        var aSelIds = gridVersionsInfoSplit.getSelectedIDs();
        var aData = versionsStorage.data.data;
        var oObj = oLastSelectedInfoObject[0];
        var nVersionId =  aSelIds[0];
        var aDataSelected  =aData[nVersionId];

        for (nInd=0; nInd<aDataSelected.length; nInd++) {
            var nColumn = aCoumnsToFetch[nInd];         
            var PREFIX = "vers_detail_";
            var sDOMID = PREFIX + nColumn;      
            var sValue = aDataSelected[nInd];   
            if(nColumn == 2) {
                var newValue = sValue;
                var stopId = sDOMID;
                var arr = new Array();
                arr[0] = sValue;
                function fnSetUserColumn(arg) {                   
                    if (document.getElementById(stopId)) {
                        if ($(stopId).firstChild)
                            removeChildNodes($(stopId));
                        $(stopId).appendChild(document.createTextNode(arg[newValue].display_name || ""))
                    }
                }
                sValue = internalCache.getUsers(arr,fnSetUserColumn);
                continue;
            }
            if (nColumn == 702) {
                var oNodAnc = newnode("span",0,{className:"linkstyle"});
                function openFIleInfoStore(evt) {               
                    var sContentType = 'application/octet-stream';
                    var sURL = AjaxRoot + '/infostore/' + encodeURIComponent(sValue)
                            + '?action=document&session=' + session
                            + '&content_type=' + encodeURIComponent(sContentType)
                            + '&id=' + encodeURIComponent(oObj.id)
                            + '&version=' + encodeURIComponent(nVersionId);
                    $('dlIframe').src = sURL;   
                    stopEvent(evt);
                }
                var oTextNode = document.createTextNode(sValue);                
                addDOMEvent(oNodAnc,"click",openFIleInfoStore);             
                document.getElementById(sDOMID).appendChild(oNodAnc);                       
                oNodAnc.appendChild(oTextNode);       
                continue;
            }
            if ($(sDOMID)) {   
                if ($(sDOMID).firstChild)
                    removeChildNodes($(sDOMID));        
                 //version comment
                if (nColumn == 709 && typeof(sValue) == "string") {
                    //sValue = sValue.replace(/\n/g,'<BR>');
                    var text = sValue.split("\n");
                    for (var i = 0; i < text.length; i++) {
                        $(sDOMID).appendChild(document.createTextNode(text[i]));
                        $(sDOMID).appendChild(newnode("br"));
                    }                   
                } else {
                    $(sDOMID).appendChild(document.createTextNode(sValue));             
                }
            }
        }
    }
}

function deleteDetailVersion() {
    function cbyes() {
        var oObjectIdObj = oLastSelectedInfoObject[0];  
        var aVersions = gridVersionsInfoSplit.getSelectedIDs();
        var nTimeStamp = versionsStorage.timestamp;
        
        function cb_detach_version(arg) { getVersions(); }
        doAjaxDetachVersion(oObjectIdObj,aVersions,nTimeStamp,cb_detach_version);
    }
    newConfirm(_("Delete Version"),_('Are you sure you want to delete the selected version?'),AlertPopup.YESNO,null,null,cbyes);
}

function setCurrentVersion() {   
    var oObjectIdObj = oLastSelectedInfoObject[0];  
    var aVersions = gridVersionsInfoSplit.getSelectedIDs();
    var nVersion = aVersions[0]; //one Selected...
    var nTimeStamp = versionsStorage.timestamp;
    function cb_set_current(arg)  { 
    	getVersions(findVersion); 
    }
    function findVersion() {
        versionsStorage.newIterate([nVersion], emptyFunction, updateCache);
    }
    function updateCache(n, data) {
    	OXCache.newRequest(null, "infostore", { columns: null,
            objects: [oObjectIdObj] }, null, emptyFunction, true);
    }
    var newInfoItem = new Object();
    newInfoItem['version'] = parseInt(nVersion);
    doAjaxRequestUpdateItem(oObjectIdObj,newInfoItem,nTimeStamp,cb_set_current);
}

function doAjaxRequestUpdateItem(oId,newInfoItem,nTimeStamp,callback) {
    var nId = parseInt(oId.id);
    var sAjaxRequest = AjaxRoot + "/infostore?action=update&id="+nId+"&timestamp="+nTimeStamp+"&session=" + session;
    new JSON().put(sAjaxRequest, newInfoItem, null,callback);      
}

function doAjaxDetachVersion(oObjectIdObj,aVersions,nTimeStamp,callback) {
    var sAjaxRequest = AjaxRoot + "/infostore?action=detach&id=" + oObjectIdObj.id +"&session=" + session + 
                                    "&folder=" +oObjectIdObj.folder + "&timestamp=" + nTimeStamp;
    new JSON().put(sAjaxRequest, aVersions,null,callback);
}

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2010 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

var infostoreSelection = new Selection2();
var infoSplitTabsList;
var infoSplitPanelsList;
var infoSplitEventList;
var oLastSelectedInfoObject = -1;
var propertiesPopUp;
var bLoadedDetailViewOverView = false;
var aPrintDetailInfoStore;
var infostoreFolderPath;

registerPrintView("infostore/list");
registerPrintView("infostore/split/overview");
registerModule("infostore", "InfoStore",60); /*i18n*/
registerModuleView("infostore","InfoStore",5,{x:0,y:1,ww:1,hw:1});

register("Loaded", function() {	
	infostoreFolderPath = new FolderPath("infostore");
    register("OX_Switch_InfoStore_Detail",function(param) { menuswitchInfoStoreDetail(param) }); 
	infoSplitTabsList = new Array('tab_infodetail1','tab_infodetail2');
    infoSplitPanelsList = new Array('panel_infodetail1','panel_infodetail2');
    infoSplitEventList = new Array(
            ['OX_Switch_InfoStore_Detail','overview'],
            ['OX_Switch_InfoStore_Detail','version']
    );
	
    var menu = new PulldownMenu($("arrowForInfostoreListOptions"));
    menu.addItem((new MenuItem("Options"/*i18n*/, showOptions))
                  .setIcon("img/folder/settings.gif"));
    var menu = new PulldownMenu($("arrowForInfostoreSplitOptions"));
    menu.addItem((new MenuItem("Options"/*i18n*/, showOptions))
                  .setIcon("img/folder/settings.gif"));
    function showOptions() {
        var elem=currentpath2.join("/");
        if(elem.indexOf("infostore") == 0) {
            triggerEvent("OX_Switch_View", "configuration/infostore/preferences");
        }   
    }
});

registerView("infostore",
        null,
        null,       
        function() {
            triggerEvent("Selected",[]);        
        }, 
        function() {
            if (infostoreRequest) {
                OXCache.unregister(infostoreRequest.uniqueName);
                infostoreRequest=null;
            }
            menuclearSearch();
        },
        null        
);

registerView("infostore/list",
        function() { 
			showNode("infostore_list"); 
			$("infostore_list").style.display=""; 
		}, 
		function() { 
			loadLiveGridInfo();
			if (gridInfoList) {				
				infostore_setFocus(gridInfoList);
			}
			register('OX_InfoStore_Delete', deleteItems);
            register('OX_InfoStore_Edit', editItem);
            register('OX_InfoStore_Lock', lockItem);
            register('OX_InfoStore_Unlock', lockItem);
			register('OX_Add_Flag',setTagInfoStore);			
			register("OX_New_Search",searchInfoItem);
			register("OX_Delete_Search",deleteSearchInfoItem);			
			register("OX_Print",infostore_print);
			register("OX_InfoStore_Send_Attachment",infostore_sendAttachment);
			if ("infostore_sendLink" in window) {
				register("OX_InfoStore_Send_Link",infostore_sendLink);
			}
			register("OX_InfoStore_Open_Attachment",openFileinInfoStore);
            register("OX_InfoStore_Save_Attachment",saveFileinInfoStore);
        }, 
        function() {
			unLoadLiveGridInfoList();
			menuclearSearch();
			infostoreFolderPath.clear();
			unregister('OX_InfoStore_Delete', deleteItems);
            unregister('OX_InfoStore_Edit', editItem);
            unregister('OX_InfoStore_Lock', lockItem);
            unregister('OX_InfoStore_Unlock', lockItem);
			unregister('OX_Add_Flag',setTagInfoStore);		
			unregister("OX_New_Search",searchInfoItem); 
			unregister("OX_Delete_Search",deleteSearchInfoItem);									
			unregister("OX_Print",infostore_print);	
			unregister("OX_InfoStore_Send_Attachment",infostore_sendAttachment);
			if ("infostore_sendLink" in window) {
				unregister("OX_InfoStore_Send_Link",infostore_sendLink);
			}
			unregister("OX_InfoStore_Open_Attachment",openFileinInfoStore);
            unregister("OX_InfoStore_Save_Attachment",saveFileinInfoStore);
        },
        function() {
			hideNode("infostore_list"); 
			$("infostore_list").style.display="none";
		},
        function(changedFolder) {
        	if (changedFolder != undefined) {
        		 menuclearSearch();
        		 loadLiveGridInfo();
        		 if (gridInfoList) {
        		    infostore_setFocus(gridInfoList); 				    
        		 }
        	}	
        }
);

registerView("infostore/split",
        function() { 
            showNode("infostore_split"); 
            $("infostore_split").style.display=""; }, 
        function() {
            loadLiveGridInfoSplit();                      
            setTabLists(infoSplitTabsList, infoSplitPanelsList, infoSplitEventList);
            if (gridInfoSplit) {            	
                infostore_setFocus(gridInfoSplit);
            }           

            // re-select id, if it's a direct link for example
            if (oLastSelectedInfoObject.length && oLastSelectedInfoObject[0].directLink &&
                oLastSelectedInfoObject[0].id) {
                delete(oLastSelectedInfoObject[0].directLink);
                gridInfoSplit.selection.selectIDs([ Key.createfromObject(oLastSelectedInfoObject[0]) ])
            } else {
                gridInfoSplit.selection.selectIDs(
                    gridInfoSplit.selection.getSelected());
            }
            expandInfostoreSplitHeader(configGetKey("gui.infostore.fullsplitheader"));
            
            register('OX_InfoStore_Delete', deleteItems);
            register('OX_InfoStore_Edit', editItem);
            register('OX_InfoStore_Lock', lockItem);
            register('OX_InfoStore_Unlock', lockItem);  
            register('OX_Add_Flag', setTagInfoStore);
            register("OX_New_Search", searchInfoItem);
            register("OX_Delete_Search", deleteSearchInfoItem); 
            register("OX_Print",infostore_print);     
            register("OX_InfoStore_Send_Attachment", infostore_sendAttachment);
            if ("infostore_sendLink" in window) {
            	register("OX_InfoStore_Send_Link", infostore_sendLink);
            }
            register("OX_InfoStore_Open_Attachment", openFileinInfoStore);  
            register("OX_InfoStore_Save_Attachment", saveFileinInfoStore);  
        }, 
        function() {
            if (infostoreRequest) {
                OXCache.unregister(infostoreRequest.uniqueName);
                infostoreRequest=null;
            }
            if (bInfoSplitLoaded) { 
		        gridInfoSplit.disable();
		        bInfoSplitLoaded = false;
		    }
            menuclearSearch();
            infostoreFolderPath.clear();
            unregister('OX_InfoStore_Delete', deleteItems);
            unregister('OX_InfoStore_Edit', editItem);
            unregister('OX_InfoStore_Lock', lockItem);
            unregister('OX_InfoStore_Unlock', lockItem); 
            unregister('OX_Add_Flag', setTagInfoStore);
            unregister("OX_New_Search", searchInfoItem);
            unregister("OX_Delete_Search", deleteSearchInfoItem);
            unregister("OX_Print",infostore_print);
            unregister("OX_InfoStore_Send_Attachment", infostore_sendAttachment);
            if ("infostore_sendLink" in window) {
            	unregister("OX_InfoStore_Send_Link", infostore_sendLink);
            }
            unregister("OX_InfoStore_Open_Attachment", openFileinInfoStore);
            unregister("OX_InfoStore_Save_Attachment", saveFileinInfoStore);
        },
        function() {
            hideNode("infostore_split"); 
            $("infostore_split").style.display="none";
        },
        function(changeFolder) {  	
        	if (changeFolder != undefined) {
        		menuclearSearch();
        		loadLiveGridInfoSplit();
        		if (gridInfoSplit) {
                    infostore_setFocus(gridInfoSplit);                    
                }                
        	}   
        }
);
  
registerView("infostore/split/overview",
        function() {
            $("tab_infodetail1").style.display="block";
            $("panel_infodetail1").className="tabbing_tab_active";
        }, 
        null,
        null,
        function() {    
            $("tab_infodetail1").style.display="none";
            $("panel_infodetail1").className="tabbing_tab_inactive";
        }
);

registerView("infostore/split/version",
		function() {
			$("tab_infodetail2").style.display="block";
			$("panel_infodetail2").className="tabbing_tab_active";
		}, 
		function() { 
			function clickVersionInformation() {				
				if(gridVersionsInfoSplit && gridVersionsInfoSplit.selection && gridVersionsInfoSplit.selection.count == 1)			
					gridVersionsInfoSplit.selection.click(gridVersionsInfoSplit.selection.anchor);	
			}
			loadDetailDocumentVersions("version", clickVersionInformation);
			if (bDetailVersionLoaded) {
				getVersions();
			}				
			register('OX_InfoStore_Version_Delete', deleteDetailVersion);
			register('OX_InfoStore_Version_Current', setCurrentVersion);	
			register('OX_Refresh', getVersions);				
		},
		function() {
			if (bDetailVersionLoaded) {   
                gridVersionsInfoSplit.disable();
                bDetailVersionLoaded = false;
            }
			unregister('OX_InfoStore_Version_Delete', deleteDetailVersion);
			unregister('OX_InfoStore_Version_Current', setCurrentVersion);		
			unregister('OX_Refresh', getVersions);							
		},
		function() {
			$("tab_infodetail2").style.display="none";
			$("panel_infodetail2").className="tabbing_tab_inactive";
		}
);

function infostore_setFocus(grid) {
    if (grid && grid.collection && infostoreSelection.count.length) {
        var index = grid.collection.getIndex(infostoreSelection.getSelected()[0]);
        grid.focus = index ? index-1 : 0;
        grid.showFocus();
    }
}
	
function openFileinInfoStore(objects) {     
    for(var i in objects) { 
        var sContentType = 'application/octet-stream';
        var sURL = AjaxRoot + "/infostore/" + encodeURIComponent(objects[i].filename) 
                    + "?action=document&session=" + session
                    + '&id=' + encodeURIComponent(objects[i].id);
        newWindow(sURL, getWindowOptions(null, null, "scrollbars=yes"));
    }
}

function saveFileinInfoStore(objects) {     
    for(var i in objects) { 
        var sContentType = 'application/octet-stream';
        var sURL = AjaxRoot + "/infostore/" + encodeURIComponent(objects[i].filename) 
                    + "?action=document&session=" + session
                    + '&content_type=' + encodeURIComponent(sContentType)
                    + '&id=' + encodeURIComponent(objects[i].id);
        newWindow(sURL, getWindowOptions());
    }
}

function jumpToInfoStoreConfiguration(divId) {
	if(divId && $(divId))
		$(divId).style.display = 'none';
	triggerEvent("OX_Switch_View","configuration/infostore/preferences");
}

function infostore_sendAttachment(bSendAsLink) {	
	function cb_openWindow(arg) {	
		var aInfoMailObj = new Array();
		var hasLink = false;
		for(var indx=0;indx < arg.length;indx++) {
			var obj = arg[indx].data;
			if (obj.file_size <= 0) {
				hasLink=true;
			}
			var oInfoMailObj = new Object();
			oInfoMailObj["filename"] = obj.filename;			
			oInfoMailObj["size"]= obj.file_size;		
			oInfoMailObj["content_type"]= obj.file_mimetype;			
			oInfoMailObj["content"]= null;
			oInfoMailObj["disk"]= null;
			oInfoMailObj["id"] = obj.id;
			oInfoMailObj["selected"] = false;
			oInfoMailObj["msgref"] = null;
			oInfoMailObj["infostore"] = true;
			oInfoMailObj["aslink"] = (bSendAsLink!=undefined && bSendAsLink);	
			aInfoMailObj.push(oInfoMailObj);
		}
		
		function cbyes() {
		    // compose new mail
		    ox.api.mail.compose({
		        data: {
		            aInfoMailAttachmentFile: aInfoMailObj
		        }
		    });
//			var newMail = newWindow("newMail.html", getWindowOptions());
//			if (newMail) {
//			    newMail.window.aInfoMailAttachmentFile = aInfoMailObj;
//			}
		}
		
		if (hasLink) {
			newConfirm(_("Send Attachment"),
				_("This object does not contain a file, would you like to send the link?"),
				AlertPopup.YESNO,null,null, function() { infostore_sendLink(arg) },
				null);
		} else {
			cbyes();
		}
	}
	doAjaxGetInfoItemMulti(oLastSelectedInfoObject,cb_openWindow);
}

function doAjaxGetInfoItemMulti(aItems, callback) {
	var aRequestes = new Array();
	for (var nindx=0;nindx<aItems.length;nindx++) {
		var oReqObj = new Object();
		oReqObj["module"] = "infostore";
		oReqObj["action"] = "get";
		oReqObj["folder"] = aItems[nindx].folder;
		oReqObj["id"] = aItems[nindx].id;		
		aRequestes.push(oReqObj);
	}
	var multJSON = new JSON();
	multJSON.put(AjaxRoot + "/multiple?session=" + session,aRequestes,null,callback);
}

function reloadInfoStoretDetailView() {
	triggerEvent("OX_Switch_View", "infostore/split/overview");
}

function infostore_print() {	
    if (!infostoreSelection || activemodule != "infostore") {
        return;
        
    } else if (infostoreSelection.count > 1) {    	
        if (currentpath2[1] == "split" && gridInfoSplit) {
            globalprint.printLiveGrid(gridInfoSplit)
        } else if (gridInfoList) {
            globalprint.printLiveGrid(gridInfoList);
        }
        
    } else {
    	if (!aPrintDetailInfoStore) return;
        
        /* detail print */
        var aPrintData = new Array();
        var detailInfoPrint = new Print(aPrintDetailInfoStore.title);
        
        aPrintData.push(Print.createTitle(aPrintDetailInfoStore.title || ""));
        aPrintData.push(Print.createLine("5px"));
        aPrintData.push(Print.createEmpty(true));
        
        if (aPrintDetailInfoStore.filename && aPrintDetailInfoStore.filename.length > 0) {
            aPrintData.push(Print.createContent(_("Document:"), aPrintDetailInfoStore.filename));
        }
        
        if (aPrintDetailInfoStore.created_by) {
	        var aTMPusrArray2 = new Array();
	        aTMPusrArray2[0]  = aPrintDetailInfoStore.created_by;
	        internalCache.getUsers(aTMPusrArray2, function (oparam){
	            aPrintData.push(Print.createContent(_("Created By:"), oparam[aTMPusrArray2[0]].display_name));        
	        });
	    }
	    
	    if (aPrintDetailInfoStore.creation_date) {                               
	        aPrintData.push(Print.createContent(_("Created on:"), formatDate(aPrintDetailInfoStore.creation_date, "datetime")));
        }
        
        if (aPrintDetailInfoStore.modified_by) {
	        var aTMPusrArray = new Array();
	        aTMPusrArray[0]  = aPrintDetailInfoStore.modified_by;
	        internalCache.getUsers(aTMPusrArray, function (oparam) {
	            aPrintData.push(Print.createContent(_("Modified By:"), oparam[aTMPusrArray[0]].display_name));     
	        });
	    }
	    
	    if (aPrintDetailInfoStore.last_modified) {                               
	        aPrintData.push(Print.createContent(_("Last modified:"), formatDate(aPrintDetailInfoStore.last_modified, "datetime")));
	    }
        
        aPrintData.push(Print.createEmpty(true));        
	    if (aPrintDetailInfoStore.description) {
	        aPrintData.push(Print.createContent(_("Comment:"), aPrintDetailInfoStore.description));
	    }
        
        detailInfoPrint.printDetail(aPrintData);
    }	
}

function checkLockUnLock(selected) {
	var countlocked    = 0;
	var countunlocked  = 0;	
	var counteditlocked= 0;
	var uid = configGetKey("identifier");

    checkLockUnLock.callbacks = [];
	triggerEvent("OX_Lockable",0,0,0);
    var collection = { objects : selected , columns : ["created_by","modified_by","locked_until"] };
    OXCache.newRequest(null, "infostore", collection, null, function(daten) {
        for (var i = 0; i < daten.objects.length; i++) {
            if (daten.objects[i]["locked_until"] != 0) { 
                if (daten.objects[i]["modified_by"] == uid) {
                    countunlocked++;
                    counteditlocked++;
                } else if (daten.objects[i]["created_by"] == uid) {
                    countunlocked++;
                }
            } else {
                countlocked++;
            }
        }
        triggerEvent("OX_Lockable", countlocked, countunlocked, counteditlocked);
        for (var i = 0; i < checkLockUnLock.callbacks.length; i++) {
            checkLockUnLock.callbacks[i]();
        }
        checkLockUnLock.callbacks = null;
    }, false);
}
checkLockUnLock.callbacks = null;
checkLockUnLock.wait = function(callback) {
    if (this.callbacks) this.callbacks.push(callback); else callback();
};

function openNewInfoPopup(module,folder) {
	if (module != "infostore")
		return;
		
	if (editInfoItemId != -1) {
	    // edit item
	    ox.api.infostore.edit({
	        params: {
	            id: editInfoItemId.id,
	            folder: editInfoItemId.folder_id
	        }
	    });
		//propertiesPopUp = newWindow("newInfoItemMain.html#edit_id="+editInfoItemId.id + "&folder="+editInfoItemId.folder_id, getWindowOptions(), editInfoItemId);
	} else {
	    // compose item
	    ox.api.infostore.compose({
	        params: {
	            folder: folder
	        }
	    });
		//propertiesPopUp = newWindow("newInfoItemMain.html#edit_id=" + -1 + "&folder="+folder, getWindowOptions());
	}
	
	editInfoItemId = -1;	
	//propertiesPopUp.focus();
}

//function closeInfoPopUp() {
////	propertiesPopUp.close();
//}

function callback_error(arg) {
	newServerError(arg);
}

function infostore_HeaderUpdate(data) {
	infostoreFolderPath.additionalNode=document.createTextNode(" ("+ data.objects.length + ")");
	infostoreFolderPath.drawDOMNode(currentpath2[1] == "split" ? "infostoreHsplitHeaderOwner" : "infostoreListHeaderOwner", activefolder);
}

fileloaded();
