/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2010 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */
 
function portalMatrix (DOMdiv)
{
this.div = DOMdiv;	
this.nodes = new Array();
}
portalMatrix.prototype = {
	/*new portlet*/
	add:function (oOXPortlet,DOMElem, posX, posY){
		if(this.nodes[posY] == undefined)
		{
			for(var nRest=this.nodes.length;nRest <= posY;nRest++)
			{
				this.nodes[nRest] = new Array();
				var oNewDOMY = newnode("div",{width:"100%"});
				this.nodes[nRest][0] = {portlet:{},parent:oNewDOMY,div:newnode("div",{flt:"left"})};
				oNewDOMY.appendChild(this.nodes[nRest][0].div);
				this.div.appendChild(oNewDOMY);
			}
		}
		var aX = this.nodes[posY];
		//this.nodes[posY] must have content (x[0])
		var oDOMY = aX[0].div.parentNode;		
		for(var nRest=aX.length;nRest <= posX;nRest++)
		{					
			aX[nRest] = {portlet:{},parent:oDOMY,div:newnode("div",{flt:"left"})};
			oDOMY.appendChild(aX[nRest].div);
		}
		if(aX[posX].portlet.id)
		{
			var newX = oDOMY.childNodes.length;
			aX[newX] = {portlet:{},parent:oDOMY,div:newnode("div",{flt:"left"})};
			oDOMY.appendChild(aX[newX].div);
			oDOMY.replaceChild(DOMElem,aX[newX].div);			
			aX[newX].div = DOMElem;
			aX[newX].portlet = oOXPortlet;
		}
		else
		{
			oDOMY.replaceChild(DOMElem,aX[posX].div);			
			aX[posX].div = DOMElem;
			aX[posX].portlet = oOXPortlet;		
		}
	},
	/*inserts new row and a portlet after node*/
	insert_rowBefore :function (oOXPortlet,DOMElem, nY){	
		var DOMNodeBefore = this.nodes[nY][0].parent;
		var oNewDOMY = newnode("div",{width:"100%"});
		this.nodes.splice(nY,0,[{portlet:oOXPortlet,parent:oNewDOMY,div:DOMElem}]);	
		oNewDOMY.appendChild(this.nodes[nY][0].div);		
		this.div.insertBefore(oNewDOMY,DOMNodeBefore);
	},
	/*inserts new portlet before node*/
	insertBefore :function (oOXPortlet,DOMElem, node){
		var oCoor = this.getXY(node);
		var posX = oCoor.x;		
		var posY = oCoor.y;		
		var parentN = this.nodes[posY][posX].parent;
		this.nodes[posY].splice((posX),0,{portlet:oOXPortlet,parent:parentN,div:DOMElem});	
		parentN.insertBefore(DOMElem,node);		
	},
	/*inserts new portlet before node*/
	replace :function (oOXPortlet,DOMElem, node){
		var oCoor = this.getXY(node);
		var posX = oCoor.x;		
		var posY = oCoor.y;
		var parentN = this.nodes[posY][posX].parent;
		this.nodes[posY][posX] = {portlet:oOXPortlet,parent:parentN,div:DOMElem};		
		parentN.replaceChild(this.nodes[posY][posX].div,node);		
	},
	/*inserts new portlet after node*/
	insert :function (oOXPortlet,DOMElem, node){		
		var oCoor = this.getXY(node);
		var posX = oCoor.x;		
		var posY = oCoor.y;
		var parentN = this.nodes[posY][posX].parent;
		var oDOMSibling = node.nextSibling;
		this.nodes[posY].splice((posX+1),0,{portlet:oOXPortlet,parent:parentN,div:DOMElem});
		if(oDOMSibling)
		{
			parentN.insertBefore(DOMElem,oDOMSibling);						
		}
		else
		{
			parentN.appendChild(DOMElem);
		}
	},
	get :function (node){		
		var oCoor = this.getXY(node);
		var posX = oCoor.x;		
		var posY = oCoor.y;		
		return this.nodes[posY][posX];
	},
	/*removes from DOM and form internal array, returns old value (portlet, div)*/
	remove :function (node){		
		var oCoor = this.getXY(node);
		var posX = oCoor.x;		
		var posY = oCoor.y;		
		var oldVal = this.nodes[posY][posX];
		var parentN = this.nodes[posY][posX].parent;
		parentN.removeChild(node);

		this.nodes[posY][posX] = {portlet:{},parent:parentN,div:newnode("div",{flt:"left"})};
		return oldVal;
	},
	/*removes empty divs*/
	normalize : function (){
		var currParent;
		for(var nYindx=0;nYindx < this.nodes.length;nYindx++)		
		{
			currParent = this.nodes[nYindx][0].parent;
			var nLengthAr = this.nodes[nYindx].length;
			for(var nNode=0;nNode < nLengthAr;nNode++)
			{		
				var bdeleted = false;
				if(this.nodes[nYindx][nNode].portlet.container == undefined)
				{
					this.nodes[nYindx].splice(nNode,1);	
					bdeleted = true;
					nNode--;
					nLengthAr--;				
				}
				if(this.nodes[nYindx][nNode])
				{
					this.nodes[nYindx][nNode].portlet.adjust = {x:nNode,y:nYindx,
				ww:(this.nodes[nYindx][nNode].portlet.adjust && this.nodes[nYindx][nNode].portlet.adjust.ww)?this.nodes[nYindx][nNode].portlet.adjust.ww:1,
								hw:(this.nodes[nYindx][nNode].portlet.adjust && this.nodes[nYindx][nNode].portlet.adjust.hw)?this.nodes[nYindx][nNode].portlet.adjust.hw:1};
			
				}
			}

			if(this.nodes[nYindx].length == 0)
			{
				this.div.removeChild(currParent);
				this.nodes.splice(nYindx,1);
				nYindx = 0;
			}
		}
		
		for(var nYindx=0;nYindx < this.nodes.length;nYindx++)		
		{		
			//normalize width
			var nWWSum = 0;
			var nNumItems = this.nodes[nYindx].length;
			for(var nNode=0;nNode < nNumItems;nNode++)
			{
				if(this.nodes[nYindx][nNode].portlet.adjust == undefined)
				{
					this.nodes[nYindx][nNode].portlet.adjust = {x:nNode,y:nYindx,ww:1,hw:1};
				}
				nWWSum += this.nodes[nYindx][nNode].portlet.adjust.ww;						
				//disable/enable borders and resize divs here
				if(this.nodes[nYindx][nNode].portlet.resize_div != undefined)
				{
					if((nNumItems-1) == nNode)
					{
						this.nodes[nYindx][nNode].portlet.resize_div.style.display = "none";
					}
					else
					{						
						this.nodes[nYindx][nNode].portlet.resize_div.style.display = "block";
						
						//fixed bug with hidden resize buttons iin IE -> help ie to render the page
						this.nodes[nYindx][nNode].portlet.resize_div.style.borderWidth = "2px";
						this.nodes[nYindx][nNode].portlet.resize_div.style.borderWidth = "0px";						
					}
				}
			}				
			var nOffset = (1 - nWWSum/this.nodes[nYindx].length);		
			if(nOffset != 0)	
			{
				for(var nNode=0;nNode < this.nodes[nYindx].length;nNode++)
				{
					this.nodes[nYindx][nNode].portlet.adjust.ww += nOffset;
				}
			}		
		}
	},
	/*
	 * hides/shows owa iframes
	 */
	 hideshow_iframes:function (sMode)
	 {
		for(var nYindx=0;nYindx < this.nodes.length;nYindx++)		
		{
			for(var nNode=0;nNode < this.nodes[nYindx].length;nNode++)
			{
				if(this.nodes[nYindx][nNode].portlet.uwa)
				{
					if(sMode == "hide")
					{
						var div = newnode("div",0,{className:"background-color-content"});				
						div.style.width = this.nodes[nYindx][nNode].portlet.container.offsetWidth + "px";
						div.style.height = this.nodes[nYindx][nNode].portlet.container.offsetHeight + "px";
						div.style.position = "absolute";
						div.style.filter = "Alpha(opacity=0)";
						div.style.mozOpacity = "0";
						div.style.opacity = "0";		
						div.style.display = "block";
						addDOMEvent(div, "selectstart", function (e){stopEvent(e);return false;});
						addDOMEvent(div, "drag", function (e){stopEvent(e);return false;});													
						this.nodes[nYindx][nNode].portlet.container.insertBefore(div,
										this.nodes[nYindx][nNode].portlet.container.firstChild);
						this.nodes[nYindx][nNode].portlet.hideDiv = div;
					}
					else if(this.nodes[nYindx][nNode].portlet.hideDiv)
					{
						this.nodes[nYindx][nNode].portlet.container.removeChild(this.nodes[nYindx][nNode].portlet.hideDiv);
					}
				}
			}
		}	 	
	 },
	/*removes empty divs and resizes*/
	resize: function (sAreaWidth,sAreaHeight){
		this.normalize();
		if(sAreaWidth == 0 || sAreaHeight==0)
			return;
		var sHeight = (sAreaHeight/this.nodes.length - 4 -(2 * pxPerEm));
		var aLGSResize = new Array();

		for(var nYindx=0;nYindx < this.nodes.length;nYindx++)		
		{
			var sNormalWidth = ((sAreaWidth/this.nodes[nYindx].length));
			for(var nNode=0;nNode < this.nodes[nYindx].length;nNode++)
			{
				if(!this.nodes[nYindx][nNode].portlet.container)
					continue;
				sWidth = this.nodes[nYindx][nNode].portlet.adjust.ww * sNormalWidth;
				if(this.nodes[nYindx][nNode].div.style.width == (sWidth-10) + 'px' && 
							this.nodes[nYindx][nNode].div.style.height == sHeight + "px")
				{
					continue;
				}				
				this.nodes[nYindx][nNode].div.style.width = (sWidth-15) + 'px';		
				this.nodes[nYindx][nNode].portlet.container.style.width = (sWidth-40) + 'px';						
				this.nodes[nYindx][nNode].div.style.height = (sHeight+30) + "px";		
				this.nodes[nYindx][nNode].portlet.container.style.height = (sHeight-25)  + "px";			
				if(this.nodes[nYindx][nNode].portlet.uwa)
				{
					this.nodes[nYindx][nNode].portlet.uwa.setConfiguration(
										{'height':sHeight-25});
				}
				if(this.nodes[nYindx][nNode].portlet.resize_div)
				{
					this.nodes[nYindx][nNode].portlet.resize_div.style.height = (sHeight-10)  + "px";
					this.nodes[nYindx][nNode].portlet.resize_div.style.left = 
													this.nodes[nYindx][nNode].div.offsetLeft 
															+ this.nodes[nYindx][nNode].div.offsetWidth + "px";						
				}
				for(var nLGSection in this.nodes[nYindx][nNode].portlet.ranges)
				{
					var currLG = this.nodes[nYindx][nNode].portlet.ranges[nLGSection].lg;
					if(currLG != undefined)
						currLG.heightDiv.style.width = this.nodes[nYindx][nNode].portlet.container.style.width ;
					//aLGSResize.push(currLG);
				}		
			}
			if(sHeight>0)
				this.nodes[nYindx][0].div.parentNode.style.height = (sHeight+30) + "px";		
		}
	},
	getXY : function (DOMElem){
 		for(var nY=0;nY < this.nodes.length;nY++)
 		{
 			for(var nX=0;nX < this.nodes[nY].length;nX++)
 			{
	 			if(DOMElem == this.nodes[nY][nX].div) 				
	 			{
	 				return {x:nX,y:nY};			
	 			}
 			}
 		}		
 		return {x:0,y:0};
	},
	/*module can be replaced by id later*/
	getByModule : function (module){
 		for(var nY=0;nY < this.nodes.length;nY++)
 		{
 			for(var nX=0;nX < this.nodes[nY].length;nX++)
 			{
	 			if(module == this.nodes[nY][nX].portlet.id) 				
	 			{
	 				return {x:nX,y:nY};			
	 			}
 			}
 		}		
 		return null;
	},
	setConfig : function (){
		var oConfigPortal = clone(configGetKey("gui.portal.internalcontents"));
		var oConfigExtPortal = clone(configGetKey("gui.portal.externalcontents"));
		for(var nYindx=0;nYindx < this.nodes.length;nYindx++)		
		{
			for(var nNode=0;nNode < this.nodes[nYindx].length;nNode++)
			{
				for(var nConfig=0;nConfig<oConfigPortal.length;nConfig++)
				{
					var sId = (oConfigPortal[nConfig]["id"])?oConfigPortal[nConfig]["id"]:oConfigPortal[nConfig]["module"];
					if(sId == this.nodes[nYindx][nNode].portlet.id)
					{
						oConfigPortal[nConfig].adj = this.nodes[nYindx][nNode].portlet.adjust;
						break;
					}
				}
				for(var nConfig=0;nConfig<oConfigExtPortal.length;nConfig++)
				{
					var sId = (oConfigExtPortal[nConfig]["id"])?oConfigExtPortal[nConfig]["id"]:oConfigExtPortal[nConfig]["title"];
					if(sId == this.nodes[nYindx][nNode].portlet.id)
					{
						oConfigExtPortal[nConfig].adj = this.nodes[nYindx][nNode].portlet.adjust;
						break;
					}
				}				
			}
		}
		configSetKey("gui.portal.internalcontents",oConfigPortal);
		configSetKey("gui.portal.externalcontents",oConfigExtPortal);		
	}
	
};

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2010 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */
function cPortal(){
	this.all_areas = new Object();
	this.matrix = new portalMatrix($('portal_horiz_content'));
	
	this.init();
}
var tempViewPortalObj = null;
var oPortalIndepObj = null;
var objDND_Obj = null;
var offsetIconX = 0;
cPortal.setMovingClass = classNameSetter("moving");
cPortal.prototype = {
	init: function (){
		var objInternalCont = configGetKey("gui.portal.internalcontents");
		for(var nIndx=0;nIndx< objInternalCont.length;nIndx++)
		{
			var oModule = objInternalCont[nIndx];
			if(oModule.adj == undefined)
			{
				continue;	
			}
			if(oModule.module == "mail" && configGetKey('mail.folder.inbox')==null)
				oModule.visible = false;
			if(!oModule.visible)
				continue;		
			this.all_areas[oModule.module] = this.get_section(oModule.module,0,oModule.params.limit,oModule.adj);
		}
		this.get_all_data(this.all_areas,true);	

		if(bUWAEnabled && !(url["external"] && url["external"]==0))
		{
			var aExtContents = configGetKey("gui.portal.externalcontents");
			for(var indx=0;indx < aExtContents.length;indx++)			
			{				
				var sId =  (aExtContents[indx]["id"])?aExtContents[indx]["id"]:aExtContents[indx]["title"];
				if(!aExtContents[indx].visible)
					continue;						
				this.all_areas[sId] = this.get_ext_section(aExtContents[indx],sId);		
			}
		}

	//	this.resize($('portal').offsetWidth);
		this.register_dnd(null,null, null,true);		
	},
	//set bInitialize true for intiialization and false for update
	get_all_data : function (aPortalAreas,bInitialize){
		var Self = this;
		var aReqAssoc = new Array();
		//create multiple request...
		var aRequests = new Array();
		for(var nIndx in aPortalAreas)
		{
			if(!aPortalAreas[nIndx].extern)
			{
				var aModReq = aPortalAreas[nIndx].getRequests();
				for(var nr=0;nr<aModReq.length;nr++)
				{
					aReqAssoc.push({id:aPortalAreas[nIndx].id,indx:nr});
					aRequests.push(aModReq[nr]);
				}
			}
		}
		//set received data in portal objects, and draw contents
		function cb_portal_mult(arg)
		{		
			if(currentpath2[0] != "portal")
				return;
			for(var nIndx=0;nIndx<arg.length;nIndx++)
			{
				var currArg = arg[nIndx];
				if(currArg) {
					if(currArg.error)
						Self.all_areas[aReqAssoc[nIndx].id].setError(currArg);
					else				
						Self.all_areas[aReqAssoc[nIndx].id].setData(currArg.data,aReqAssoc[nIndx].indx,currArg.timestamp);			
				}
			}

			for(var nIndx in aPortalAreas)
			{
				if(!aPortalAreas[nIndx].extern)
				{
					/*
					if(bInitialize)
						aPortalAreas[nIndx].getHTML();
					else*/
						aPortalAreas[nIndx].update();
				}
			}
			Self.resize($('portal').offsetWidth);
		}
		//send multiple request
		doAjaxMultiplePortalRequest(aRequests,cb_portal_mult);		
	},
	disable : function (){
		for(var indx in this.all_areas)
		{
			this.all_areas[indx].disable();
		}					
	},
	resize : function (sWidth){
		this.matrix.resize(sWidth,$('portal_new_top_dyn').offsetHeight);
	},
	update : function (){
		//delete old data
		for(var nIndx in this.all_areas)
		{
			this.all_areas[nIndx].error = undefined;
			this.all_areas[nIndx].data = undefined;		
			if(this.all_areas[nIndx].extern)
			{
				this.all_areas[nIndx].update();
			}
		}
		//using the method for asynchrounus data handling
		this.get_all_data(this.all_areas,false);				
		
	},	
	remove_section : function (sId){
		this.matrix.remove(this.all_areas[sId].oDOMTD);
		delete this.all_areas[sId];
		this.resize($('portal').offsetWidth);					
	},
	/*should be used after configuration change*/
	rebuild_page : function (){	
		var objInternalCont = configGetKey("gui.portal.internalcontents");		
		var newAreas = new Array();
		for(var nIndx=0;nIndx< objInternalCont.length;nIndx++)
		{		
			if(this.all_areas[objInternalCont[nIndx].module] != undefined && !objInternalCont[nIndx].visible)
			{
				this.remove_section(objInternalCont[nIndx].module);	
			}			
			else if(this.all_areas[objInternalCont[nIndx].module] == undefined 
																&& objInternalCont[nIndx].visible)
			{
				var nY = (this.matrix.nodes.length == 0)?0:(this.matrix.nodes.length-1);
				var nX = (nY==0)?0:this.matrix.nodes[nY].length;
				this.all_areas[objInternalCont[nIndx].module] = 
						this.get_section(objInternalCont[nIndx].module,0,objInternalCont[nIndx].params.limit,
							{x:nX,y:nY,ww:1,hw:1});
				newAreas.push(this.all_areas[objInternalCont[nIndx].module]);				
			}
		}
		if(bUWAEnabled){			
			var objExternalCont = configGetKey("gui.portal.externalcontents");	
			for(var nIndx=0;nIndx< objExternalCont.length;nIndx++)		
			{	
				var sId = (objExternalCont[nIndx]["id"])?objExternalCont[nIndx]["id"]:objExternalCont[nIndx]["title"];
				if(this.all_areas[sId] != undefined && !objExternalCont[nIndx].visible)
				{
					this.remove_section(sId);	
				}			
				else if(this.all_areas[sId] == undefined 
														&& objExternalCont[nIndx].visible)
				{
						var nLastRow = this.matrix.nodes.length-1;
						var nLengthLastRow = this.matrix.nodes[nLastRow].length;
						if(nLengthLastRow > 3)
						{
							nLastRow++;
							var newAdj = {x:0,y:nLastRow,ww:1,hw:1};
						}else
						{
							var newAdj = {x:nLengthLastRow,y:nLastRow,ww:1,hw:1};							
						}						
						objExternalCont[nIndx].adj = newAdj;
						this.all_areas[sId] = this.get_ext_section(objExternalCont[nIndx],sId);						
				}				
			}
			//remove deleted items
			for(var nre in this.all_areas)
			{				
				if(this.all_areas[nre].extern === true)
				{
					var bfound = false;
					for(var nIndx=0;nIndx< objExternalCont.length;nIndx++)
					{
						var sId = (objExternalCont[nIndx]["id"])?objExternalCont[nIndx]["id"]:objExternalCont[nIndx]["title"];
						if(sId == this.all_areas[nre].id)
						{
							bfound = true;
						}
					}
					if(!bfound)
						this.remove_section(this.all_areas[nre].id);
				}
			}
		}		
		if(newAreas.length > 0)
			this.get_all_data(newAreas,true);			

		this.resize($('portal').offsetWidth);		
	},
	get_ext_section : function (oObj,sId){
		var nItem = this.get_section(oObj.title,null,null,oObj.adj,oObj,sId);	
		return nItem;
	},
	header_action : function (sModule){
		if(sModule == "mail")
		{
			var oFoldersMail = configGetKey("mail.folder");
			var sfolderId = oFoldersMail["inbox"];
		}
		else
			var sfolderId = configGetKey("folder." +sModule);
		var sdefView = configGetKey("gui." +sModule+".view");		
		setActiveFolder(sfolderId,function (){
				activemodule = sModule;
				triggerEvent("OX_Switch_Module",sModule, "newfolder");
		});
	},
	close_section : function (sModule,sId){
		//handle external portlets here
		if(sId)
		{
			this.matrix.remove(this.all_areas[sId].oDOMTD);
			delete this.all_areas[sId];
			var objExternalCont = configGetKey("gui.portal.externalcontents");	
			for(var nIndx=0;nIndx< objExternalCont.length;nIndx++)		
			{		
				var sStoredId = (objExternalCont[nIndx]["id"])?objExternalCont[nIndx]["id"]:objExternalCont[nIndx]["title"];
				if(sStoredId == sId)
				{
					objExternalCont[nIndx].visible = false;
					break;
				}				
			}
			configSetKey("gui.portal.externalcontents",objExternalCont);
			configuration_changed_fields["gui"]=true;
		}
		else
		{
			this.matrix.remove(this.all_areas[sModule].oDOMTD);
			delete this.all_areas[sModule];
			var objInternalCont = configGetKey("gui.portal.internalcontents");
			for(var nIndx=0;nIndx< objInternalCont.length;nIndx++)
			{
				if(objInternalCont[nIndx].module == sModule)
				{
					objInternalCont[nIndx].visible = false;
					objInternalCont[nIndx]["params"]["limit"] = 0;
					break;
				}
			}
			configSetKey("gui.portal.internalcontents",objInternalCont);
			configuration_changed_fields["gui"]=true;
		}
		this.resize($('portal').offsetWidth);	
	},
	get_section : function (sModule,nIndx,nLimit,oAdj,oObjExt,sId){
		var Self = this;
		function getPortalSizeCallback(split,previous)
		{
			return function(e) {
				/*
				 * checking the clicked mouse button. anything else then a left click
				 * won't be allowed. can't handle this in the addDomEvent as we need
				 * the mousedown event which will be fired before the other events.
				 */
				var clButton = e.which || e.button || 1;
                if (clButton != 1) {
                    cancelDefault(e);
                    return false;
                }
				Self.matrix.hideshow_iframes("hide");
				var oCoords = Self.matrix.getXY(previous);
				var oldLeft = split.offsetLeft;
				var nNextWidth = Self.matrix.nodes[oCoords.y][oCoords.x+1].div.offsetWidth;
				function getPixels(value) {
					if (!value) return value;
					var match = /^([0-9.]+)(em|px)$/.exec(value);
					if (!match) alert(format("Invalid ox:min or ox:max at id=\"%1\".", split.id));
					var num = parseFloat(match[1]);
					switch (match[2]) {
						case "px": return num;
						case "em": return pxPerEm * num;
					}
				}
				var displayOffset;
				var min = 140;
				var max = previous.offsetWidth + (Self.matrix.nodes[oCoords.y][oCoords.x+1].div.clientWidth-120);
				var sizeF = {
					left: function() {
						displayOffset = previous.offsetLeft;
						var offset = previous.offsetWidth - e.clientX;
					return function(x, y) {	
							return Math.min(max, Math.max(min, offset + x));
						};
					}
				}["left"]();
				function m(e) {
					stopEvent(e);
					size = sizeF(e.clientX, e.clientY);
					split.style.left = (displayOffset + size) + "px";				
				};
				function u() {
					Self.matrix.hideshow_iframes("show");
					removeDOMEvent(body, "mousemove", m);
					removeDOMEvent(body, "mouseup", u);
                    cPortal.setMovingClass(split, false);
					var nXCoord = getPixels(split.style.left) - previous.offsetLeft;		
					var nOldWeights = Self.matrix.nodes[oCoords.y][oCoords.x+1].portlet.adjust.ww + Self.matrix.nodes[oCoords.y][oCoords.x].portlet.adjust.ww;
					var nFullLength = previous.offsetWidth + Self.matrix.nodes[oCoords.y][oCoords.x+1].div.offsetWidth;
					var nLeftNewX = (Math.round(((nOldWeights/nFullLength) * nXCoord)*1000)/1000);
					var nRightNewX = nOldWeights - nLeftNewX;
					Self.matrix.nodes[oCoords.y][oCoords.x+1].portlet.adjust.ww = nRightNewX;
					Self.matrix.nodes[oCoords.y][oCoords.x].portlet.adjust.ww = nLeftNewX;
					Self.resize($('portal').offsetWidth);	
					Self.matrix.setConfig();
				};
				addDOMEvent(body, "mousemove", m);
				addDOMEvent(body, "mouseup", u);
                cPortal.setMovingClass(split, true);
				cancelDefault(e);					
			};
		}
		var oNewCell = newnode("div",{flt:"left",paddingLeft:"7px"});
		var oDOMresize = newnode("div",{zIndex:"5",verticalAlign:"middle",cursor:"e-resize",position:"absolute",
							height:"40px",width:"7px",borderLeft:"1px solid #FFFFFF",borderRight:"1px solid #FFFFFF"});
		var oResIm = newnode('img',0,{src:getFullImgSrc("img/grip_bg_vertical.gif")});
		var oResTable = newnode('table',{borderCollapse:"collapse",height:"100%",width:"100%"},{ cellpadding:"0",cellspacing:"0"});		
		var oResBody = newnode('tbody');	
		var oResTR = newnode('tr');	
		var oResTD = newnode('td',{verticalAlign:"middle"});	
		oResTD.appendChild(oResIm);
		oResTR.appendChild(oResTD);
		oResBody.appendChild(oResTR);		
		oResTable.appendChild(oResBody);		
		oDOMresize.appendChild(oResTable);
		addDOMEvent(oDOMresize, "mousedown", getPortalSizeCallback(oDOMresize,oNewCell));
		var sHeight = $('portal_new_top_dyn').offsetHeight + 'px';
		var contentTable = newnode('table',{borderCollapse:"collapse",height:"90%",width:"100%"},{ cellpadding:"0",cellspacing:"0"});		
		var oDOMTD = newnode('td',{verticalAlign:"top"});		
		oDOMTD.appendChild(contentTable);
		var bodyTable = newnode('tbody');		
		contentTable.appendChild(bodyTable);		
		var oDOMTH = newnode('th');		
		var dndIm = newnode("img",{cursor:"move"},{src:getFullImgSrc("img/portal/move_n.gif")});
		var header = newnode('div',0,{className:"mozSelected"});
		function get_closed_actionfn(){
			return function (){
				Self.header_action(sModule);
			};
		}
		//enable action for internal module change
		if(oObjExt == undefined)		
		{
			addDOMEvent(header,"click",get_closed_actionfn());
			header.style.cursor = "pointer";
		}
		bodyTable.appendChild(newnode('tr',{height:"1.6em"},0,[oDOMTH,newnode('th',{verticalAlign:"top"},0,[oDOMresize])]));		

		var moveDiv = newnode('div',{height:"14px"},{className:"mozSelected"},[dndIm]);		
        var oCloseImg = newnode("img",{cursor:"pointer"},{src:getFullImgSrc("img/portal/btn_close.gif")});
        var closeDiv = newnode('div',{height:"14px"},{className:"mozSelected"},[oCloseImg]);            

		function get_closed_closefn(){
			return function (){
				Self.close_section(sModule,sId);
			};
		}
        addDOMEvent(oCloseImg,"click",get_closed_closefn());
		var oDOMHeaderTable = newnode('div',{paddingLeft:"8px"},0,[
								newnode("table",{width:"100%",lineHeight:"1.5em",
											borderCollapse:"collapse"},
													{cellPadding: "0", cellSpacing: "0", className: "portal-header-box-background background-color-additional-content"},[
									newnode("tbody",0,0,[
										newnode("tr",0,0,[
											newnode("td",0,0,[header]),
											newnode("td",{verticalAlign:"middle",paddingLeft:"2px",width:"18px"},0,[moveDiv]),											
											newnode("td",{verticalAlign:"middle",paddingRight:"4px",width:"28px",textAlign:"right"},0,[closeDiv])												
										
										])])])]);
		oDOMTH.appendChild(oDOMHeaderTable);
//		oDOMTH.appendChild(closeDiv);
		var container = newnode('div',{position:"relative",paddingLeft:"10px",paddingRight:"10px",overflowX:"hidden",overflowY:"auto"});
		bodyTable.appendChild(newnode('tr',0,0,[newnode('td',{verticalAlign:"top"},0,[container])]));	
		oNewCell.appendChild(contentTable);
		this.register_dnd(oNewCell,dndIm,oDOMHeaderTable);
		if(oObjExt == undefined)
			var newItem = new portalItem(sModule,container,header,nLimit,oAdj,oNewCell,oDOMresize);
		else
		{
			var newItem = new portalExternalItem(sId,sModule,container,header,oObjExt.parameter,oAdj,oNewCell,oDOMresize,oObjExt.url);
			newItem.autorefresh = oObjExt.autorefresh;
			newItem.standalone = oObjExt.standalone;
		}
			
		this.matrix.add(newItem,oNewCell,oAdj.x,oAdj.y);		
		newItem.getHTML();
		return newItem;		
	},
	register_dnd : function (oNewCell,oDragPoint,header,bPortalBorder){
		var Self = this;


		if(header)
		{
			addDOMEvent(header, "selectstart", function (e){stopEvent(e);return false;});
			addDOMEvent(header, "drag", function (e){stopEvent(e);return false;});										
		}
		var timeoutPortal;		
		function clearPortalSelection(e,dragType,draggedObjects,mouseposition,OutOpen,dropNode) {			
		clearTimeout(timeoutPortal);			
		if(dropNode) {
				dropNode.className = removeClass(dropNode.className, "dndOver");	
			}
			else if(e) {
				var mynode = e.currentTarget || e.srcElement || false;
				if(mynode) { 	mynode.className = removeClass(mynode.className, "dndOver");  }
			}
	
		}
	
		function portalenable(e,dragType,draggedObjects,mouseposition,targetNode,node){				
				if (objDND_Obj == null)
				{
					Self.matrix.hideshow_iframes("hide");
					var sStrWidth = draggedObjects.div.style.width;
					var nNumWidth = sStrWidth.replace(/px/,'');
					var objDND_Header = draggedObjects.header.firstChild.cloneNode(true);
					objDND_Header.style.width = "99%";
					objDND_Obj = newnode('div',{paddingTop:"3px",paddingRight:"10px",paddingLeft:"10px",position:"absolute",border:"1px dotted #000000",width:sStrWidth,height:draggedObjects.div.style.height},0,[objDND_Header]);
					addDOMEvent(objDND_Obj, "selectstart", function (e){stopEvent(e);return false;});
					addDOMEvent(objDND_Obj, "drag", function (e){stopEvent(e);return false;});							
					$('mailDnDPortal_anchor').appendChild(objDND_Obj);
					if(offsetIconX == 0)
					{
						var absPos = draggedObjects.div.offsetLeft;
						offsetIconX = getAbsolutePositionLeft(draggedObjects.div) - mouseposition.clientX;					
					}
				}					
				var iconNode = objDND_Obj;
				iconNode.style.left = (e.clientX + offsetIconX) + "px";
				iconNode.style.top = (e.clientY+1)+ "px";
		}
		function poralPreview(node,bPortalBordersOpt,DirectOpt){return function(e,dragType,draggedObjects,mouseposition,targetNode) {
								var saveX = e.clientX;
								var saveY = e.clientY;		
								portalenable(e,dragType,draggedObjects,mouseposition,targetNode,node);
								function local_tempst(){	
									if(bPortalBorder)							
										showPreviewBorder(e,dragType,draggedObjects,mouseposition,targetNode,node,saveX,saveY,DirectOpt);
									else
										showPreview(e,dragType,draggedObjects,mouseposition,targetNode,node,saveX,saveY);
									
								}					
								clearTimeout(timeoutPortal);
								timeoutPortal = setTimeout(local_tempst,100);
							};
		}
	
		function showPreview(e,dragType,draggedObjects,mouseposition,targetNode,node,saveX,saveY){
			clearTimeout(timeoutPortal);
			if(node == tempViewPortalObj){
				return;			
			}
			var absolutX = getAbsolutePositionLeft(node);
			var sNewPosition;
			
			//coordinate system transformation
			var x_ = saveX-absolutX - node.offsetWidth/2;
			var y_ = saveY-getAbsolutePositionTop(node) - node.offsetHeight/2;		
			//working with polar coordinates
			var nDEGAngl = getPolarAngle(x_,y_) * 180 / Math.PI;
			if(nDEGAngl <= 135 && nDEGAngl >=45)
			{
				sNewPosition = "bottom";
			}
			else if(nDEGAngl <= 180 && nDEGAngl > 135 || nDEGAngl >= -180 && nDEGAngl < -135)
			{
				sNewPosition = "left";
			}
			else if(nDEGAngl >= -135 && nDEGAngl <= -45)
			{
				sNewPosition = "top";
			}		
			else if(nDEGAngl >-45 && nDEGAngl <= 0 || nDEGAngl > 0 && nDEGAngl < 45)
			{
				sNewPosition = "right";
			}		
			showPreviewAt(sNewPosition,mouseposition,draggedObjects,node,nDEGAngl);
		}
		var tObj = new Object();	
		tObj["portal_dnd"] = function (event,dragType,draggedObjects,mouseposition,targetNode,dropNode) {
							clearTimeout(timeoutPortal);
							if(!oPortalIndepObj)
								return;
							if(oPortalIndepObj.portlet.uwa === null)
								oPortalIndepObj.portlet.appendFrame();							
							Self.matrix.hideshow_iframes("show");
							Self.matrix.replace(oPortalIndepObj.portlet,oPortalIndepObj.div,tempViewPortalObj);
							Self.resize($('portal').offsetWidth);	
							Self.matrix.setConfig();
							tempViewPortalObj = null;
							oPortalIndepObj = null;
							if(objDND_Obj != null){
								$('portal_mi_anchor').removeChild(objDND_Obj);
								objDND_Obj = null;
								offsetIconX = 0;
							}
							//clearPortalSelection(event,dragType,draggedObjects,mouseposition,null,dropNode);
							};
		function showPreviewAt(sNewPosition,mouseposition,draggedObjects,node,nDEGAngl){
			var sameDiv = (draggedObjects.div == node);			

			if(tempViewPortalObj == null)
			{			
				if(sameDiv && (sNewPosition == "left" || sNewPosition == "right"))				
					oPortalIndepObj = Self.matrix.get(draggedObjects.div);
				else					
					oPortalIndepObj = Self.matrix.remove(draggedObjects.div);

				if(oPortalIndepObj.portlet.uwa)
					oPortalIndepObj.portlet.deleteFrame();
					
				var tempContainer = newnode("div",{border: "1px dotted black",position:"absolute",paddingLeft:"10px",
																						paddingRight:"10px",overflow:"hidden"});
				tempViewPortalObj = newnode("div",{flt:"left",paddingLeft:"9px"});
				tempViewPortalObj.appendChild(tempContainer);
				Self.register_dnd(tempViewPortalObj);			
			}
			else
			{
				Self.matrix.remove(tempViewPortalObj);	
				var tempContainer = tempViewPortalObj.firstChild;						
			}		
			switch(sNewPosition){
				case "left":		
							if(node.previousSibling == draggedObjects.div) 
								return;			
							if(sameDiv)				
								Self.matrix.replace({container:tempContainer},tempViewPortalObj, node);
							else
								Self.matrix.insertBefore({container:tempContainer},tempViewPortalObj, node);
							Self.resize($('portal').offsetWidth);	
							break;		
				case "top": 
							var oCoor = Self.matrix.getXY(node);
							Self.matrix.insert_rowBefore({container:tempContainer},tempViewPortalObj,oCoor.y);						
							Self.resize($('portal').offsetWidth);							
							break;	
				case "bottom_border": 		
							var nYCoord = Self.matrix.nodes.length;
							Self.matrix.add({container:tempContainer},tempViewPortalObj,0,nYCoord);
							Self.resize($('portal').offsetWidth);								
							break;														
				case "bottom": 		
							var oCoor = Self.matrix.getXY(node);
							if(Self.matrix.nodes[oCoor.y+1] == undefined)
							{		
								Self.matrix.add({container:tempContainer},tempViewPortalObj,0,(oCoor.y+1));
								Self.resize($('portal').offsetWidth);	
							}		
							else
							{
								Self.matrix.insert_rowBefore({container:tempContainer},tempViewPortalObj,(oCoor.y+1));						
								Self.resize($('portal').offsetWidth);	
							}
							break;																						
				case "right":
							if(node.nextSibling == draggedObjects.div) 
								return;
							if(sameDiv)				
								Self.matrix.replace({container:tempContainer},tempViewPortalObj, node);
							else				
								Self.matrix.insert({container:tempContainer},tempViewPortalObj, node);
							Self.resize($('portal').offsetWidth);					
							break;			
			}

		}	
		function showPreviewBorder(e,dragType,draggedObjects,mouseposition,targetNode,node,saveX,saveY,sDirect)
		{
			if(sDirect == "top" && Self.matrix.nodes[0][0].div)
				showPreviewAt(sDirect,mouseposition,draggedObjects,Self.matrix.nodes[0][0].div);	
			if(sDirect == "bottom" && Self.matrix.nodes[(Self.matrix.nodes.length-1)][0].div)
				showPreviewAt("bottom_border",mouseposition,draggedObjects,Self.matrix.nodes[(Self.matrix.nodes.length-1)][0].div);				
		}
		
		if(bPortalBorder)
		{
			addDOMEvent($("portal_border_top"), "selectstart", function (e){stopEvent(e);return false;});
			addDOMEvent($("portal_border_top"), "drag", function (e){stopEvent(e);return false;});							
			addDOMEvent($("portal_border_bottom"), "selectstart", function (e){stopEvent(e);return false;});
			addDOMEvent($("portal_border_bottom"), "drag", function (e){stopEvent(e);return false;});									
			registerTarget($("portal_border_top"), tObj,null,null,function (){},
									poralPreview($("portal_border_top"),true,"top"),clearPortalSelection,true);
			registerTarget($("portal_border_bottom"), tObj,null,null,function (){},
									poralPreview($("portal_border_bottom"),true,"bottom"),clearPortalSelection,true);								
		}
		else
			registerTarget(oNewCell, tObj,null,null,function (){},
									poralPreview(oNewCell),clearPortalSelection,true);
	
		function getPolarAngle(x,y){
			var r = Math.pow((x*x+y*y),0.5);
			if(y >= 0)
				return Math.acos(x/r);
			else
				return (Math.acos(-1 * (x/r)) - Math.PI);
		}
		function fn(sPortalId)
		{
			return function ()
			{
				var dwi = sPortalId;
				return dwi;
			};
		}			
		function leaveSourcePortal(){
			if(objDND_Obj != null){
				$('mailDnDPortal_anchor').removeChild(objDND_Obj);
				objDND_Obj = null;				
				offsetIconX = 0;
				Self.matrix.hideshow_iframes("show");							
			}		
			if(oPortalIndepObj == null || tempViewPortalObj == null)
				return;
			if(oPortalIndepObj.portlet.uwa === null)
					oPortalIndepObj.portlet.appendFrame();
			Self.matrix.replace(oPortalIndepObj.portlet,oPortalIndepObj.div,tempViewPortalObj);
			Self.resize($('portal').offsetWidth);	
			Self.matrix.setConfig();
			tempViewPortalObj = null;
			oPortalIndepObj = null;
		}
		if(oDragPoint)
			registerSource(oDragPoint, "portal_dnd", fn({header:header,div:oNewCell}),null,null, 
																		function(e,dragType,draggedObjects,mouseposition,targetNode) {
																					portalenable(e,dragType,draggedObjects,mouseposition,targetNode,header);
																		}
	, 
																			leaveSourcePortal);																									
			
		}

};
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2010 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */
registerModule("portal", "Start Page",1); /*i18n*/

var	bPortalConfigChanged = false;

var oPortalObject = null;

registerView("portal",
	function() { showNode("portal"); }, 
	function() { 
		if(oPortalObject != null)			
		{	
			if(bPortalConfigChanged)
			{
				oPortalObject.rebuild_page();
			}
			else
			{
				resizePortalHeaders();
				oPortalObject.update();			
			}
			oMainFolderTree.set_selected();
		}
		else
		{			
			oPortalObject = new cPortal();
			register("OX_Refresh",portalUpdate);
		}
		window.onbeforeunload = unloadMessageMainLogin;		
		resizeEvents.register("Resized",resizePortalHeaders);	
	 }, 
	function() {
		window.onbeforeunload = unloadMessageMainLogin;
		resizeEvents.unregister("Resized",resizePortalHeaders);			
	},
	function() {		
		oPortalObject.disable();
		hideNode("portal");
	},function () {	
	});

function portalUpdate(){
	oPortalObject.update();
}
register('OX_Portal_Click_Item',fn_clickedItem);


register('OX_Configuration_Changed',function (param)
									{
										if(param && (param == 'configuration/portal/layout'))	
												bPortalConfigChanged = true;
									});

function fn_clickedItem(sModule,oObj)
{
	triggerEvent("OX_Direct_Linking",sModule,oObj);
}

function resizePortalHeaders()
{		
	if(oPortalObject != null)
		oPortalObject.resize($('portal').offsetWidth);
}

function doAjaxMultiplePortalRequest(aRequests,callback)
{
	var multJson = new JSON();	
	var sAjaxRequest = AjaxRoot + '/multiple?session='+session;
	multJson.put(sAjaxRequest,aRequests,null,callback);
}

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2010 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

function  portalExternalItem(sId,sModule,oDOMContainerDiv,oDOMHeaderDiv,oParams,oAdj,oCell,oResizeDiv,sUrl){
	this.module = sModule;
	this.id = sId;
	this.resize_div = oResizeDiv;
	this.adjust = oAdj;
	
	this.autorefresh  = false;
	this.standalone = false;
	
	this.params = oParams;
	
	this.oDOMTD = oCell;
	this.container = oDOMContainerDiv;
	this.header = oDOMHeaderDiv;
	this.newportal = true;
	
	this.uwa;
	this.url = sUrl;
	
	this.privheader;
	
	this.extern = true;
}
portalExternalItem.prototype = {
	getHTML: function (){
	
	this.privheader = newnode('div',{paddingLeft:"4px",textAlign:"left",height:"1.6em",width:"100%",overflow:"hidden",whiteSpace:"nowrap"},
									{className:"font-style-headline background-color-additional-content"});	
	this.privheader.appendChild(newnode('div',{paddingLeft:"30px"},0,[addTranslated(this.module)]));
	this.header.appendChild(this.privheader);
	this.container.style.overflow = "hidden";	
	this.appendFrame();
	},
	deleteFrame: function (){
		removeChildNodes(this.container);
		this.uwa = null;
	},
	appendFrame:function (){
		this.uwa =new UWAWidget({ inline: false,id:this.id, container: this.container,
														    moduleUrl: this.url, standalone: this.standalone } );
		this.uwa.setConfiguration( { 'title':'',  'borderWidth':'0', 
							    'color':'#aaaaaa', 'displayTitle':false, 'displayFooter':false } );	 
		this.uwa.setPreferencesValues(this.params);				
	},
	update_content:function (newdata){
		this.uwa.setPreferencesValues(newdata.parameter);
		this.uwa.moduleUrl = newdata.url;
		this.uwa.updateIframeUrl();
		removeChildNodes(this.privheader);
		this.module = newdata.title;
		var oHeaderTextNode = document.createTextNode(this.module);
		this.privheader.appendChild(newnode('div',{paddingLeft:"30px"},0,[oHeaderTextNode]));		
		
		this.autorefresh = newdata.autorefresh;
	},
	disable : function (){
	
	},
	update: function ()
	{
		if(this.autorefresh)
			this.uwa.updateIframeUrl();		
	}
};

function portalItem(sModule,oDOMContainerDiv,oDOMHeaderDiv,limitParam,oAdj,oCell,oResizeDiv)
{
	this.module = sModule;
	this.id = this.module;
	this.resize_div = oResizeDiv;
	this.adjust = oAdj;
	this.oDOMTD = oCell;
	this.container = oDOMContainerDiv;
	this.header = oDOMHeaderDiv;
	this.newportal = true;
	
 	this.limit_count = limitParam;
 	this.live_grid = null;

	//comma separated list of columns which be displayed
	this.columns = initColumns(sModule);
	this.sDate = 0;
	this.error;
	this.data = new Array();	
	this.id_assoc = new Object();
	this.timestamp;
	
	this.sort = initSortParam(sModule);
	this.order = initOrderParam(sModule);
	
	this.column_heads = initColHeads(sModule);
	this.column_functions = initColFunctions(sModule);
	this.col_width = getArrayWidth(sModule);
	var Self = this;
	this.style = getStyle(sModule);
	this.ranges = getRanges(sModule);
	var UserArray = new Array();	
	function getRanges(sModule)
	{
							
		var aRanges = new Array();
		switch (sModule){
			case "calendar":					
					var t = new Date();		
					t.setUTCHours(0);	
					t.setUTCMinutes(0);
					t.setUTCSeconds(0);
					var nStartDay = t.getUTCDay();
					tend = new Date(t);
					tend.setUTCDate(tend.getUTCDate()+1);					
					for(var nIndx=nStartDay;nIndx<=7;nIndx++)
					{
						if(nIndx == nStartDay)
							var sHeadName = "Today"; /*i18n*/
						else
							var sHeadName = weekdays.untranslated[t.getUTCDay()];
						var lgObj = Self.createLg(sHeadName);
						aRanges.push({name:sHeadName,range:{start:t.getTime(),end:tend.getTime()},limit:Infinity,lg:lgObj.lg,section:lgObj.section});
						t.setUTCDate(t.getUTCDate()+1);						
						tend.setUTCDate(tend.getUTCDate()+1);
					}
					tend.setUTCDate(tend.getUTCDate()-1);
					tnextend = new Date(tend);
					tnextend.setUTCDate(tnextend.getUTCDate()+7);
					var lgObj = Self.createLg("Next Week");
					aRanges.push({name:"Next Week", /*i18n*/
					    range:{start:tend.getTime(),end:tnextend.getTime()},limit:Infinity,lg:lgObj.lg,section:lgObj.section});
					var tnextyear = new Date();			
					tnextyear.setUTCHours(0);
					tnextyear.setUTCMinutes(0);			
					tnextyear.setUTCSeconds(0);						
					tnextyear.setUTCFullYear(tnextyear.getUTCFullYear()+1);
					tnextyear.setUTCDate(tnextyear.getUTCDate()+1);		
					var lgObj = Self.createLg("Later");	
					aRanges.push({name:"Later", /*i18n*/
					    range:{start:tnextend.getTime(),end:tnextyear.getTime(),limit:Self.limit_count},lg:lgObj.lg,section:lgObj.section});
					break;
			case "tasks":
					var t = new Date();		
					t.setUTCHours(0);	
					t.setUTCMinutes(0);
					t.setUTCSeconds(0);
					var nStartDay = t.getUTCDay();
					tend = new Date(t);
					tend.setUTCDate(tend.getUTCDate()+1);					
					for(var nIndx=nStartDay;nIndx<=7;nIndx++)
					{
						if(nIndx == nStartDay)
							var sHeadName = "Today"; /*i18n*/
						else
							var sHeadName = weekdays.untranslated[t.getUTCDay()];						
						var lgObj = Self.createLg(sHeadName);
						aRanges.push({name:sHeadName,range:{start:t.getTime(),end:tend.getTime()},limit:Infinity,lg:lgObj.lg,section:lgObj.section});							
						t.setUTCDate(t.getUTCDate()+1);						
						tend.setUTCDate(tend.getUTCDate()+1);
					}
					tend.setUTCDate(tend.getUTCDate()-1);
					tnextend = new Date(tend);
					tnextend.setUTCDate(tnextend.getUTCDate()+7);
					var lgObj = Self.createLg("Next Week");
					aRanges.push({name:"Next Week", /*i18n*/
					    range:{start:tend.getTime(),end:tnextend.getTime()},limit:Infinity,lg:lgObj.lg,section:lgObj.section});	
					var lgObj = Self.createLg("Later");						
					aRanges.push({name:"Later", /*i18n*/
					    range:{start:tnextend.getTime(), end:null},limit:Self.limit_count,lg:lgObj.lg,section:lgObj.section});
					break;				
			case "mail": 
					var lgObj = Self.createLg("Inbox");				
					aRanges = [{name:"Inbox",range:{folder:"INBOX"},limit:Self.limit_count,lg:lgObj.lg,section:lgObj.section}];			
					break;			
			case "infostore": 
					var lgObjMy = Self.createLg("My Infostore");						
					var lgObjAll = Self.createLg("All folders");							
					aRanges = [{name:"My Infostore", /*i18n*/
					    range:{folder:configGetKey("folder.infostore")},limit:Self.limit_count,lg:lgObjMy.lg,section:lgObjMy.section},
													{name:"All folders", /*i18n*/
													    range:{},limit:Self.limit_count,lg:lgObjAll.lg,section:lgObjAll.section}];			
					break;			
		}
		return aRanges;		
	}
	
	function doNothing(arg)
	{
		return document.createTextNode(arg || "");
	}
	
	function setUser(arg,DOMtd)
	{
		var aIds = new Array();
		var TT = DOMtd;
		aIds.push(arg);
		function fillTds(result){
			TT.innerHTML = result[arg].display_name;
		}
		internalCache.getUsers(aIds,fillTds);	
		/*
		UserArray[UserArray.length] = {uid:arg,div:DOMtd};
		
		if(UserArray.length > 4)
		{
			loadUser();
		}
		*/
		return document.createTextNode('');
	}
	
	function loadUser()			
	{
		/*
		var aIds = new Array();aIds.push(UserArray[i].uid);
		for(var i=0;i<UserArray.length;i++)		
		{
			aIds.push(UserArray[i].uid);
		}
		
		function fillTds(arg)
		{
			for(var nEntr2=0;nEntr2<UserArray.length;nEntr2++)		
			{

				for(var userID in arg)
				{
					if(userID == UserArray[nEntr2].uid)
					{		
						UserArray[nEntr2].div.firstChild.data = arg[userID].display_name;
												
					}
				}
			}	
		}		*/
//		internalCache.getUsers(aIds,fillTds);	
	}
	
	
	
	function setDate(arg)
	{		
		var dateString = "";
		if (null != arg) dateString = formatDate(arg, "date");
		return document.createTextNode(dateString);
	}
	function setDateTime(arg)
	{
		var dateString = "";
		if (null != arg) dateString = formatDate(arg, "date")  + " " + formatDate(arg, "time");
		return document.createTextNode(dateString);
	}
	
	function setTime(arg)
	{
		var timeString = '';
		if (null != arg) timeString = formatDate(arg, "time");
		return document.createTextNode(timeString);
	}
	
	function setPriority(arg,td)
	{
		var DOMImg;
		if (arg == 3) 
		{
			DOMImg = newnode('img',0,{ src: getFullImgSrc("img/tasks/taskprio3.gif") });
		}
		else if (arg == 1) 
			DOMImg = newnode('img',0,{ src: getFullImgSrc("img/tasks/taskprio1.gif") });
		else 
			DOMImg = newnode('img',0,{ src: getFullImgSrc("img/tasks/taskprio2.gif") });
		return DOMImg;
	}
	function setMailAdress(arg)
	{
		return document.createTextNode(arg ? getAdressString(arg,true) : "");
	}
	function getArrayWidth(sModuleParam)
	{
		var aWidth = new Array();
		switch (sModuleParam){
			case "calendar": aWidth = {201:"7em",401:"6em",200:""};break;
			case "tasks": aWidth ={200:"",202:"7em",309:"5em"};break;
			case "mail": aWidth = {603:"",607:"",610:"12em"};break;			
			case "infostore": aWidth = {700:"",3:"",5:"8em"};break;			
			default: oFunctions = new Object();
		}
		return aWidth;
	}
	function getStyle(sModuleParam)
	{
		var aWidth = new Array();
		switch (sModuleParam){
			case "calendar": aWidth = {201:{color:"gray"},401:{color:"gray"},200:{}};break;
			case "tasks": aWidth ={200:{},201:{},202:{color:"gray"},309:{}};break;
			case "mail": aWidth = {603:{},607:{color:"gray"},610:{color:"gray"}};break;			
			case "infostore": aWidth = {700:{},3:{color:"gray"},5:{color:"gray"}};break;			
			default: oFunctions = new Object();
		}
		return aWidth;
	}
	function initColFunctions(sModuleParam)
	{	
		var oFunctions;
		switch (sModuleParam){
			case "calendar": oFunctions = {201:setDate,401:setTime,200:doNothing};break;
			case "tasks": oFunctions = {201:setDate,200:doNothing,202:setDate,309:setPriority};break;			
			case "mail": oFunctions = {603:setMailAdress,607:doNothing,610:setDateTime};break;	
			case "infostore": oFunctions ={700:doNothing,3:setUser,5:setDate};break;
			default: oFunctions = new Object();
		}
		return oFunctions;
	}
	function initColHeads(sModuleParam)
	{
		var oHeads;
		switch (sModuleParam){
			case "calendar": oHeads = {201:"Start date" /*i18n*/
										,401:"Start time", /*i18n*/
										200:"Description" /*i18n*/
										};break;
			case "tasks": oHeads = {201:"Start date", /*i18n*/
									200:"Subject", /*i18n*/
									202:"End date", /*i18n*/
									309:"Priority" /*i18n*/
									};break;			
			case "mail": oHeads = {603:"From", /*i18n*/
									607:"Subject", /*i18n*/
									610:"Received" /*i18n*/
									};break;	
			case "infostore": oHeads ={700:"Title", /* no i18n, see Evil hack below */
										3:"Changed by", /*i18n*/
										5:"Changed on" /*i18n*/
										};break;
			default: oHeads = new Object();
		}
		return oHeads;
	}
	
	function initSortParam(sModuleParam)
	{
		var nSortColumn;
		switch (sModuleParam){
			case "calendar": nSortColumn = '201';break;
			case "tasks": nSortColumn = '202';break;			
			case "mail": nSortColumn = "610";break;	
			//4 = creation date
			case "infostore": nSortColumn = "5";break;
			default: nSortColumn = "";
		}
		return nSortColumn;
	}	
	function initOrderParam(sModuleParam)
	{
		var sSortOrder = '';
		if((sModuleParam == 'calendar') || (sModuleParam == 'tasks'))
		{
			sSortOrder = 'asc';
		}
		else if(sModuleParam == 'infostore' || (sModuleParam == 'mail'))
		{
			sSortOrder = 'desc';		
		}
		return sSortOrder;
	}
	function initColumns(sModuleParam)
	{
		var sColumns;
		switch (sModuleParam){
			case "calendar": sColumns = "1,20,201,401,200,207";break;
			case "tasks": sColumns = "1,20,202,309,200,301";break;			
			case "mail": sColumns = "600,601,603,607,610";break;
			case "infostore": sColumns = "1,20,700,3,5";break;
			default: sColumns = "";
		}
		return sColumns;
	}	
}

portalItem.prototype = {
	setColumns: function(sColumns) 
	{
		this.columns = sColumns;
	},
	setError: function (oRespData)
	{		
		this.error = oRespData;
	},
	setData: function (oData,index,nTimestemp)
	{
		this.data = oData;
		this.timestamp = nTimestemp;
		this.ranges[index]["data"] = oData;
		this.ranges[index]["timestamp"] = nTimestemp;				
	},
	update: function ()
	{
		if(this.error)
		{			
			newServerError(this.error);		
			return;
		}		
		var bContentPresent = false;
		for(var dataIndx in this.ranges)			
		{
			if(this.ranges[dataIndx].data.length > 0)
				bContentPresent = true;							
			if(this.ranges[dataIndx]["lg"] == undefined)
				this.createLg(this.ranges[dataIndx]);	
			else			
				this.update_grid(this.ranges[dataIndx]);	
		}
		if(this.portletEmptyMSG)
			this.portletEmptyMSG.style.display = (!bContentPresent)?"block":"none";
	},
	disable : function (){
		for(var dataIndx in this.ranges)
		{
			if(this.ranges[dataIndx]["lg"])
				this.ranges[dataIndx]["lg"].disable();
		}
	},
	getHTML: function ()
	{	
		this.portletEmptyMSG = 	newnode("div",
									{display: "none", position: "absolute", textAlign: "center", 
									 width: "100%", marginTop: "5px"}, {className:"font-color-disabled"},
									[addTranslated("No Items available")]); /*i18n*/	
		addDOMEvent(this.portletEmptyMSG, "selectstart", function (e){stopEvent(e);return false;});
		addDOMEvent(this.portletEmptyMSG, "drag", function (e){stopEvent(e);return false;});							
		this.container.appendChild(this.portletEmptyMSG);
		var newportalHeader = newnode('div',{paddingLeft:"4px",textAlign:"left",height:"1.6em",width:"100%",overflow:"hidden",whiteSpace:"nowrap"}
		,{className:"portal-header-box-background font-style-headline background-color-additional-content"});		
		newportalHeader.appendChild(newnode('img',{position:"absolute"},{ src: getFullImgSrc("img/"+this.module+"/mod_"+this.module+".gif") }));
		newportalHeader.appendChild(newnode('div',{paddingLeft:"30px"},0,[addTranslated(getNameModule(this.module))]));
		
										
		this.header.appendChild(newportalHeader);		
	},
	getRequests : function (){
		//reset old data
		this.data = new Array();	
		var aAllRequests = new Array();
		for(var nRange=0;nRange<this.ranges.length;nRange++)
		{
			//create request objects
			var oRequestObj = new Object();
			var oRequestBody = new Object();		
			oRequestBody['pattern'] = '';
			oRequestObj['module'] = this.module;
			if(this.module == 'mail')	
			{
				oRequestObj['action'] = 'newmsgs';
				oRequestObj['folder'] = configGetKey('mail.folder.inbox');
			}
			else if(this.module == 'calendar')	
			{
				oRequestObj['action'] = 'newappointments';
			}
			else
				oRequestObj['action'] = 'search';		
			oRequestObj['columns'] = this.columns;		
			oRequestObj['sort'] = this.sort;		
			oRequestObj['order'] = this.order;

			//limit required
			oRequestObj['limit'] = (this.ranges[nRange].limit == Infinity)?9999:this.ranges[nRange].limit;
			if(this.module == 'calendar' || this.module == 'tasks')
			{
				var oDate = new Date();			
				oDate.setUTCHours(0);
				oDate.setUTCMinutes(0);			
				oDate.setUTCSeconds(0);						
				oRequestObj['start'] = oDate.getTime();
				oDate.setUTCFullYear(oDate.getUTCFullYear()+1);
				oDate.setUTCDate(oDate.getUTCDate()+1);			
				oRequestObj['end'] = oDate.getTime();
			}
			for(var nProp in this.ranges[nRange].range){				
				oRequestObj[nProp] = this.ranges[nRange].range[nProp];
			}
			oRequestObj['data'] = oRequestBody;		
			aAllRequests.push(oRequestObj);
		}
		return aAllRequests;
	},
	getLgColDef: function (nColumnNum,index){
		var fn = this.column_functions[nColumnNum];
		var resObj = new Object();
		if(nColumnNum == 401)
			resObj =  {
				text: this.column_heads[nColumnNum],
				i18n: this.column_heads[nColumnNum] != "Title" || "description", // Evil hack				
				width: this.col_width[nColumnNum],
				style: this.style[nColumnNum],				
				set: function  (div, text){
					removeChildNodes(div);
					div.appendChild((text[3])?document.createTextNode(""):fn(text[2],div));	
				},
				clear: LiveGrid.makeClear("")
			};
		else if(nColumnNum == 200 && this.module == "tasks")
			resObj =  {		
				text: this.column_heads[nColumnNum],
				i18n: true,
				width: this.col_width[nColumnNum],				
				style: this.style[nColumnNum],				
				set: function  (div, content){
					if (!div.firstChild) {
						div.appendChild(document.createTextNode("\u00a0"));
					}
					if (content[4]) {
						div.firstChild.data = content[4];
						if (content[5] && content[5] == 100) {
							div.className = "cell font-color-disabled";
							div.style.textDecoration = "line-through";							
						} else if (content[2] && getDays(new Date()-new Date(content[2])) > 0) {
							div.style.textDecoration = "line-through";
							div.style.color = "red";
						} else {
							div.className = "cell";
							div.style.textDecoration = "none";
						}
					} else {
						div.firstChild.data = "\u00a0";
					}
				},
				clear: LiveGrid.makeClear("")				
			};
		else
			resObj =  {
				index: index,	
				text: this.column_heads[nColumnNum],
				i18n: true,		
				style: this.style[nColumnNum],		
				width: this.col_width[nColumnNum],
				set: function  (div, text){
					removeChildNodes(div);
					div.appendChild(fn(text,div));	
				},
				clear: LiveGrid.makeClear("")
			};
		if(resObj["width"] == '')
		{
			delete resObj["width"];
		}
		return resObj;
	},
	createLg: function (sHeadName)
	{
		var oDOMHead;
		var oDOMBody;	
		var oTableNewSection = newnode("table",{width:"100%"},{ cellpadding:"0",cellspacing:"0"},
								[newnode("tbody",0,0
											,[newnode('tr',0,0,[oDOMHead = newnode('td')]),
														newnode('tr',0,0,[oDOMBody = newnode('td')])])]);
		//create live grid definition array
		var aColumnNums = this.columns.split(',');
		var aColDefs = new Array();
		for(var nColumn=0;nColumn<aColumnNums.length;nColumn++)
		{
			if(aColumnNums[nColumn].length>0 && nColumn>1 && 
							(this.column_heads[aColumnNums[nColumn]] != undefined))			
				aColDefs.push(this.getLgColDef(aColumnNums[nColumn],nColumn));
		}
		var selection =new Selection();
		var sectionLG = new LiveGrid(aColDefs,selection);
		sectionLG.mousedown_cb = function(e) { if(e.button == LeftButton) sectionLG.mousedown(e); };
		sectionLG.selected_cb = function(count) {
				sectionLG.events.trigger("Selected", count);
		};
		//no style update to disable visible selection
		sectionLG.updateStyles = function () {};
		sectionLG.insertRow = function(index) {
			var row = this.rows[index] =
				this.rowcache.length ? this.rowcache.pop() : this.createRow();
			row.tr.className = "tr";
			row.tr.style.display = "";		
			row.tr.style.top = (index * this.rowHeight) + "px";
			row.tr.oxRowIndex = index;
			this.unfetched[index] = true;
		};
		var Self = this;
		sectionLG.events.register("Selected",function (ids)
			{		
					
				if(sectionLG.selection.getSelected()[0])
				{
					var s_str = sectionLG.selection.getSelected()[0];
					var oIdObj = new Object();
					oIdObj['id'] = s_str.split('_')[0];	
					//TMP MUST BE REMOVED WHEN OBJECTCACHE IS USED
					if(Self.module) {
						oIdObj["module"]=Self.module;
					}
					oIdObj['folder'] = s_str.split('_')[1];
					//END OF TMP
					oIdObj['folder_id'] = s_str.split('_')[1];
					oIdObj['recurrence_position'] = s_str.split('_')[2];		
					triggerEvent('OX_Portal_Click_Item',Self.module,oIdObj);
				}
			});
		
		sectionLG.emptylivegridtext=getEmptyText(this.module);	
		if(!this.newportal)
			this.header.appendChild(sectionLG.getHeader());
		else
		{
			sectionLG.getHeader();					
			var newportalHeader = newnode('div',{borderBottom:"1px solid",paddingLeft:"2px",textAlign:"left",
							height:"1.6em",width:"100%",overflow:"hidden",whiteSpace:"nowrap"},{className:"font-style-lable background-color-content border-color-design"});
			newportalHeader.appendChild(addTranslated(sHeadName));
			oDOMHead.appendChild(newportalHeader);				
		}		
		this.container.appendChild(oTableNewSection);
		sectionLG.getTable(oDOMBody);
		sectionLG.emptyMessage.style.position = "relative";
		sectionLG.emptyMessage.style.textAlign = "left";
		sectionLG.emptyMessage.style.paddingLeft = "8px";
		sectionLG.emptyMessage.style.color = "silver";
		sectionLG.heightDiv.style.cursor = "pointer";
		sectionTB = oTableNewSection;
		if(this.module == "calendar") {
			var hv = sectionLG.addHover(OXAppointmentHover.getContent().node, function(id) {
				OXAppointmentHover.actualHover=hv;
				sectionLG.storage.newIterate([id], emptyFunction, set);
				function set(i, data) {	
					OXAppointmentHover.refillContent(id.split('_')[0],id.split('_')[1],id.split('_')[2]);					
				}
			});
			hv.setSize(OXAppointmentHover.contentobject.node);
		} else if(this.module == "tasks") {
			var hv = sectionLG.addHover(OXTaskHover.getContent().node, 
			function(id) {
				OXTaskHover.accordion.setHover(hv);
				var sFolder = id.split('_')[1];
				var sId = id.split('_')[0];	
				sectionLG.storage.newIterate([id], emptyFunction, set);
				function set(i, data) {	
					OXTaskHover.refillContent(id.split('_')[0],id.split('_')[1]);					
				}
			});
			hv.setSize(OXTaskHover.contentobject.node);
		} else if(this.module == "infostore") {
			var hv = sectionLG.addHover(OXInfostoreHover.getContent().node, 
			function(id) {
				OXInfostoreHover.accordion.setHover(hv);
				var sFolder = id.split('_')[1];
				var sId = id.split('_')[0];	
				sectionLG.storage.newIterate([id], emptyFunction, set);
				function set(i, data) {	
					OXInfostoreHover.refillContent(id.split('_')[0],id.split('_')[1]);					
				}
			});
			hv.setSize(OXInfostoreHover.contentobject.node);
		} else if(this.module == "mail") {
			var hv = sectionLG.addHover(OXMailHover.getContent().node, 
			function(id) {
				OXMailHover.accordion.setHover(hv);
				var sFolder = id.split('_')[1];
				var sId = id.split('_')[0];	
				sectionLG.storage.newIterate([id], emptyFunction, set);
				function set(i, data) {
					OXMailHover.refillContent(id.split('_')[0],id.split('_')[1]);					
				}
			});
			hv.setSize(OXMailHover.contentobject.node);
		}
 		return {lg:sectionLG,section:sectionTB};
	},
	update_grid: function (aData){
		if(this.module == "calendar")
			var storage = new Storage(0, [],null,null,null,null,function (x){
                    return x[0] + "_" + x[1] + "_" + (x[5] || 0);
				});							
		else
			var storage = new Storage(0, [],null,null,null,null,function (x){
							return x[0]+'_'+x[1];
				});			
		storage.append(aData.data);	
		//aData['lg'].parent.style.height = aData.data.length * 1.6 + "em";
		//aData['lg'].showFocus = function (){};
		if(aData.data.length == 0)
			aData['section'].style.display = "none";
		else
			aData['section'].style.display = "";
		aData['lg'].disablehover=!configGetKey("gui.effects.hover.portal");	
		aData['lg'].enable(storage);	
	}

};
function getEmptyText(sModule)
{
	var sModuleName;
	switch (sModule){
		case 'calendar' : sModuleName = "No appointments today"; /*i18n*/ break;
		case 'mail' : sModuleName = "No new E-Mails in this folder"; /*i18n*/ break;
		case 'tasks' : sModuleName = "No tasks today"; /*i18n*/ break;
		case 'infostore' : sModuleName = "No Info Items in this folder"; /*i18n*/ break;
		default: sModuleName = "";		
	}
	return sModuleName;
}
function getNameModule(sModule)
{
	var sModuleName;
	switch (sModule){
		case 'calendar' : sModuleName = "Calendar"; /*i18n*/ break;
		case 'mail' : sModuleName = "E-Mail"; /*i18n*/ break;
		case 'tasks' : sModuleName = "Tasks"; /*i18n*/ break;
		case 'infostore' : sModuleName = "InfoStore"; /*i18n*/ break;
		default: sModuleName = "&#xa0;";		
	}
	return sModuleName;
}
fileloaded();
